$TITLE GTAP data version 5.3 to Global SAM
$OFFUPPER
*$OFFLISTING OFFSYMXREF OFFSYMLIST
$ONEMPTY

*############## GENERAL INFORMATION #############################
$ontext

This programme was developed by Scott McDonald (University of Sheffield)
and Karen Thierfelder (US Naval Academy).

 Scott McDonald                           Karen Thiefelder
 Dept of Economics                        Dept of Economics
 The University of Sheffield              US Naval Academy
 9 Mappin Street                          Annapolis
 Sheffield, S1 4DT, UK                    Maryland, USA
 email:                                   email:
    s.mcdonald@sheffield.ac.uk               thier@usna.edu

Invaluable helpful advice about the GTAP model and GEMPACK was received
from Terrie Walmsley. Helpful comments were provided by referees and
Vitaly Kharitonov, who identified an error in the code .

This version works with GTAP 5.3.

This version last checked 22nd Nov 2004

Scott McDonald and Karen Thierfelder, "Deriving a Global Social Accounting
Matrix from GTAP version 5 Data", Sheffield Economic Research Paper 2004:002.
Dept of Economics University of Sheffield. www.shef.ac.uk/economics/serp

Copyright (c) 2004 Scott McDonald and Karen Thierfelder.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

A copy of the GNU GPL, gpl.txt, is included with the programme files.

Do NOT remove this notice if you redistribute this programme

If you use this programme you should acknowledge the source and not claim
authorship. Altered versions should be clearly distinguished from the original.

$offtext
*############## USER GUIDE ######################################
$ontext

SOFTWARE REQUIREMENTS

  1) This programme is known to work with versions of GAMS 250 after and
     including distribution 21.3. It is believed to work with all versions
     of GAMS 250 that include the GDXXRW utilities, i.e, since
     distribution 21.0 in May 2003.

  2) Users need to get copies of the GDX2HAR and HAR2GDX utilities developed
     by Horridge and Rutherford (revised Nov 2003).
            http://debreu.colorado.edu/gdxhar
                   OR
            http://www.monash.edu.au/policy/ftp/gpextra/gdxhar.zip
       There are three files that need to be copied to the GAMS directory
            gdx2har.exe
            har2gdx.exe
            gdxiomh.dll

  3) It is also useful to have a copy of GDXVIEWER - this is one of the
     WTOOLS utilities developed by Erwin Kalvelagen. (GDXVIEWER allows the
     resultant Global SAM to be viewed on screen in a simple user friendly
     environment). The WTOOLS utilities can be downloaded from
            http://www.gams.com/~erwin/interface/interface.html#1.31_WTOOLS

DATA REQUIREMENTS

  1) No GTAP data are provided. The user must have a licensed version
     of the GTAP database complete with the GTAPAgg programme.

  2) All the sets and set mapping required to use the GAMS programmes for
     specific versions of the GTAP database are provided from
     a single Excel workbook.
         GTAP version 5.3               - data_gtp_53.xls
         GTAP version 5.4               - data_gtp_54.xls
         GTAP version 6.0 pre release 5 - data_gtp_60_p5.xls

     An additional Excel workbook is also supplied that provides a simple
     semi-automated method for producing new set and mapping configurations.

     Step 11 in the User Instructions below provides brief guidance for
     working with other - older or more recent - versions of the GTAP
     database.

USER INSTRUCTIONS
   (These instructions assume the user is working in a Windows 2000/XP
    environment using GAMSIDE and Microsoft Excel 2000/WP.)

  1) The programme files are made available in a WinZip archive - gtapsam.zip.

  2) The programme files are organised so that they can be used as a
     GAMS User Model Library (see the GAMS documentation for information
     on using User Model Libraries). These instruction assume that files
     in gtapsim.zip have been extracted to a directory - gsamlib.

  3) Create a directory for the programme. The path to this directory
     should follow standard/old DOS conventions - no directory with more
     than an 8 character name and no spaces in the names in the path.

     Create a project file (*.gpr) in this directory.

  4) To copy the programme files to the project directory.
     In GAMSIDE with the project file controlling paths do the following
     a) Locate the User Model Library
          File>Model Library>Open User Model Library and then select the
          file gtablib.glb in the directory gsamlib
     b) Double click on the NAME of the version of the programme that
        corresponds to the version of the GTAP database with which you are
        working. ALL the files needed to run the programme other than the
        GTAP database file will be copied to the directory containing the
        project file.
        NB: A brief description of the programme is provided in the window
            at the bottom of the User Mode Library window.

  5) Read and study the GAMS programme.

  6) Create the database for the programme
     a) Use GTAPAgg to create an aggregation with 1:1 mappings for
        sectors, regions and factors.
     b) Extract the file Basedata.har from the WinZip archive created by
        GTAPAgg and copy to the project directory.

  7) Check that programme compiles by using SHIFT+F9.
        If the steps above have been followed there should be no problems.
        a) Some users can have problems with the GDXXRW facility
           that generates the file data_in.gdx from the Excel file. These
           problems mostly seem to originate with a corruption of the
           'LAYOUT' worksheet and result in an error message saying the
           file data_in.gdx does not exist. To overcome this type of problem
              i)  check that gdxxrw.exe exists in the GAMS directory
              ii) copy the contents of the worksheet 'LAYOUT2' and replace
                  the worksheet 'LAYOUT' using Paste Special
        b) If an error message saying that the file database.gdx does not
           exist arises check that the files har2gdx.exe, gdx2har.exe and
           gdxiomh.dll exist in the GAM directory.

  8) Run the programme. The output to the working directory should be as
     follows:
     a) A series of GDX files for checking the intermediate stages
          gtptots1.gdx
          gtptots2.gdx
          gtptots3.gdx
          gtptots4.gdx
          gtptots5.gdx
          gtpmxmin.gdx
     b) A Global SAM in GDX format
          gtpsam60_p5.gdx
     c) A Global SAM in HAR format
          gsam60p5.har

     NB: For version 6 of the GTAP database the directory will be in the
         order of 500MB with the Global SAM in HAR format accounting for
         some 230MB.

  9) Exports fob and Imports fob calculated directly do not always equate -
     indirect and direct methods of calculating imports are included
     search for TRADECAL to control the choice of method. All the checks
     labelled TRADECHK should equal ZERO.

  10)GAMS code for aggregating the Global SAM programme is provided
     in the User Model Library.

  11)These notes relate to situations where a user wishes to work with
     another version of the GTAP database. It is assumed this will be a later
     version.
     A new workbook - data_gtp_**.xls - will need to be compiled.
     a) Using the file gtp_sets_v60.xls as a template
        i)   Get the 'new' sector, region, factor and margin codes and
             descriptions from the GTAP database and copy them into the
             worksheet 'Set data from GTAPAgg'
        ii)  Check that the worksheets
             'Set creation regions/sectors/factor/margins' have all updated
             correctly - NB the number of entries in each group of
             codes is the critical point.
        iii) Compile the new sets in the worksheet 'Compiling Sets'
     b) Using the file data_gtp_60.xls as a template
        i)   Generate a revise worksheet 'Sets' - using copy and paste
             SPECIAL from the new file gtp_sets_V**.xls.
        ii)  Generate a revise worksheet 'Maps' - using copy and paste
             from the new worksheet 'Sets'.
        iii) The worksheet 'Layout' should NOT need to be changed unless
             new sets or maps are created.
     c) Update the programme file to read the new sets and maps.

     d) Some general suggestions
        i)   Spaces in the cells of the file data_gtp_**.xls are a
             problem - to GAMS spaces are characters.
        ii)  If the orderings in the mapping sets are not consistent the
             mappings implemented will be wrong.
        iii) 'Corruption' of the worksheet 'Layout' will cause the sets
             maps not to be read in.
        iv)  The codes used for account names in the GTAP database may
             have changed.
        v)   'Big' initial 'errors' (say entries in the first DIFFTOT that
             are greater than 1) are likely to be due to an error in the
             sets and maps files.
        vi)  'Small' initial 'errors' (say less that 0.01) are more likely
             to rounding issues due to the degree of precision in the
             GTAP database.
        vii) When adjusting the programme to remove 'errors' due to
             the degree precision in the database, it is best by far to
             work through the accounts as they appear in the SAM, i.e.,
             start with the import commodity accounts, then domestic
             commodities, etc.

$offtext
*############## PROGRAMME DESCRIPTION ##################################
$ontext
This programme sorts GTAP data into a global SAM structure.
 This version
        output is in the form of both a GDX file and a HAR file

        does not adjust for the law of one price
        has the GTAP price system
        has GTAP style Regional and Private Households
        runs with the full GTAP 5.3 database

$offtext
*############## 1. OUTLINE OF PROGRAMME ################################
$ontext
     PROGRAMME DESCRIPTION

  1. OUTLINE OF PROGRAMME

  2. DATA CONVERSION

  3. CONVENTIONS

  4. READ IN DATA and GTAP Sets

  5. OTHER SET DECLARATION

  6. PARAMETER DECLARATION
          GTAP parameters coefficients read by GTAP.TAB v 6.2
                  Savings
                  Government consumption
                  Private consumption
                  Firms expenditures
                  Global Bank
                  International Trade
          GTAP parameters coefficients NOT read by GTAP.TAB v 6.2
          New Parameters for Intermediate & Investment Demand
                  Intermdiate Inputs by Activity
                  Investment Demand
          Other New Parameters
                  Values of Components of Domestic production
                  Factor use by activities
                  Depeciation by factor
          New Parameters for Taxes
          New Parameters for Margins
          Parameters for GAMS database version

  7. RELABELLING THE GTAP DATA
          Display Statements for Relabelled Data

  8. CREATING THE GLOBAL SAM
          Computing Account totals for Global SAM by Region

  9. CHECKING THE GLOBAL SAM

  10. BALANCING THE GLOBAL SAM

  11. CHECKING THE BALANCED GLOBAL SAM

  12. A SAMPLE REGION SAM

  13. WRITING THE GLOBAL SAM TO GDX


$offtext
*############## 2. DATA CONVERSION #####################################
$ontext

DATA

INPUT
Header Array (HAR) Data are rendered readable by GAMS using HAR2GDX.
All sets and mapping sets for the GAMS rountine are entered from Excel
using GDXXRW.

OUTPUT
GDX data are rendered readable by GEMPACK programmes using GDX2HAR

$offtext
*############## 3. CONVENTIONS #########################################
$ontext

Naming conventions

     - the Excel workbook that contains all the sets - data_gtp_**.inc
       (where ** is the number of GTAP database version)
     - the output from GTAPAgg - basedata.har
     - the results from 'checks' on row and column totals are output to
       GDX - gtptots*.gdx (where * is 1 to 5)
     - maximum and minimum transaction values by region gtpmxmin.gdx
     - the global SAM in GDX format - gtpsam**.gdx
       (where ** is the number of GTAP database version)
     - the global SAM in HAR format - gsam**.har
       (where ** is the number of GTAP database version)

PARAMETERS
The output from HAR2GDX produces a GDX file that includes all the GTAP data.

This is used directly to create a global SAM; the global SAM does not
require all the data in the GTAP database.

SETS
The sets used involve adding preffices to the account names to distinguish
between different sections of the SAM. the suffices are
     COMM          commodity accounts
     REG           region accounts
     FACT          factor accounts

Imported Commodities       -----> mmCOMM
Domestic Commodities       -----> ddCOMM
Activities                 -----> aaCOMM
Factors                    -----> ffFACT
Regional Household         -----> n/a
Private Household          -----> n/a
Import duties              -----> tmmREG
Export Taxes               -----> teeREG
Import Sales Taxes         -----> tssmCOMM
Domestic Sales Taxes       -----> tssdCOMM
Factor Taxes               -----> tffFACT
Capital                    -----> n/a
ROW Transport Margins      -----> otppCOMM
                                  wtppCOMM
                                  atppCOMM
ROW Goods & Services       -----> wwREG

$offtext
*############## 4. DECLARING SETS AND PARAMETERS FOR THIS PROGRAMME #######

*######## Listing of Sets ##########
$ontext

WITHIN REGION SETS
         SS                SAM accounts

Commodity sets
         MCC(SS)           Imported Commodities
         DCC(SS)           Domestic Commodities

Activity sets
         AA(SS)            Activities
         A2                Production commodities Activities in GTAP

Factor sets
         FF (SS)           Factors

Tax sets
         TMMTAX(SS)        Import duties
         TEETAX(SS)        Export taxes
         SMMTAX(SS)        Sales Taxes on imported goods and services
         SDDTAX(SS)        Sales Taxes on domestic goods and services
         FFTAX(SS)         Taxes on Factors

Investment set
         II(SS)            Investment

Trade sets
         OTPPMARG(SS)      Other trade and transport costs
         WTPPMARG(SS)      Water trade and transport costs
         ATPPMARG(SS)      Air trade and transport costs

         VSTTMARG(SS)      Exports of trade and transport services

         WW(SS)            Rest of the World

REGION SET
         KK                Regions


$offtext

SETS

* These sets come from the basic GTAP database

 GlobalSet(*)              Set provided by GDX2HAR to order symbol table
 TRAD_COMM(*)              traded commodities
* REG(*)                    regions in the model
 KK(*)                     regions in the model
 ENDW_COMM(*)              endowment commodities
 PROD_COMM(*)              produced commodities
 DIR(*)                    direction of trade flows
 MARG_COMM(*)              margin commodities

* Use of global set (SS) and then subsets (MC,DC,A,F,TMTAX,TETAX,SUBTAX,MMARG,W)

 SS                        SAM accounts
 MCC(SS)                   Imported Commodities
 DCC(SS)                   Domestic Commodities
 AA(SS)                    Activities
 FF(SS)                    Factors
 TMMTAX(SS)                Import duties
 TEETAX(SS)                Export taxes
 SMMTAX(SS)                Sales Taxes on imported goods and services
 SDDTAX(SS)                Sales Taxes on domestic goods and services
 FFTAX(SS)                 Taxes on Factors
 OTPPMARG(SS)              Other trade and transport costs
 WTPPMARG(SS)              Water trade and transport costs
 ATPPMARG(SS)              Air trade and transport costs
 VSTTMARG(SS)              Exports of trade and transport services
 WW(SS)                    Rest of the World
 II(SS)                    Investment
 KK                        Regions
 A2                        Production commodities Activities

* Mapping sets for this version

 MAPIMP(mcc,TRAD_COMM)     Import mapping
 MAPDOM(DCC,TRAD_COMM)     Domestic good mapping
 MAPVST(DCC,MARG_COMM)     Transport services mapping
 MAPPROD(a2,PROD_COMM)     Production mapping
 MAPACT(aa,PROD_COMM)      Activty mapping
 MAPINV(ii,PROD_COMM)      Investment mapping
 MAPTRAD(ww,kk)            Tradeaccount mapping
 MAPTMTAX(tmmtax,kk)       Export Duty tax mapping
 MAPTETAX(teetax,kk)       Export Duty tax mapping
 MAPOTPMARG(otppmarg,kk)   Other Transport margin mapping
 MAPWTPMARG(wtppmarg,kk)   Water Transport margin mapping
 MAPATPMARG(atppmarg,kk)   Air Transport margin mapping
 MAPSDTAX(sddtax,dcc)      Mapping domestic commodities to domestic sales taxes
 MAPSMTAX(smmtax,mcc)      Mapping imported commodities to imported sales taxes
 MAPFACT(ff,ENDW_COMM)     Mapping factors to factor use taxes
 MAPFTAX(fftax,ENDW_COMM)  Mapping factors to factor use taxes
 MAPDCC_AA(dcc,aa)         Mappingdcc from aa

* Mapping sets to Check Trade Transactions

 RR                        Regions
 MAPREG(rr,kk)             Region mapping to rr from kk
 MAPREG2(rr,ww)            Region mapping to rr from ww
 MAPREG3(ww,kk)            Region mapping to ww from kk
 MAPREG4(kk,ww)            Region mapping to ww from kk
 MAPREG5(ww,rr)            Region mapping to ww from kk
 MAPCOM(mcc,dcc)           Region mapping to mcc from dcc

*Other Sets

 SSN(SS)       SAM accounts excluding TOTAL

            ;

Parameter
* Parameters from HAR file

 ADRV(TRAD_COMM,KK,KK)            Protection Anti-Dumping Duty
 DPSM(KK)                         Sum Distn Parameters in Hhold Demand System
 VERNUM                           Format of GTAP data
 EVFA(ENDW_COMM,PROD_COMM,KK)     Endowments Firms Purchases at Agents Prices
 EVOA(ENDW_COMM,KK)               Endowments Output at Agents Prices
 FBEP(ENDW_COMM,PROD_COMM,KK)     Protection Factor-Based Subsidies
 ISEP(TRAD_COMM,PROD_COMM,KK,DIR) Protection Intermediate Input Subsidies
 MFRV(TRAD_COMM,KK,KK)            Protection MFA Export Subsidy Equivalent
 OSEP(TRAD_COMM,KK)               Protection Ordinary Output Subsidies
 PURV(TRAD_COMM,KK,KK)            Protn Price Undertaking Export Subsidy Equiv
 SAVE(KK)                         Savings Net Expenditure at Agents Prices
 TFRV(TRAD_COMM,KK,KK)            Protection Ordinary Import Duty
 VDEP(KK)                         Capital Stock Value of Depreciation
 VDFA(TRAD_COMM,PROD_COMM,KK)     Intermed Firms Dom Purchases at Agent Prices
 VDFM(TRAD_COMM,PROD_COMM,KK)     Intermed Firms Dom Purchases at Mkt Prices
 VDGA(TRAD_COMM,KK)               Government Dom Purchases at Agents Prices
 VDGM(TRAD_COMM,KK)               Government Dom Purchases at Market Prices
 VDPA(TRAD_COMM,KK)               Private Hhold Dom Purchases at Agents Prices
 VDPM(TRAD_COMM,KK)               Private Hhold Dom Purchases at Market Prices
 VFM(ENDW_COMM,PROD_COMM,KK)      Endowments Firms Purchases at Market Prices
 VIFA(TRAD_COMM,PROD_COMM,KK)     Intermed Firms Imports at Agents Prices
 VIFM(TRAD_COMM,PROD_COMM,KK)     Intermed Firms Imports at Market Prices
 VIGA(TRAD_COMM,KK)               Government Imports at Agents Prices
 VIGM(TRAD_COMM,KK)               Government Imports at Market Prices
 VIMS(TRAD_COMM,KK,KK)            Trade Bilateral Imports at Market Prices
 VIPA(TRAD_COMM,KK)               Private Households Imports at Agents Prices
 VIPM(TRAD_COMM,KK)               Private Households Imports at Market Prices
 VIWS(TRAD_COMM,KK,KK)            Trade Bilateral Imports at World Prices
 VKB(KK)                          Capital Stock Value at Beginning-of-Period
 VRRV(TRAD_COMM,KK,KK)            Protection VER Export Subsidy Equivalent
 VST(MARG_COMM,KK)                Trade Exports Internatl Trans Mkt Prices
 VTWR(MARG_COMM,TRAD_COMM,KK,KK)  Trade Margins Internatl Trans World Prices
 VXMD(TRAD_COMM,KK,KK)            Trade Bilateral Exports at Market Prices
 VXWD(TRAD_COMM,KK,KK)            Trade Bilateral Exports at World Prices
 XTRV(TRAD_COMM,KK,KK)            Protection Ordinary Export Subsidy

* Trade Margins Related
 VST1(dcc,kk)         Exports for internatl transportation at mkt prices

* Depeciation by factor
 DEPREC(ff,kk)        Depreciation charges by factor

* Values of Components of Domestic production
 VDM(dcc,kk)          Domestic output dc sold domestically by region k

* Global SAM

 SAMG(ss,ss,kk)       Social accounting matrices for regions k

* Other parameters

 IDbase(aa,aa)        identity matrix for creation
 ID(aa,dcc)           identity matrix

   ;

*############## 5. READ IN GTAP DATA AND SETS ###########################

* Data are rendered readable by GAMS using HAR2GDX

* NB After the first time this programme is run the HAR2GDX CALL statement
*    can be turned off since basedata.gdx has been written to disk.

$CALL har2gdx   basedata.har    basedata.gdx

* Data are read in from a *.gdx file


$GDXIN basedata.gdx
* Sets from GTAP database
$LOAD GlobalSet
$LOAD TRAD_COMM
$LOAD KK = REG
$LOAD ENDW_COMM
$LOAD PROD_COMM
$LOAD DIR
$LOAD MARG_COMM

* Parameters from GTAP database
$LOAD ADRV
$LOAD DPSM
$LOAD EVFA EVOA
$LOAD FBEP ISEP MFRV OSEP PURV TFRV VRRV
$LOAD SAVE
$LOAD VDEP VDFA VDFM VDGA VDGM VDPA VDPM
$LOAD VFM
$LOAD VIFA VIFM VIGA VIGM VIPA VIPM VIMS VIWS
$LOAD VKB
$LOAD VST VTWR
$LOAD VXMD VXWD XTRV

$GDXIN

DISPLAY ADRV,  DPSM,  EVFA,  EVOA,  FBEP,  ISEP,  MFRV,  OSEP,  PURV,  SAVE,
        TFRV,  VDEP,  VDFA,  VDFM,  VDGA,  VDGM,  VDPA,  VDPM,  VFM,   VIFA,
        VIFM,  VIGA,  VIGM,  VIPA,  VIPM,  VIMS,  VIWS,  VKB,   VRRV,  VST,
        VTWR,  VXMD,  VXWD,  XTRV
   ;

option decimals = 6 ;

*############## 6. OTHER SET DECLARATION AND DATA ########################

* SETS are read in from a *.inc files

* These files are for GTAP Database v5.3

$CALL "GDXXRW i=data_gtp_53.XLS o=data_in.gdx INDEX=LAYOUT!A4"

$GDXIN data_in.gdx

$LOAD SS MCC DCC AA FF
$LOAD TMMTAX TEETAX SMMTAX SDDTAX FFTAX
$LOAD OTPPMARG WTPPMARG ATPPMARG VSTTMARG
$LOAD WW
$LOAD II
*$LOAD KK
$LOAD A2

$LOAD RR
$LOAD MAPIMP MAPDOM MAPVST MAPPROD MAPACT MAPINV MAPTRAD
$LOAD MAPTMTAX MAPTETAX
$LOAD MAPOTPMARG MAPWTPMARG MAPATPMARG
$LOAD MAPSDTAX MAPSMTAX MAPFACT MAPFTAX MAPDCC_AA

$LOAD MAPREG MAPREG2 MAPREG3 MAPREG4 MAPREG5 MAPCOM

$GDXIN

* Other Sets

* SAM Accounts excluding totals
 SSN(SS)       = YES ;
 SSN("TTOTAL")  = NO ;


* Setting up ALIASES

 ALIAS(SS,SSP) ;
 ALIAS(SSN,SSNP) ;
 ALIAS(MCC,MCCP) ;
 ALIAS(DCC,DCCP) ;
 ALIAS(AA,AAP) ;
 ALIAS(A2,AA2) ;
 ALIAS(FF,FFP,ENDOW_COMM) ;
 ALIAS(TMMTAX,TMMTAXP) ;
 ALIAS(TEETAX,TEETAXP) ;
 ALIAS(SMMTAX,SMMTAXP) ;
 ALIAS(SDDTAX,SDDTAXP) ;
 ALIAS(SDDTAX,SDDTAXP) ;
 ALIAS(FFTAX,FFTAXP) ;
 ALIAS(OTPPMARG,OTPPMARGP) ;
 ALIAS(WTPPMARG,WTPPMARGP) ;
 ALIAS(ATPPMARG,ATPPMARGP) ;
 ALIAS(VSTTMARG,VSTTMARGP) ;
 ALIAS(WW,WWP) ;
 ALIAS(KK,KKP,REGP) ;
 ALIAS(rr,rrp,rrpp) ;

* Other data

 IDbase(aa,aap)$DIAG(aa,aap)  = 1 ;

 ID(aa,dcc)          = SUM(aap
                        $MAPDCC_AA(dcc,aap),
                        IDbase(aa,aap)) ;

DISPLAY IDbase, ID ;

* ### ROUNDING READ IN DATA
* Rounding all read in data to 6 decimal places
* The GTAP database only records data to 6 decimal places

 SAVE(kk)                         = ROUND(SAVE(kk),6) ;
 VDGA(trad_comm,kk)               = ROUND(VDGA(trad_comm,kk),6) ;
 VDGM(trad_comm,kk)               = ROUND(VDGM(trad_comm,kk),6) ;
 VIGA(trad_comm,kk)               = ROUND(VIGA(trad_comm,kk),6) ;
 VIGM(trad_comm,kk)               = ROUND(VIGM(trad_comm,kk),6) ;
 VDPA(trad_comm,kk)               = ROUND(VDPA(trad_comm,kk),6) ;
 VDPM(trad_comm,kk)               = ROUND(VDPM(trad_comm,kk),6) ;
 VIPA(trad_comm,kk)               = ROUND(VIPA(trad_comm,kk),6) ;
 VIPM(trad_comm,kk)               = ROUND(VIPM(trad_comm,kk),6) ;
 VDFA(trad_comm,prod_comm,kk)     = ROUND(VDFA(trad_comm,prod_comm,kk),6) ;
 VDFM(trad_comm,prod_comm,kk)     = ROUND(VDFM(trad_comm,prod_comm,kk),6) ;
 VIFA(trad_comm,prod_comm,kk)     = ROUND(VIFA(trad_comm,prod_comm,kk),6) ;
 VIFM(trad_comm,prod_comm,kk)     = ROUND(VIFM(trad_comm,prod_comm,kk),6) ;
 VFM(endw_comm,prod_comm,kk)      = ROUND(VFM(endw_comm,prod_comm,kk),6) ;
 EVFA(endw_comm,prod_comm,kk)     = ROUND(EVFA(endw_comm,prod_comm,kk),6) ;
 EVOA(endw_comm,kk)               = ROUND(EVOA(endw_comm,kk),6) ;
 VDEP(kk)                         = ROUND(VDEP(kk),6) ;
 VXMD(trad_comm,kk,kkp)           = ROUND(VXMD(trad_comm,kk,kkp),6) ;
 VXWD(trad_comm,kk,kkp)           = ROUND(VXWD(trad_comm,kk,kkp),6) ;
 VIMS(trad_comm,kkp,kk)           = ROUND(VIMS(trad_comm,kkp,kk),6) ;
 VIWS(trad_comm,kkp,kk)           = ROUND(VIWS(trad_comm,kkp,kk),6) ;
 VST(marg_comm,kk)                = ROUND(VST(marg_comm,kk),6) ;
 VTWR(marg_comm,trad_comm,kkp,kk) = ROUND(VTWR(marg_comm,trad_comm,kkp,kk),6) ;

*############## 7. RELABELLING THE GTAP DATA ###########################

*####### GTAP parameters coefficients read by GTAP.TAB v 6.1 ###########

* Trade Margins Related

 VST1(dcc,kk)        = SUM(marg_comm
                        $MAPVST(dcc,marg_comm),
                        VST(marg_comm,kk)) ;

* Depeciation by factor

 DEPREC("ffcapital",kk)
                    = VDEP(kk) ;

* Values of Components of Domestic production

 VDM(dcc,kk)         = SUM(trad_comm
                       $MAPDOM(dcc,trad_comm),
                       VDPM(trad_comm,kk))
                         + SUM(trad_comm
                           $MAPDOM(dcc,trad_comm),
                           VDGM(trad_comm,kk))
                             + SUM(aa, SUM((trad_comm,prod_comm)
                                       $(MAPDOM(dcc,trad_comm)
                                       $MAPACT(aa,prod_comm)),
                                       VDFM(trad_comm,prod_comm,kk)))
                               + SUM((trad_comm,prod_comm)
                                 $(MAPDOM(dcc,trad_comm)
                                 $MAPINV("kkap",prod_comm)),
                                 VDFM(trad_comm,prod_comm,kk)) ;


*############## 8. CREATING THE GLOBAL SAM ###########################
*$ontext
* Constructing the global SAM
* Submatrices are added by rows of the SAM
* Number in brackets (x:y) indicate row (x) and column (y) in the SAM

*#### Import commodity income components

* Import Intermediate Use matrices (1:3)

 SAMG(mcc,aa,kk)        = SUM((trad_comm,prod_comm)
                          $(MAPIMP(mcc,trad_comm)
                          $MAPACT(aa,prod_comm)),
                          VIFM(trad_comm,prod_comm,kk)) ;

* Household import demand vectors (1:6)

 SAMG(mcc,"hhous",kk)   = SUM(trad_comm
                          $MAPIMP(mcc,trad_comm),
                          VIPM(trad_comm,kk)) ;

* Government import demand vectors (1:13)

 SAMG(mcc,"ggovt",kk)   = SUM(trad_comm
                          $MAPIMP(mcc,trad_comm),
                          VIGM(trad_comm,kk)) ;

* Investment import demand vectors (1:14)

 SAMG(mcc,ii,kk)        = SUM((trad_comm,prod_comm)
                          $(MAPIMP(mcc,trad_comm)
                          $MAPINV(ii,prod_comm)),
                          VIFM(trad_comm,prod_comm,kk)) ;

*#### Domestic commodity income components

* Domestic Intermediate Use matrices (2:3)

 SAMG(dcc,aa,kk)        = SUM((trad_comm,prod_comm)
                          $(MAPDOM(dcc,trad_comm)
                          $MAPACT(aa,prod_comm)),
                          VDFM(trad_comm,prod_comm,kk)) ;

* Household domestic demand vectors (2:6)

 SAMG(dcc,"hhous",kk)   = SUM(trad_comm
                          $MAPDOM(dcc,trad_comm),
                          VDPM(trad_comm,kk)) ;

* Export taxes

 SAMG(teetax,dcc,kk)    = SUM((trad_comm,kkp)
                          $(MAPDOM(dcc,trad_comm)
                          $MAPTETAX(teetax,kkp)),
                          VXWD(trad_comm,kk,kkp))
                              - SUM((trad_comm,kkp)
                                $(MAPDOM(dcc,trad_comm)
                                $MAPTETAX(teetax,kkp)),
                                VXMD(trad_comm,kk,kkp)) ;

* Government domestic demand vectors (2:13)

 SAMG(dcc,"ggovt",kk)   = SUM(trad_comm
                          $MAPDOM(dcc,trad_comm),
                          VDGM(trad_comm,kk)) ;

* Investment domestic demand vectors (2:14)

 SAMG(dcc,ii,kk)           = SUM((trad_comm,prod_comm)
                             $(MAPDOM(dcc,trad_comm)
                             $MAPINV(ii,prod_comm)),
                             VDFM(trad_comm,prod_comm,kk)) ;

* Export demand matrices (2:16)
* Export of transport services

 SAMG("ddotp","otppvst",kk)     = VST1("ddotp",kk) ;
 SAMG("ddwtp","wtppvst",kk)     = VST1("ddwtp",kk) ;
 SAMG("ddatp","atppvst",kk)     = VST1("ddatp",kk) ;

* Exports of Goods and Services

 SAMG(dcc,ww,kk)           = SUM((trad_comm,kkp)
                             $(MAPDOM(dcc,trad_comm)
                             $MAPTRAD(ww,kkp)),
                             VXWD(trad_comm,kk,kkp)) ;

*#### Activity Income

* Make Matrix (3:2)

 SAMG(aa,dcc,kk)    = (VDM(dcc,kk) + VST1(dcc,kk)
                              + SUM(ww,SUM((trad_comm,kkp)
                                $(MAPDOM(dcc,trad_comm)
                                $MAPTRAD(ww,kkp)),
                                VXMD(trad_comm,kk,kkp))))
                          * ID(aa,dcc) ;

*#### Factor Income

* Factor demands by activities (4:3)

 SAMG(ff,aa,kk)            = SUM((endw_comm,prod_comm)
                             $(MAPFACT(ff,endw_comm)
                             $MAPACT(aa,prod_comm)),
                             VFM(endw_comm,prod_comm,kk)) ;

*#### Indirect Tax Receipts for INDTAX(r) in GTAP model

* Import Duty Income (7:1)

 SAMG(tmmtax,mcc,kk)      = SUM((trad_comm,kkp)
                            $(MAPIMP(mcc,trad_comm)
                            $MAPTMTAX(tmmtax,kkp)),
                            VIMS(trad_comm,kkp,kk))
                                  - SUM((trad_comm,kkp)
                                    $(MAPIMP(mcc,trad_comm)
                                    $MAPTMTAX(tmmtax,kkp)),
                                    VIWS(trad_comm,kkp,kk)) ;

*# Import Sales Taxes

* Intermediate Inputs (8:3)

 SAMG(smmtax,aa,kk)      = SUM(mcc
                           $MAPSMTAX(smmtax,mcc),
                             SUM((trad_comm,prod_comm)
                             $(MAPIMP(mcc,trad_comm)
                             $MAPACT(aa,prod_comm)),
                             VIFA(trad_comm,prod_comm,kk)))
                                - SUM(mcc
                                  $MAPSMTAX(smmtax,mcc),
                                    SUM((trad_comm,prod_comm)
                                    $(MAPIMP(mcc,trad_comm)
                                    $MAPACT(aa,prod_comm)),
                                    VIFM(trad_comm,prod_comm,kk))) ;

* Household Demand (9:6)

 SAMG(smmtax,"hhous",kk) = SUM(mcc
                           $MAPSMTAX(smmtax,mcc),
                             SUM(trad_comm
                             $MAPIMP(mcc,trad_comm),
                             VIPA(trad_comm,kk)))
                               - SUM(mcc
                                 $MAPSMTAX(smmtax,mcc),
                                   SUM(trad_comm
                                   $MAPIMP(mcc,trad_comm),
                                   VIPM(trad_comm,kk))) ;

* Government Demand (9:13)

 SAMG(smmtax,"ggovt",kk) = SUM(mcc
                           $MAPSMTAX(smmtax,mcc),
                             SUM(trad_comm
                             $MAPIMP(mcc,trad_comm),
                             VIGA(trad_comm,kk)))
                               - SUM(mcc
                                 $MAPSMTAX(smmtax,mcc),
                                   SUM(trad_comm
                                   $MAPIMP(mcc,trad_comm),
                                   VIGM(trad_comm,kk))) ;

* Investment Demand (9:14)

 SAMG(smmtax,ii,kk)      = SUM(mcc
                           $MAPSMTAX(smmtax,mcc),
                             SUM((trad_comm,prod_comm)
                             $(MAPIMP(mcc,trad_comm)
                             $MAPINV(ii,prod_comm)),
                             VIFA(trad_comm,prod_comm,kk)))
                               - SUM(mcc
                                 $MAPSMTAX(smmtax,mcc),
                                   SUM((trad_comm,prod_comm)
                                   $(MAPIMP(mcc,trad_comm)
                                   $MAPINV(ii,prod_comm)),
                                   VIFM(trad_comm,prod_comm,kk))) ;

*# Domestic Sales Taxes

* Intermediate Inputs (8:3)

 SAMG(sddtax,aa,kk)      = SUM(dcc
                           $MAPSDTAX(sddtax,dcc),
                             SUM((trad_comm,prod_comm)
                             $(MAPDOM(dcc,trad_comm)
                             $MAPACT(aa,prod_comm)),
                             VDFA(trad_comm,prod_comm,kk)))
                                - SUM(dcc
                                  $MAPSDTAX(sddtax,dcc),
                                    SUM((trad_comm,prod_comm)
                                    $(MAPDOM(dcc,trad_comm)
                                    $MAPACT(aa,prod_comm)),
                                    VDFM(trad_comm,prod_comm,kk))) ;

* Household Demand (8:6)

 SAMG(sddtax,"hhous",kk) = SUM(dcc
                           $MAPSDTAX(sddtax,dcc),
                             SUM(trad_comm
                             $MAPDOM(dcc,trad_comm),
                             VDPA(trad_comm,kk)))
                                - SUM(dcc
                                  $MAPSDTAX(sddtax,dcc),
                                    SUM(trad_comm
                                    $MAPDOM(dcc,trad_comm),
                                    VDPM(trad_comm,kk))) ;

* Government Demand (8:13)

 SAMG(sddtax,"ggovt",kk) = SUM(dcc
                           $MAPSDTAX(sddtax,dcc),
                             SUM(trad_comm
                             $MAPDOM(dcc,trad_comm),
                             VDGA(trad_comm,kk)))
                                - SUM(dcc
                                  $MAPSDTAX(sddtax,dcc),
                                    SUM(trad_comm
                                    $MAPDOM(dcc,trad_comm),
                                    VDGM(trad_comm,kk))) ;

* Investment Demand (8:14)

 SAMG(sddtax,ii,kk)     = SUM(dcc
                          $MAPSDTAX(sddtax,dcc),
                            SUM((trad_comm,prod_comm)
                            $(MAPDOM(dcc,trad_comm)
                            $MAPINV(ii,prod_comm)),
                            VDFA(trad_comm,prod_comm,kk)))
                               - SUM(dcc
                                 $MAPSDTAX(sddtax,dcc),
                                   SUM((trad_comm,prod_comm)
                                   $(MAPDOM(dcc,trad_comm)
                                   $MAPINV(ii,prod_comm)),
                                   VDFM(trad_comm,prod_comm,kk))) ;

* Factor taxes paid by activities

* Factor taxes paid by activities

 SAMG(fftax,aa,kk)        = SUM((endw_comm,prod_comm)
                            $(MAPFTAX(fftax,endw_comm)
                            $MAPACT(aa,prod_comm)),
                            EVFA(endw_comm,prod_comm,kk))
                               - SUM((endw_comm,prod_comm)
                                 $(MAPFTAX(fftax,endw_comm)
                                 $MAPACT(aa,prod_comm)),
                                 VFM(endw_comm,prod_comm,kk)) ;

* Production taxes paid by activity

 SAMG("pprodtax",aa,kk)  = SUM(dcc,SAMG(aa,dcc,kk)) -
                           (SUM(mcc,SUM((trad_comm,prod_comm)
                                    $(MAPIMP(mcc,trad_comm)
                                    $MAPACT(aa,prod_comm)),
                                    VIFA(trad_comm,prod_comm,kk)))
                           + SUM(dcc,SUM((trad_comm,prod_comm)
                                     $(MAPDOM(dcc,trad_comm)
                                     $MAPACT(aa,prod_comm)),
                                     VDFA(trad_comm,prod_comm,kk)))
                           + SUM(ff,SUM((endw_comm,prod_comm)
                                     $(MAPFACT(ff,endw_comm)
                                     $MAPACT(aa,prod_comm)),
                                     EVFA(endw_comm,prod_comm,kk))) ) ;


* Factor Income Taxes (12:4)

 SAMG("ddirtax",ff,kk)   = SUM(aa,SUM((endw_comm,prod_comm)
                           $(MAPFACT(ff,endw_comm)
                           $MAPACT(aa,prod_comm)),
                           VFM(endw_comm,prod_comm,kk)))
                              - SUM(endw_comm
                                $MAPFACT(ff,endw_comm),
                                EVOA(endw_comm,kk)) ;

*#### Components of Regional Household Income

* Factor Incomes after depreciation (5:4)

 SAMG("rreghous",ff,kk)      = SUM(endw_comm
                               $MAPFACT(ff,endw_comm),
                               EVOA(endw_comm,kk))
                                   - DEPREC(ff,kk) ;

* Import duties and export taxes (5:7)

 SAMG("rreghous",tmmtax,kk)  = SUM(mcc,SAMG(tmmtax,mcc,kk)) ;

 SAMG("rreghous",teetax,kk)  = SUM(dcc,SAMG(teetax,dcc,kk)) ;

* Domestic Sales taxes (5:8)

 SAMG("rreghous",sddtax,kk)  = SUM(aa, SAMG(sddtax,aa,kk))
                              + SAMG(sddtax,"hhous",kk)
                              + SAMG(sddtax,"ggovt",kk)
                              + SAMG(sddtax,"kkap",kk) ;

* Import Sales taxes (5:9)

 SAMG("rreghous",smmtax,kk)  = SUM(aa,SAMG(smmtax,aa,kk))
                              + SAMG(smmtax,"hhous",kk)
                              + SAMG(smmtax,"ggovt",kk)
                              + SAMG(smmtax,"kkap",kk) ;

* Production Taxes (5:11)

 SAMG("rreghous","pprodtax",kk)
                         = SUM(aa,SAMG("pprodtax",aa,kk)) ;

* Factor Use Taxes

 SAMG("rreghous",fftax,kk)   =  SUM(aa,SAMG(fftax,aa,kk)) ;

* Direct Taxes (5:12)
 SAMG("rreghous","ddirtax",kk)  =  SUM(ff,SAMG("ddirtax",ff,kk)) ;

*#### Components of Regional Household Expenditure

* Income of Private Households (6:5)

 SAMG("hhous","RREGHOUS",kk) = SUM(mcc,SAMG(mcc,"hhous",kk))
                              + SUM(smmtax,SAMG(smmtax,"hhous",kk))
                              + SUM(dcc,SAMG(dcc,"hhous",kk))
                              + SUM(sddtax,SAMG(sddtax,"hhous",kk))  ;

* Income of Government (13:5)
 SAMG("ggovt","RREGHOUS",kk) = SUM(mcc,SAMG(mcc,"ggovt",kk))
                              + SUM(smmtax,SAMG(smmtax,"ggovt",kk))
                              + SUM(dcc,SAMG(dcc,"ggovt",kk))
                              + SUM(sddtax,SAMG(sddtax,"ggovt",kk))  ;

* Domestic Savings (14:5)

 SAMG("kkap","RREGHOUS",kk)  = SAVE(kk) ;

*#### Capital Account Income

* Depreciation charges (14:4)

 SAMG("kkap","ffcapital",kk) = VDEP(kk) ;

*#### Rest of World

* Import Margin Matrices (15:1)

 SAMG(OTPPMARG,mcc,kk)    = SUM((trad_comm,kkp)
                            $(MAPIMP(mcc,trad_comm)
                            $MAPOTPMARG(otppmarg,kkp)),
                            VTWR("otp",trad_comm,kkp,kk)) ;

 SAMG(WTPPMARG,mcc,kk)    = SUM((trad_comm,kkp)
                            $(MAPIMP(mcc,trad_comm)
                            $MAPWTPMARG(wtppmarg,kkp)),
                            VTWR("wtp",trad_comm,kkp,kk)) ;

 SAMG(ATPPMARG,mcc,kk)    = SUM((trad_comm,kkp)
                            $(MAPIMP(mcc,trad_comm)
                            $MAPATPMARG(atppmarg,kkp)),
                            VTWR("atp",trad_comm,kkp,kk)) ;

* Import Supply Matrices (16:1)

* SMcD TRADE

* Direct method
$ontext
 SAMG(ww,mcc,kk)          = SUM((trad_comm,kkp)
                             $(MAPIMP(mcc,trad_comm)
                             $MAPTRAD(ww,kkp)),
                             VIWS(trad_comm,kkp,kk))
                                - SUM(marg_comm,SUM((trad_comm,kkp)
                                  $(MAPIMP(mcc,trad_comm)
                                  $MAPTRAD(ww,kkp)),
                                  VTWR(marg_comm,trad_comm,kkp,kk)))  ;
$offtext

* Indirect Method using Exports fob

Parameter
 SAMExports1(mcc,ww,rr)    Exports of commod mcc to region ww by region rr
 SAMExports2(mcc,kk,rr)    Exports of commod mcc to region kk by region rr
 SAMExports3(mcc,kk,ww)    Exports of commod mcc to region kk by region ww

 ;

 SAMExports1(mcc,ww,rr) = SUM((dcc,kk)
                          $(MAPCOM(mcc,dcc)
                          $MAPREG(rr,kk)),
                          SAMG(dcc,ww,kk)) ;

 SAMExports2(mcc,kk,rr)  = SUM(ww
                           $MAPREG4(kk,ww),
                           SAMExports1(mcc,ww,rr)) ;

 SAMExports3(mcc,kk,ww)  = SUM(rr
                           $MAPREG5(ww,rr),
                           SAMExports2(mcc,kk,rr)) ;

 SAMG(ww,mcc,kk)         = SAMExports3(mcc,kk,ww) ;

* Expenditures on transport services

 SAMG("otppvst",otppmarg,kk)  = SUM(mcc,SAMG(otppmarg,mcc,kk)) ;
 SAMG("wtppvst",wtppmarg,kk)  = SUM(mcc,SAMG(wtppmarg,mcc,kk)) ;
 SAMG("atppvst",atppmarg,kk)  = SUM(mcc,SAMG(atppmarg,mcc,kk)) ;

* Capital Account Balances
* Capital Account balance for trade in transport services

 SAMG("kkap","otppvst",kk)  = SUM((mcc,otppmarg),SAMG(otppmarg,mcc,kk))
                               - SUM(dcc,SAMG(dcc,"otppvst",kk)) ;

 SAMG("kkap","wtppvst",kk)  = SUM((mcc,wtppmarg),SAMG(wtppmarg,mcc,kk))
                               - SUM(dcc,SAMG(dcc,"wtppvst",kk)) ;

 SAMG("kkap","atppvst",kk)  = SUM((mcc,atppmarg),SAMG(atppmarg,mcc,kk))
                               - SUM(dcc,SAMG(dcc,"atppvst",kk)) ;

* Capital Account balances by trade partner on commodity trade

 SAMG("kkap",ww,kk)       = SUM(mcc,SAMG(ww,mcc,kk))
                             - SUM(dcc,SUM((trad_comm,kkp)
                                       $(MAPDOM(dcc,trad_comm)
                                       $MAPTRAD(ww,kkp)),
                                       VXWD(trad_comm,kk,kkp))) ;

*#### Rounding the Global SAM to 6 Decimal Places
* The GTAP database only records data to 6 decimal places

 SAMG(ss,ssp,kk)      = ROUND(SAMG(ss,ssp,kk),6) ;

*DISPLAY SAMG ;

*############## 9. CHECKING THE GLOBAL SAM ###########################

* This checking of the Global SAM is important. When using a new version of
* the GTAP data it is essential to check that the 'errors' corrected for
* below are those that actually exist.

*#### Checking that Exports fob equal Imports fob
* This check is critical since it impacts upon all subsequent routines
* All entries in TradeCHK must be ZERO

* TRADECAL

Parameter
 Exports(mcc,ww,rr)    Exports of commod mcc to region ww by region rr
 Imports1(rr,mcc,kk)   Imports from region rr of commod mcc by region kk
 Imports2(rr,mcc,ww)   Imports from region rr of commod mcc by region ww

 TradeCHK(mcc,ww,rr)   Difference between imports and exports

 ;

 Exports(mcc,ww,rr)  = SUM((dcc,kk)
                       $(MAPCOM(mcc,dcc)
                       $MAPREG(rr,kk)),
                       SAMG(dcc,ww,kk)) ;

 Imports1(rr,mcc,kk) = SUM(ww
                       $MAPREG2(rr,ww),
                       SAMG(ww,mcc,kk)) ;

 Imports2(rr,mcc,ww) = SUM(kk
                       $MAPREG3(ww,kk),
                       Imports1(rr,mcc,kk)) ;

 TradeCHK(mcc,ww,rr) = Exports(mcc,ww,rr) - Imports2(rr,mcc,ww) ;

option decimals = 8 ;

DISPLAY  Exports, Imports1, Imports2 ;
DISPLAY  TradeCHK ;

*#### Computing Account totals for Global SAM by Region

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;

 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

Set
 step    steps for counts of big total and percentage differences   /
 step1      step1
 step2      step2
 step3      step3
 step4      step4
 step5      step5
 step6      step6
 step7      step7
 step8      step8
 step9      step9
  /
 case   number of cases in each step  /
 case1      case1
 case2      case2
 case3      case3
  /
  ;

Parameter
 SAMGv1(ss,ss,kk)      Social accounting matrices for regions k stage 1
 COLTOT(*,kk)          Check on region column totals
 ROWTOT(kk,*)          Check on region row totals
 DIFFTOT(*,kk)         Check on difference in region column and row totals
 SUMDIFFTOT(kk)        Sum of differences in region row and column totals
 DIFFPER(*,kk)         Percentage differences in region column and row totals

 DIFTOTPERCNT(step,case)  Counts of big total and percentage differences
 ;

 SAMGv1(ss,ssp,kk) =  SAMG(ss,ssp,kk) ;

 COLTOT(ssnp,kk)    = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 ROWTOT(kk,ssn)     = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 DIFFTOT(ssnp,kk)   = COLTOT(ssnp,kk) - ROWTOT(kk,ssnp) ;

 DIFFTOT(ssnp,kk)   = ROUND(DIFFTOT(ssnp,kk),6 ) ;

 SUMDIFFTOT(kk)     = SUM(ssnp,DIFFTOT(ssnp,kk)) ;

 DIFFPER(ssnp,kk)$COLTOT(ssnp,kk)
       = (DIFFTOT(ssnp,kk)/(0.5 * (COLTOT(ssnp,kk) + ROWTOT(kk,ssnp)))) * 100 ;

 DIFFPER(ssnp,kk)   = ROUND(DIFFPER(ssnp,kk),6 ) ;

* Counting big total and percentage differences

 DIFTOTPERCNT("step1","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 5), 1) ;
 DIFTOTPERCNT("step2","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 1), 1) ;
 DIFTOTPERCNT("step3","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.5), 1) ;
 DIFTOTPERCNT("step4","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.1), 1) ;
 DIFTOTPERCNT("step5","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.01), 1) ;
 DIFTOTPERCNT("step6","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.001), 1) ;
 DIFTOTPERCNT("step7","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.0001), 1) ;
 DIFTOTPERCNT("step8","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.00001), 1) ;
 DIFTOTPERCNT("step9","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.000001), 1) ;

 DIFTOTPERCNT("step1","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 5), 1) ;
 DIFTOTPERCNT("step2","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 1), 1) ;
 DIFTOTPERCNT("step3","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.5), 1) ;
 DIFTOTPERCNT("step4","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.1), 1) ;
 DIFTOTPERCNT("step5","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.01), 1) ;
 DIFTOTPERCNT("step6","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.001), 1) ;
 DIFTOTPERCNT("step7","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.0001), 1) ;
 DIFTOTPERCNT("step8","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.00001), 1) ;
 DIFTOTPERCNT("step9","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.000001), 1) ;

 DIFTOTPERCNT("step3","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 1)
                              AND (DIFFPER(ssn,kk) > 0.1)), 1) ;
 DIFTOTPERCNT("step4","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.1)
                              AND (DIFFPER(ssn,kk) > 0.01)),  1) ;
 DIFTOTPERCNT("step5","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.01)
                              AND (DIFFPER(ssn,kk) > 0.001)),  1) ;
 DIFTOTPERCNT("step6","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.001)
                              AND (DIFFPER(ssn,kk) > 0.0001)),  1) ;
 DIFTOTPERCNT("step7","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.0001)
                              AND (DIFFPER(ssn,kk) > 0.00001)),  1) ;
 DIFTOTPERCNT("step8","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.00001)
                              AND (DIFFPER(ssn,kk) > 0.000001)),  1) ; ;
 DIFTOTPERCNT("step9","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.000001)
                              AND (DIFFPER(ssn,kk) > 0.0000001)),  1) ;


option decimals = 6 ;

DISPLAY COLTOT, ROWTOT, DIFFTOT, DIFFPER, DIFTOTPERCNT ;

*## Writing out the results to GDX
*$ontext

Execute_Unload  'gtptots1.gdx', SAMGv1
                                COLTOT
                                ROWTOT
                                DIFFTOT
                                DIFFPER
                                DIFTOTPERCNT ;

*$offtext

*############## 10. BALANCING THE GLOBAL SAM ###########################
$ontext

This balancing process adjusts for 'errors' in version 6.0 of the GTAP data

These 'errors' were
      No domestic demand for imports of dwe - account mdwe - in some regions
      Row and column totals differ for imported commodities
             - appear at the 3rd, or usually, more decimal
             - all are small percentage differences
      Regional Household row and column totals differ
      Capital account row and column totals differ

However these are mutually cancelling 'errors'.

The following parameters summarise the differences
       DIFFTOT  - absolute differences in row and column totals
       DIFFPER  - percentage differences in row and column totals
       DIFFTOTPERCNT  - counts of absolute and/or percentage differences
                        in row and column totals

$offtext

*### Correcting and Adding domestic demand for mdwe where missing

 SAMG("mmdwe","HHOUS",kk)    = 0.0 ;

 SAMG("mmdwe","HHOUS",kk)    = 0.000001 ;

* Recalculating difference

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;

 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 COLTOT(ssnp,kk)    = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 ROWTOT(kk,ssn)     = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 DIFFTOT(ssnp,kk)   = COLTOT(ssnp,kk) - ROWTOT(kk,ssnp) ;

 DIFFTOT(ssnp,kk)   = ROUND(DIFFTOT(ssnp,kk),6 ) ;

 DIFFPER(ssnp,kk)$COLTOT(ssnp,kk)
       = (DIFFTOT(ssnp,kk)/(0.5 * (COLTOT(ssnp,kk) + ROWTOT(kk,ssnp)))) * 100 ;

 DIFFPER(ssnp,kk)   = ROUND(DIFFPER(ssnp,kk),6 ) ;

DISPLAY DIFFTOT ;

*## Writing out the results to GDX
*$ontext

Execute_Unload  'gtptots2.gdx', COLTOT
                                ROWTOT
                                DIFFTOT
                                DIFFPER ;

*$offtext

*### Adjusting for 'errors' in imports accounts
* Leave trade fixed, i.e., column entries fixed, and add adjustment to
* final demand by GOVT

 SAMG(mcc,"GGOVT",kk)        = SAMG(mcc,"GGOVT",kk) + DIFFTOT(mcc,kk) ;

* Recalculating difference

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;

 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 COLTOT(ssnp,kk)    = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 ROWTOT(kk,ssn)     = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 DIFFTOT(ssnp,kk)   = COLTOT(ssnp,kk) - ROWTOT(kk,ssnp) ;

 DIFFTOT(ssnp,kk)   = ROUND(DIFFTOT(ssnp,kk),6 ) ;

 DIFFPER(ssnp,kk)$COLTOT(ssnp,kk)
       = (DIFFTOT(ssnp,kk)/(0.5 * (COLTOT(ssnp,kk) + ROWTOT(kk,ssnp)))) * 100 ;

 DIFFPER(ssnp,kk)   = ROUND(DIFFPER(ssnp,kk),6 ) ;

DISPLAY DIFFTOT ;

*## Writing out the results to GDX
*$ontext

Execute_Unload  'gtptots3.gdx', COLTOT
                                ROWTOT
                                DIFFTOT
                                DIFFPER ;

*$offtext

*### Correcting Regional Incomes and Expenditures

* Adjusting the SAM

 SAMG("HHOUS","RREGHOUS",kk)
                     = SAMG("HHOUS","RREGHOUS",kk) + DIFFTOT("HHOUS",kk) ;

 SAMG("GGOVT","RREGHOUS",kk)
                     = SAMG("GGOVT","RREGHOUS",kk) + DIFFTOT("GGOVT",kk) ;

 SAMG("KKAP","RREGHOUS",kk)
                     = SAMG("KKAP","RREGHOUS",kk) + DIFFTOT("KKAP",kk) ;

* Recalculating difference

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;

 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 COLTOT(ssnp,kk)    = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 ROWTOT(kk,ssn)     = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 DIFFTOT(ssnp,kk)   = COLTOT(ssnp,kk) - ROWTOT(kk,ssnp) ;

 DIFFTOT(ssnp,kk)   = ROUND(DIFFTOT(ssnp,kk),6 ) ;

 DIFFPER(ssnp,kk)$COLTOT(ssnp,kk)
       = (DIFFTOT(ssnp,kk)/(0.5 * (COLTOT(ssnp,kk) + ROWTOT(kk,ssnp)))) * 100 ;

 DIFFPER(ssnp,kk)   = ROUND(DIFFPER(ssnp,kk),6 ) ;

DISPLAY DIFFTOT ;

*## Writing out the results to GDX
*$ontext

Execute_Unload  'gtptots4.gdx', COLTOT
                                ROWTOT
                                DIFFTOT
                                DIFFPER ;

*$offtext

* The GTAP database only records data to 6 decimal places

 SAMG(ss,ssp,kk)      = ROUND(SAMG(ss,ssp,kk),6) ;

*############## 11. CHECKING THE BALANCED GLOBAL SAM ###################

*#### Computing Account totals for Balanced Global SAM by Region

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;

 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

Parameter
 COLTOT2(*,kk)          Check on region column totals
 ROWTOT2(kk,*)          Check on region row totals
 DIFFTOT2(*,kk)         Check on difference in region column and row totals
 SUMDIFFTOT2(kk)        Sum of differences in region row and column totals
 DIFFPER2(*,kk)         Percentage differences in region column and row totals
 ;

 COLTOT2(ssnp,kk)    = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 ROWTOT2(kk,ssn)     = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 DIFFTOT2(ssnp,kk)   = COLTOT2(ssnp,kk) - ROWTOT2(kk,ssnp) ;

 DIFFTOT2(ssnp,kk)   = ROUND(DIFFTOT2(ssnp,kk),6 ) ;

 SUMDIFFTOT2(kk)     = SUM(ssnp,DIFFTOT2(ssnp,kk)) ;

 DIFFPER2(ssnp,kk)$COLTOT2(ssnp,kk)
     = (DIFFTOT2(ssnp,kk)/(0.5 * (COLTOT2(ssnp,kk) + ROWTOT2(kk,ssnp)))) * 100 ;

 DIFFPER2(ssnp,kk)   = ROUND(DIFFPER2(ssnp,kk),6 ) ;

option decimals = 8 ;

DISPLAY COLTOT2, ROWTOT2, DIFFTOT2, DIFFPER2 ;

*## Writing out the results to GDX
*$ontext

Execute_Unload  'gtptots5.gdx', COLTOT2
                                ROWTOT2
                                DIFFTOT2
                                DIFFPER2 ;

*$offtext

* Identifying the MAX and MIN transactions for each Region

PARAMETER
 MAXTV(kk)        Max absolute value of transactions in SAM by region
 MINTV(kk)        Min absolute value of transactions in SAM by region ;

 MAXTV(kk)    = SMAX((SSN,SSNP),ABS (SAMG(SSN,SSNP,kk))) ;
 MINTV(kk)    = SMIN((SSN,SSNP)$SAMG(SSN,SSNP,kk),ABS (SAMG(SSN,SSNP,kk))) ;

 DISPLAY MAXTV, MINTV ;

*## Writing out the results to GDX
*$ontext

Execute_Unload  'gtpmxmin.gdx', MAXTV
                                MINTV ;

*$offtext

*############## 12. A SAMPLE REGION SAM ################################

PARAMETER
 SAMREGX(ss,ssp)  SAM for Region X ;

$ontext
Regions are
                 aus        Australia
                 nzl        New Zealand
                 xoc        Rest of Oceania
                 chn        China
                 hkg        Hong Kong
                 jpn        Japan
                 kor        Korea
                 twn        Taiwan
                 xea        Rest of East Asia
                 idn        Indonesia
                 mys        Malaysia
                 phl        Philippines
                 sgp        Singapore
                 tha        Thailand
                 vnm        Vietnam
                 xse        Rest of Southeast Asia
                 bgd        Bangladesh
                 ind        India
                 lka        Sri Lanka
                 xsa        Rest of South Asia
                 can        Canada
                 usa        United States
                 mex        Mexico
                 xna        Rest of North America
                 col        Colombia
                 per        Peru
                 ven        Venezuela
                 xap        Rest of Andean Pact
                 arg        Argentina
                 bra        Brazil
                 chl        Chile
                 ury        Uruguay
                 xsm        Rest of South America
                 xca        Central America
                 xfa        Rest of FTAA
                 xcb        Rest of the Caribbean
                 aut        Austria
                 bel        Belgium
                 dnk        Denmark
                 fin        Finland
                 fra        France
                 deu        Germany
                 gbr        United Kingdom
                 grc        Greece
                 irl        Ireland
                 ita        Italy
                 lux        Luxembourg
                 nld        Netherlands
                 prt        Portugal
                 esp        Spain
                 swe        Sweden
                 che        Switzerland
                 xef        Rest of EFTA
                 xer        Rest of Europe
                 alb        Albania
                 bgr        Bulgaria
                 hrv        Croatia
                 cyp        Cyprus
                 cze        Czech Republic
                 hun        Hungary
                 mlt        Malta
                 pol        Poland
                 rom        Romania
                 svk        Slovakia
                 svn        Slovenia
                 est        Estonia
                 lva        Latvia
                 ltu        Lithuania
                 rus        Russian Federation
                 xsu        Rest of Former Soviet Union
                 tur        Turkey
                 xme        Rest of Middle East
                 mar        Morocco
                 tun        Tunisia
                 xnf        Rest of North Africa
                 bwa        Botswana
                 zaf        South Africa
                 xsc        Rest of South African CU
                 mwi        Malawi
                 moz        Mozambique
                 tza        Tanzania
                 zmb        Zambia
                 zwe        Zimbabwe
                 xsd        Rest of SADC
                 mdg        Madagascar
                 uga        Uganda
                 xss        Rest of Sub-Saharan Africa

$offtext

 SAMREGX(ss,ssp)  = SAMG(ss,ssp,"aus") ;

DISPLAY SAMREGX ;

*Execute_Unload  'gtpsamregx.gdx', SAMREGX ;

*############## 13. WRITING THE GLOBAL SAM TO GDX #####################

*## Writing out the GTAP SAM to GDX
*$ontext

* This writes all the data and sets to GDX

*GTAP database version 5.3
Execute_Unload  'gtpsam53.gdx',     SAMG
                                    SS
                                    MCC
                                    DCC
                                    AA
                                    FF
                                    TMMTAX
                                    TEETAX
                                    SMMTAX
                                    SDDTAX
                                    FFTAX
                                    OTPPMARG
                                    WTPPMARG
                                    ATPPMARG
                                    VSTTMARG
                                    WW
                                    KK
 ;

*$offtext

*## Writing out the GDX file to HAR

execute 'gdx2har   gtpsam53.gdx    gsam53.har' ;

*########################### THE END ########################