$TITLE GTAP data v9 pr1 2011 to Global SAM with Satellite Data
* Elasticities, TS Trade and Energy
$OFFUPPER
*$OFFLISTING OFFSYMXREF OFFSYMLIST
$ONEMPTY

*############## TO DO ON THIS VERSION #############################
$ontext


$offtext
*############## PROGRAMME DESCRIPTION ##################################
$ontext
This programme sorts GTAP data into a global SAM structure.

There are 2 versions of the SAM reported:
  1) a SAM that is consistent with the basic GTAP model (SAMG1); and
  2) a SAM that distinguishes between ad valorem (equivalent) and
     specific trade taxes (SAMG2)

 This version
        output is in the form of both a GDX file and a HAR file

        does not adjust for the law of one price
        has the GTAP price system
        has GTAP style Regional and Private Households
        runs with the full GTAP database version 8 (2007)
             i.e., BaseData.har
                   Default.har
                   gsdvol.har
                   co2.har
                   TStrade.har

        In addition to the SAM the GDX file contains all the data supplied
        with GTAP v8 (2007), e.g., elasticities, time series trade data,
        energy volumes, CO2 emissions, additional data on taxes, etc.

 All versions of this programme together with the documentation are
 supplied in the form of a USER MODEL LIBRARY. Unzip the archive into
 a directory and from GAMSIDE select
         FILE > Model Library > Open User Model Library
 and select the library index file (gtaplib.glb) and then select the
 version of the programme that matches the version of GTAP with which you
 are working.

 The GTAP version supported by programmes in the library are
           GTAP v5.3
           GTAP v5.4
           GTAP v6.0 pre 5
           GTAP v6.0
           GTAP v7.0 release candidate 4
           GTAP v7.0
           GTAP v7.1
           GTAP v8.0 2007 & 2004
           GTAP v8.1 2007 & 2004
           GTAP v9 pr1 2011

 For GTAP versions 6 and 7rc4 the programme extracts nearly all the data
    supplied by GTAP.
 For GTAP version 7 & 7.1 the programme extracts ALL the data supplied by GTAP.
 For GTAP version 8 (2004 & 2007) the programme extracts ALL the data
    supplied by GTAP.
 For GTAP version 8.1 (2004 & 2007) the programme extracts ALL the data
    supplied by GTAP.
 For GTAP version 9 pr 1 (2011) the programme extracts ALL the data
    supplied by GTAP.

$offtext
*############## GENERAL INFORMATION #############################
$ontext

This programme was developed by Scott McDonald

 Scott McDonald
 Moncrieffe Road,
 Sheffield, S7 1HR, UK
 email:
    scott@cgemod.org.uk

Acknowledgements:
    Terrie Walmsley provided invaluable helpful advice about the GTAP model
        and GEMPACK.
    Helpful comments were provided by the referees for GTAP Tech Paper 22.
    Vitaly Kharitonov identified an error in the code.

This version works with GTAP version 9 pr1 2011.

This version last checked 26th Sept 2014

Documentation for the SAM representation of GTAP data is in

Scott McDonald and Karen Thierfelder,
'Deriving a Global Social Accounting Matrix from GTAP version 5 Data',
Global Trade Analysis Project Technical Paper 22.
Center for Global Trade Analysis: Purdue University. (www.gtap.org)

Copyright (c) 2014 Scott McDonald

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

A copy of the GNU GPL, gpl.txt, is included with the programme files.

Do NOT remove this notice if you redistribute this programme

If you use this programme you should acknowledge the source and not claim
authorship. Altered versions should be clearly distinguished from the original.

$offtext
*############## USER GUIDE v7 ######################################
$ontext

SOFTWARE REQUIREMENTS

  1) This programme is known to work with version 23.7 of GAMS 250.
     It is believed to work with all versions of GAMS 250 since
     distribution 22.6 in Dec 2007. It has not been tested for earlier
     versions of GDX, i.e., before v7

  2) This programme does not require a full licensed version of GAMS.

  3) Note that GAMS has used several formats for GDX. In some circumstances
     the version of GDX can create problems for users, e.g., when a
     GDX file is created using one version of GAMS and sent to a user with
     a different version of GAMS.
     With GAMS 22.8 the default format for gdx files is V7 uncompressed.
     V7 formatted files were introduced with version 22.6 of GAMS;
     V6 formatted files were introduced with version 22.3 of GAMS.
        Users with older licenced versions of GAMS may choose to use a
        recent demo version of GAMS resolve such problems.

  4) Recent versions of GAMS include the GDX2HAR and HAR2GDX utilities.
     If your version of GAMS does not include GDX2HAR and HAR2GDX it is
     necessary to get copies of the GDX2HAR and HAR2GDX utilities developed
     by Horridge and Rutherford (revised Nov 2003).
            http://debreu.colorado.edu/gdxhar
                   OR
            http://www.monash.edu.au/policy/ftp/gpextra/gdxhar.zip
       There are three files that need to be copied to the GAMS directory
            gdx2har.exe
            har2gdx.exe
            gdxiomh.dll

  5) It is also useful to have a copy of GDXVIEWER. This is standard in
     recent versions of GAMS.
     NB: for GAMS versions 22.6 and 22.7 the cube facility in GDXViewer
         does not seem to work correctly.
     Users of versions of GAMS that do not include GDXViewer should note that
     GDXViewer was one of the WTOOLS utilities developed by
     Erwin Kalvelagen. (GDXVIEWER allows the resultant Global SAM to be
     viewed on screen in a simple user friendly environment). The WTOOLS
     utilities were available from
            http://www.gams.com/~erwin/interface/interface.html#1.31_WTOOLS

DATA REQUIREMENTS

  1) No GTAP data are provided. The user must have a licensed version
     of the GTAP database complete with the GTAPAgg (or FLEXAgg) programme.

  2) All the sets and set mapping required to use the GAMS programmes for
     specific versions of the GTAP database are provided from
     an Excel workbook.
         GTAP version 5.3               - data_gtp_53.xls
         GTAP version 5.4               - data_gtp_54.xls
         GTAP version 6.0 pre release 5 - data_gtp_60_p5.xls
         GTAP version 6.0               - data_gtp_60.xls
         GTAP version 7.0rc4            - data_gtp_70_rc4.xls
         GTAP version 7.0               - data_gtp_70.xls
         GTAP version 7.1               - data_gtp_71.xls
         GTAP version 8.0               - data_gtp_804.xls
         GTAP version 8.0               - data_gtp_807.xls
         GTAP version 8.1               - data_gtp_8104.xls
         GTAP version 8.1               - data_gtp_8107.xlsx
         GTAP version 9 pr1 11          - data_gtp_9_pr1_11.xlsx

     An additional Excel workbook is also supplied that provides a simple
     semi-automated method for producing new set and mapping configurations.

     Step 11 in the User Instructions below provides brief guidance for
     working with other - more recent or older - versions of the GTAP
     database.

USER INSTRUCTIONS
   (These instructions assume the user is working in a Windows XP/Vista/7
    environment using GAMSIDE and Microsoft Excel 2003/2007/2010/2013)

  1) The programme files are made available in a WinZip archive - gtapsam.zip.

  2) The programme files are organised so that they can be used as a
     GAMS User Model Library (see the GAMS documentation for information
     on using User Model Libraries). These instructions assume that files
     in gtapsim.zip have been extracted to a directory - gsamlib.

  3) Create a directory for the programme. The path to this directory
     should follow standard/old DOS conventions - no directory with more
     than an 8 character name and no spaces in the names in the path.

     (This is probably no longer necessary but I am old fashioned)

     Create a project file (*.gpr) in this directory.

  4) To copy the programme files to the project directory.
     In GAMSIDE with the project file controlling paths do the following
     a) Locate the User Model Library
          File>Model Library>Open User Model Library and then select the
          file gtablib.glb in the directory gsamlib
     b) Double click on the NAME of the version of the programme that
        corresponds to the version of the GTAP database with which you are
        working. ALL the files needed to run the programme other than the
        GTAP database files will be copied to the directory containing the
        project file.
        NB: A brief description of the programme is provided in the window
            at the bottom of the User Model Library window.

  5) Read and study the GAMS programme.

  6) Create the database for the programme
     a) Use GTAPAgg to create an aggregation with 1:1 mappings for
        sectors, regions and factors.
     b) Extract the files Basedata.har, default.prm, gsdvole.har and
        tstrade.har from the WinZip archive created by GTAPAgg
        and copy to the project directory.
     c) NB; GTAP have labeled a *.har file as a *.prm file. Thus
        default.prm should be renamed default.har for HAR2GDX.
           IF default.har does NOT exist the programme fails on a Display
           statement for elastexist.

  7) Check that programme compiles by using SHIFT+F9.
        If the steps above have been followed there should be no problems.
        a) Some users can have problems with the GDXXRW facility
           that generates the file data_in.gdx from the Excel file. These
           problems mostly seem to originate with a corruption of the
           'LAYOUT' worksheet and result in an error message saying the
           file data_in.gdx does not exist. To overcome this type of problem
              i)  check that gdxxrw.exe exists in the GAMS directory
              ii) copy the contents of the worksheet 'LAYOUT2' and replace
                  the worksheet 'LAYOUT' using Paste Special
        b) If an error message saying that the file database.gdx does not
           exist arises check that the files har2gdx.exe, gdx2har.exe and
           gdxiomh.dll exist in the GAMS programme directory.

  8) Run the programme. The output to the working directory should be as
     follows:
     a) A GDX file for checking aspects of the SAM
          gtptots.gdx
          gtpmxmin.gdx
          trade_data_CHK.gdx
     b) Results files
          i)    ALL the GTAP data to GDX
                    gtpdatav8107.gdx or gtadatav8104.gdx
     c) Additional results files are available. These need the user to
        remove the characters that comment out the unload commmands. (This
        reduces the amount of potentially unuseful output.)
          i)    ONLY A Global SAM in GDX format (section 13.2)
                    gtpsam8107.gdx  or gtpsam8104.gdx
          ii)   A Global SAM in HAR format (section 13.3)
                    gsam8107.har or gsam8104.har
          iii)  A SAM for a SAMPLE Region (section 13.4)
                    gtpsamregx.gdx

     NB: For version 8 of the GTAP database the directory will be in the
         order of 940 MB with the Global SAM in HAR format accounting for
         some 427 MB and the GTAP data in GDX some 47 MB.
         A file - clean_gtp.bat - that removes surplus files is included:
         this is a batch file, i.e., double click of the file in
         Windows Explorer.
         This leaves ALL results files not used for checking and all data
         files needed to run the programme. (This clears out some 250 MB
         of files.)

  9) Exports fob and Imports fob calculated directly do not always equate -
     indirect and direct methods of calculating imports are included
     search for TRADECAL to control the choice of method. All the checks
     labelled TRADECHK should equal ZERO. The programme aborts with an
     error message if the trade accounts do not balance.

  10)GAMS code for aggregating the Global SAM programme is provided
     in the User Model Library. Two 'methods' are provided:
     10.1) A simple GAMS programme with an Excel workbook to assist
           generating the mapping accounts.
     10.2) A VBA programme that generates the mapping accounts and runs
           a GAMS programme.

  11)These notes relate to situations where a user wishes to work with
     another version of the GTAP database. It is assumed this will be a later
     version.
     A new workbook - data_gtp_**.xls - will need to be compiled.
     a) Using the file gtp_sets_v9_11_pr1.xlsx as a template
        i)   Get the 'new' sector, region, factor and margin codes and
             descriptions from the GTAP database and copy them into the
             worksheet 'Set data from GTAPAgg'
        ii)  Check that the worksheets
             'Set creation regions/sectors/factor/margins' have all updated
             correctly - NB the number of entries in each group of
             codes is the critical point.
        iii) Compile the new sets in the worksheet 'Compiling Sets'
     b) Using the file data_gtp_9_pr1_11.xlsx as a template
        i)   Generate a revise worksheet 'Sets' - using copy and paste
             SPECIAL from the new file gtp_sets_V**.xls.
        ii)  Generate a revise worksheet 'Maps' - using copy and paste
             from the new worksheet 'Sets'.
        iii) The worksheet 'Layout' should NOT need to be changed unless
             new sets or maps are created.
     c) Update the programme file to read the new sets and maps.

     d) Some general suggestions
        i)   Spaces in the cells of the file data_gtp_**.xlsx are a
             problem - to GAMS leading and trailing spaces are characters.
        ii)  If the orderings in the mapping sets are not consistent the
             mappings implemented will be wrong.
        iii) 'Corruption' of the worksheet 'Layout' will cause the sets and
             maps not to be read in.
        iv)  The codes used for account names in the GTAP database may
             have changed.
        v)   'Big' initial 'errors' (say entries in the first DIFFTOT that
             are greater than 1) are likely to be due to an error in the
             sets and maps files.
        vi)  'Small' initial 'errors' (say less that 0.01) are more likely
             to rounding issues due to the degree of precision in the
             GTAP database.
        vii) When adjusting the programme to remove 'errors' due to
             the degree precision in the database, it is best by far to
             work through the accounts as they appear in the SAM, i.e.,
             start with the import commodity accounts, then domestic
             commodities, etc.

$offtext
*############## 1. OUTLINE OF PROGRAMME ################################
$ontext
     PROGRAMME DESCRIPTION

  1. OUTLINE OF PROGRAMME

  2. DATA CONVERSION

  3. CONVENTIONS

  4. DECLARING SETS AND PARAMETERS FOR THIS PROGRAMME

  5. READ IN GTAP DATA AND SETS

  6. OTHER SET DECLARATION AND DATA

  7. RELABELLING THE GTAP DATA

  8. CREATING THE GLOBAL SAM

  9. CHECKING THE GLOBAL SAM

  10. BALANCING THE GLOBAL SAM

  11. CHECKING THE BALANCED GLOBAL SAM

  12. ADDITIONAL DATA FROM GTAP
             SATELLITE TAX DATA
             DOMESTIC SALES
             POPULATION DATA
             CAPITAL STOCK DATA
             GTAP ELASTICITIES DATA
             GTAP ENERGY DATA
             GTAP TIME SERIES TRADE DATA

  13. WRITING THE GLOBAL SAM TO GDX
        13.1 Writing out ALL the GTAP data to GDX
        13.2 Writing out ONLY the GTAP SAM to GDX
        13.3 Writing out ONLY the GTAP SAM and sets to HAR
        13.4 Writing out the SAM for a SAMPLE Region

$offtext
*############## 2. DATA CONVERSION #####################################
$ontext

DATA

INPUT
Header Array (HAR) Data are rendered readable by GAMS using HAR2GDX.
All sets and mapping sets for the GAMS rountine are entered from Excel
using GDXXRW.

OUTPUT
GDX data are rendered readable by GEMPACK programmes using GDX2HAR

$offtext
*############## 3. CONVENTIONS #########################################
$ontext

Naming conventions

     - the Excel workbook that contains all the sets - data_gtp_**.inc
       (where ** is the number of GTAP database version)
     - the output from GTAPAgg - basedata.har
     - the results from 'checks' on row and column totals are output to
       GDX - gtptots*.gdx (where * is 1 to 5)
     - maximum and minimum transaction values by region gtpmxmin.gdx
     - the global SAM in GDX format - gtpsam**.gdx
       (where ** is the number of GTAP database version)
     - the global SAM in HAR format - gsam**.har
       (where ** is the number of GTAP database version)

PARAMETERS
The output from HAR2GDX produces a GDX file that includes all the GTAP data.

This is used directly to create a global SAM; the global SAM does not
require all the data in the GTAP database.

SETS
The sets used involve adding preffices to the account names to distinguish
between different sections of the SAM. the suffices are
     COMM          commodity accounts
     REG           region accounts
     FACT          factor accounts

Imported Commodities         -----> mmCOMM
Domestic Commodities         -----> ddCOMM
Activities                   -----> aaCOMM
Factors                      -----> ffFACT
Regional Household           -----> n/a
Private Household            -----> n/a
Import duties - ALL          -----> tmmREG
   - Ad valorem equivalent   -----> tmm_avREG
   - specific                -----> tmm_spREG
Export Taxes                 -----> teeREG
Import Sales Taxes           -----> tssmCOMM
Domestic Sales Taxes         -----> tssdCOMM
Factor Taxes                 -----> tffFACT
Capital                      -----> n/a
ROW Transport Margins        -----> otppCOMM
                                    wtppCOMM
                                    atppCOMM
ROW Goods & Services         -----> wwREG

$offtext

*######## Listing of Sets ##########
$ontext

WITHIN REGION SETS
         SS                SAM accounts

Commodity sets
         MCC(SS)           Imported Commodities
         DCC(SS)           Domestic Commodities

Activity sets
         AA(SS)            Activities
         A2                Production commodities Activities in GTAP

Factor sets
         FF (SS)           Factors

Tax sets
         TMMTAX(SS)        Import duties
         TMSSTAX(SS)       Specific Import duties
         TEETAX(SS)        Export taxes
         SMMTAX(SS)        Sales Taxes on imported goods and services
         SDDTAX(SS)        Sales Taxes on domestic goods and services
         FFTAX(SS)         Taxes on Factors

Investment set
         II(SS)            Investment

Trade sets
         OTPPMARG(SS)      Other trade and transport costs
         wtppmarg(SS)      Water trade and transport costs
         atppmarg(SS)      Air trade and transport costs

         VSTTMARG(SS)      Exports of trade and transport services

         WW(SS)            Rest of the World

REGION SET
         KK                Regions

$offtext

*############## 4. DECLARING SETS AND PARAMETERS FOR THIS PROGRAMME #######

SETS

* These sets come from the basic GTAP database

 GlobalSet(*)              Set provided by GDX2HAR to order symbol table
 trad_comm(*)              traded commodities
 reg(*)                    regions in the model
 endw_comm(*)              endowment commodities
 prod_comm(*)              produced commodities
 dir(*)                    direction of trade flows
 marg_comm(*)              margin commodities
 decoupling(*)             PSE components
 tartype(*)                Tariff type
 allpayt(*)                Agricultural support payments


* Use of global set (ss) and then subsets (MC,DC,A,F,TMTAX,TETAX,SUBTAX,MMARG,W)

 ss                        SAM accounts
 mcc(ss)                   Imported Commodities
 dcc(ss)                   Domestic Commodities
 aa(ss)                    Activities
 ff(ss)                    Factors
 tmmtax(ss)                Import duties and Ad valorem equivalent Import duties
 tmsstax(ss)               Specific Import duties
 teetax(ss)                Export taxes
 smmtax(ss)                Sales Taxes on imported goods and services
 sddtax(ss)                Sales Taxes on domestic goods and services
 fftax(ss)                 Taxes on Factors
 otppmarg(ss)              Other trade and transport costs
 wtppmarg(ss)              Water trade and transport costs
 atppmarg(ss)              Air trade and transport costs
 vsttmarg(ss)              Exports of trade and transport services
 ww(ss)                    Rest of the World
 ii(ss)                    Investment
 kk                        Regions
 a2                        Production commodities Activities

 en                        energy commodities

* Mapping sets for this version

 MAPIMP(mcc,trad_comm)     Import mapping
 MAPDOM(dcc,trad_comm)     Domestic good mapping
 MAPVST(dcc,marg_comm)     Transport services mapping
 MAPPROD(a2,prod_comm)     Production mapping
 MAPACT(aa,prod_comm)      Activty mapping
 MAPINV(ii,prod_comm)      Investment mapping
 MAPTRAD(ww,kk)            Tradeaccount mapping
 MAPTMTAX(tmmtax,kk)       Export Duty tax mapping
 MAPTETAX(teetax,kk)       Export Duty tax mapping
 MAPOTPMARG(otppmarg,kk)   Other Transport margin mapping
 MAPWTPMARG(wtppmarg,kk)   Water Transport margin mapping
 MAPATPMARG(atppmarg,kk)   Air Transport margin mapping
 MAPSDTAX(sddtax,dcc)      Mapping domestic commodities to domestic sales taxes
 MAPSMTAX(smmtax,mcc)      Mapping imported commodities to imported sales taxes
 MAPFACT(ff,endw_comm)     Mapping factors to factor use taxes
 MAPFTAX(fftax,endw_comm)  Mapping factors to factor use taxes
 MAPDCC_AA(dcc,aa)         Mapping to dcc from aa
 mapaa_trad(aa,trad_comm)  Mapping to aa from trad comm

 map_tmss_tmm(tmsstax,tmmtax)  Mapping to tmsstax from tmmtax

* maptmmavtaxtmmtax(tmmavtax,tmmtax)   Mapping to tmmavtax from tmmtax
* maptmmasptaxtmmtax(tmmsptax,tmmtax)  Mapping to tmmsptax from tmmtax


* Mapping sets to Check Trade Transactions

 RR                        Regions
 MAPREG(rr,kk)             Region mapping to rr from kk
 MAPREG2(rr,ww)            Region mapping to rr from ww
 MAPREG3(ww,kk)            Region mapping to ww from kk
 MAPREG4(kk,ww)            Region mapping to ww from kk
 MAPREG5(ww,rr)            Region mapping to ww from kk
 MAPCOM(mcc,dcc)           Region mapping to mcc from dcc

*Other Sets

 tar           Tariff types
* pys           Agricultural support payment types
* dec           PSE components

 SSN(ss)       SAM accounts excluding TOTAL

 TT            Time periods  / Y1965*Y2014 /
            ;

Parameter
* Parameters from HAR file

 ADRV(trad_comm,kk,kk)            Protection Anti-Dumping Duty
 DPSM(kk)                         Sum Distn Parameters in Hhold Demand System
 EVFA(endw_comm,prod_comm,kk)     Endowments Firms Purchases at Agents Prices
 EVOA(endw_comm,kk)               Endowments Output at Agents Prices
 FBEP(endw_comm,prod_comm,kk)     Protection Factor-Based Subsidies
 FTRV(endw_comm,prod_comm,kk)     Taxes - Factor Employment Tax Revenue
 ISEP(trad_comm,prod_comm,kk,dir) Protection Intermediate Input Subsidies
 MFRV(trad_comm,kk,kk)            Protection MFA Export Subsidy Equivalent
 OSEP(trad_comm,kk)               Protection Ordinary Output Subsidies
 POP(kk)                          Population
 PURV(trad_comm,kk,kk)            Protn Price Undertaking Export Subsidy Equiv
 SAVE(kk)                         Savings Net Expenditure at Agents Prices
 TFRV(trad_comm,kk,kk)            Protection Ordinary Import Duty
 TVOM(trad_comm,kk)               sales of domestic product at market prices
 VDEP(kk)                         Capital Stock Value of Depreciation
 VDFA(trad_comm,prod_comm,kk)     Intermed Firms Dom Purchases at Agent Prices
 VDFM(trad_comm,prod_comm,kk)     Intermed Firms Dom Purchases at Mkt Prices
 VDGA(trad_comm,kk)               Government Dom Purchases at Agents Prices
 VDGM(trad_comm,kk)               Government Dom Purchases at Market Prices
 VDPA(trad_comm,kk)               Private Hhold Dom Purchases at Agents Prices
 VDPM(trad_comm,kk)               Private Hhold Dom Purchases at Market Prices
 VFM(endw_comm,prod_comm,kk)      Endowments Firms Purchases at Market Prices
 VIFA(trad_comm,prod_comm,kk)     Intermed Firms Imports at Agents Prices
 VIFM(trad_comm,prod_comm,kk)     Intermed Firms Imports at Market Prices
 VIGA(trad_comm,kk)               Government Imports at Agents Prices
 VIGM(trad_comm,kk)               Government Imports at Market Prices
 VIMS(trad_comm,kk,kk)            Trade Bilateral Imports at Market Prices
 VIPA(trad_comm,kk)               Private Households Imports at Agents Prices
 VIPM(trad_comm,kk)               Private Households Imports at Market Prices
 VIWS(trad_comm,kk,kk)            Trade Bilateral Imports at World Prices
 VKB(kk)                          Capital Stock Value at Beginning-of-Period
 VRRV(trad_comm,kk,kk)            Protection VER Export Subsidy Equivalent
 VST(marg_comm,kk)                Trade Exports Internatl Trans Mkt Prices
 VTWR(marg_comm,trad_comm,kk,kk)  Trade Margins Internatl Trans World Prices
 VXMD(trad_comm,kk,kk)            Trade Bilateral Exports at Market Prices
 VXWD(trad_comm,kk,kk)            Trade Bilateral Exports at World Prices
 XTRV(trad_comm,kk,kk)            Protection Ordinary Export Subsidy

* PAYD(dec,pys,trad_comm,kk)       Domestic support payments of different types bases in millions of USD
 VTSS(tar,trad_comm,kk,kk)        Value of Imports in World Prices + Specific & AdValorem tariff revenue


* Trade Margins Related
 VST1(dcc,kk)         Exports for internatl transportation at mkt prices

* Depeciation by factor
 DEPREC(ff,kk)        Depreciation charges by factor

* Values of Components of Domestic production
 VDM(dcc,kk)          Domestic output dc sold domestically by region k

* Global SAM

 SAMG(ss,ss,kk)       Social accounting matrices for regions k

* Other parameters

 IDbase(aa,aa)        identity matrix for creation
 ID(aa,dcc)           identity matrix

   ;

*############## 5. CONVERT GTAP DATA TO GDX ##############################

* Data are rendered readable by GAMS using HAR2GDX

* NB After the first time this programme is run the HAR2GDX CALL statement
*    can be turned off since basedata.gdx has been written to disk.

$CALL har2gdx   basedata.har    basedata.gdx

*############## 6. LOADING SETS ##########################################

* Data are read in from a *.gdx file

$GDXIN basedata.gdx
* Sets from GTAP database
$LOAD GlobalSet
$LOAD trad_comm
$LOAD kk = reg
$LOAD endw_comm
$LOAD prod_comm
$LOAD dir
$LOAD marg_comm
*$LOAD dec = decoupling
$LOAD tar = tartype
*$LOAD pys = allpayt

$GDXIN

*$ontext

Display  GlobalSet, trad_comm, kk, endw_comm, prod_comm, dir, marg_comm
   ;
*$offtext

option decimals = 6 ;

* SETS are read in from an Excel file

$CALL "GDXXRW i=data_gtp_9_pr1_11.xlsx o=data_in.gdx INDEX=LAYOUT!A4"

$GDXIN data_in.gdx

$LOADdc ss mcc dcc aa ff
$LOADdc tmmtax tmsstax teetax smmtax sddtax fftax
$LOADdc otppmarg wtppmarg atppmarg vsttmarg
$LOADdc ww
$LOADdc ii
*$LOAD kk
$LOADdc a2

$LOADdc rr
$LOADdc MAPIMP MAPDOM MAPVST MAPPROD MAPACT MAPINV MAPTRAD
$LOADdc MAPTMTAX MAPTETAX
$LOADdc MAPOTPMARG MAPWTPMARG MAPATPMARG
$LOADdc MAPSDTAX MAPSMTAX MAPFACT MAPFTAX MAPDCC_AA

$LOADdc MAPREG MAPREG2 MAPREG3 MAPREG4 MAPREG5 MAPCOM mapaa_trad

$LOADdc map_tmss_tmm

*$LOADdc maptmmavtaxtmmtax maptmmasptaxtmmtax


$GDXIN

* Other Sets

* SAM Accounts excluding totals
 SSN(ss)       = YES ;
 SSN("TTOTAL")  = NO ;

* Setting up ALIASES

 ALIAS(ss,ssp), (ssn,ssnp),
      (mcc,mccp), (dcc,dccp),
      (aa,aap), (a2,aa2),
      (ff,ffp,endow_comm),
      (tmmtax,tmmtaxp), (tmsstax,tmsstaxp),
      (teetax,teetaxp),
      (smmtax,smmtaxp), (sddtax,sddtaxp), (sddtax,sddtaxp),
      (fftax,p),
      (otppmarg,otppmargp), (wtppmarg,wtppmargp), (atppmarg,atppmargp),
      (vsttmarg,vsttmargp),
      (ww,wwp), (kk,kkp,regp), (rr,rrp,rrpp)
 ;

* Other data

 IDbase(aa,aap)$DIAG(aa,aap)  = 1 ;

 ID(aa,dcc)          = SUM(aap
                        $MAPDCC_AA(dcc,aap),
                        IDbase(aa,aap)) ;

DISPLAY IDbase, ID ;

*############## 7. LOADING DATA FOR GTAP SAM #############################

* Data are read in from a *.gdx file

$GDXIN basedata.gdx

* Parameters from GTAP database

$LOAD EVFA EVOA
$LOAD SAVE
$LOAD VDEP VDFA VDFM VDGA VDGM VDPA VDPM
$LOAD VFM
$LOAD VIFA VIFM VIGA VIGM VIPA VIPM VIMS VIWS
$LOAD VST
$LOAD VTWR
$LOAD VXMD VXWD

* Unloaded parameters (loaded later)
$ontext
$LOAD ADRV
$LOAD DPSM
$LOAD FBEP ISEP MFRV OSEP PURV TFRV VRRV
$LOAD VKB
$LOAD XTRV
$offtext

$GDXIN

*$ontext
DISPLAY EVFA,  EVOA,  SAVE,
        VDEP,  VDFA,  VDFM,  VDGA,  VDGM,  VDPA,  VDPM,  VFM,   VIFA,
        VIFM,  VIGA,  VIGM,  VIPA,  VIPM,  VIMS,  VIWS,  VST,
        VTWR,  VXMD,  VXWD
   ;
*$offtext

option decimals = 6 ;

* ### ROUNDING READ IN DATA
* Rounding all read in data to 6 decimal places
* The GTAP database only records data to 6 decimal places

 SAVE(kk)                         = ROUND(SAVE(kk),6) ;
 VDGA(trad_comm,kk)               = ROUND(VDGA(trad_comm,kk),6) ;
 VDGM(trad_comm,kk)               = ROUND(VDGM(trad_comm,kk),6) ;
 VIGA(trad_comm,kk)               = ROUND(VIGA(trad_comm,kk),6) ;
 VIGM(trad_comm,kk)               = ROUND(VIGM(trad_comm,kk),6) ;
 VDPA(trad_comm,kk)               = ROUND(VDPA(trad_comm,kk),6) ;
 VDPM(trad_comm,kk)               = ROUND(VDPM(trad_comm,kk),6) ;
 VIPA(trad_comm,kk)               = ROUND(VIPA(trad_comm,kk),6) ;
 VIPM(trad_comm,kk)               = ROUND(VIPM(trad_comm,kk),6) ;
 VDFA(trad_comm,prod_comm,kk)     = ROUND(VDFA(trad_comm,prod_comm,kk),6) ;
 VDFM(trad_comm,prod_comm,kk)     = ROUND(VDFM(trad_comm,prod_comm,kk),6) ;
 VIFA(trad_comm,prod_comm,kk)     = ROUND(VIFA(trad_comm,prod_comm,kk),6) ;
 VIFM(trad_comm,prod_comm,kk)     = ROUND(VIFM(trad_comm,prod_comm,kk),6) ;
 VFM(endw_comm,prod_comm,kk)      = ROUND(VFM(endw_comm,prod_comm,kk),6) ;
 EVFA(endw_comm,prod_comm,kk)     = ROUND(EVFA(endw_comm,prod_comm,kk),6) ;
 EVOA(endw_comm,kk)               = ROUND(EVOA(endw_comm,kk),6) ;
 VDEP(kk)                         = ROUND(VDEP(kk),6) ;
 VXMD(trad_comm,kk,kkp)           = ROUND(VXMD(trad_comm,kk,kkp),6) ;
 VXWD(trad_comm,kk,kkp)           = ROUND(VXWD(trad_comm,kk,kkp),6) ;
 VIMS(trad_comm,kkp,kk)           = ROUND(VIMS(trad_comm,kkp,kk),6) ;
 VIWS(trad_comm,kkp,kk)           = ROUND(VIWS(trad_comm,kkp,kk),6) ;
 VST(marg_comm,kk)                = ROUND(VST(marg_comm,kk),6) ;
 VTWR(marg_comm,trad_comm,kkp,kk) = ROUND(VTWR(marg_comm,trad_comm,kkp,kk),6) ;

*############## 8. RELABELLING THE GTAP DATA ###########################

*####### GTAP parameters coefficients read by GTAP.TAB v 6.1 ###########

* Trade Margins Related

 VST1(dcc,kk)        = SUM(marg_comm
                        $MAPVST(dcc,marg_comm),
                        VST(marg_comm,kk)) ;

* Depeciation by factor

 DEPREC("ffcapital",kk)
                    = VDEP(kk) ;

* Values of Components of Domestic production

 VDM(dcc,kk)         = SUM(trad_comm
                       $MAPDOM(dcc,trad_comm),
                       VDPM(trad_comm,kk))
                         + SUM(trad_comm
                           $MAPDOM(dcc,trad_comm),
                           VDGM(trad_comm,kk))
                             + SUM(aa, SUM((trad_comm,prod_comm)
                                       $(MAPDOM(dcc,trad_comm)
                                       $MAPACT(aa,prod_comm)),
                                       VDFM(trad_comm,prod_comm,kk)))
                               + SUM((trad_comm,prod_comm)
                                 $(MAPDOM(dcc,trad_comm)
                                 $MAPINV("kkap",prod_comm)),
                                 VDFM(trad_comm,prod_comm,kk)) ;

*############## 9. CREATING THE GLOBAL SAM ###########################
* Submatrices are added by rows of the SAM
* Number in brackets (x:y) indicate row (x) and column (y) in the SAM

*#### Import commodity income components

* Import Intermediate Use matrices (1:3)

 SAMG(mcc,aa,kk)        = SUM((trad_comm,prod_comm)
                          $(MAPIMP(mcc,trad_comm)
                          $MAPACT(aa,prod_comm)),
                          VIFM(trad_comm,prod_comm,kk)) ;

* Household import demand vectors (1:6)

 SAMG(mcc,"hhous",kk)   = SUM(trad_comm
                          $MAPIMP(mcc,trad_comm),
                          VIPM(trad_comm,kk)) ;

* Government import demand vectors (1:13)

 SAMG(mcc,"ggovt",kk)   = SUM(trad_comm
                          $MAPIMP(mcc,trad_comm),
                          VIGM(trad_comm,kk)) ;

* Investment import demand vectors (1:14)

 SAMG(mcc,ii,kk)        = SUM((trad_comm,prod_comm)
                          $(MAPIMP(mcc,trad_comm)
                          $MAPINV(ii,prod_comm)),
                          VIFM(trad_comm,prod_comm,kk)) ;

*#### Domestic commodity income components

* Domestic Intermediate Use matrices (2:3)

 SAMG(dcc,aa,kk)        = SUM((trad_comm,prod_comm)
                          $(MAPDOM(dcc,trad_comm)
                          $MAPACT(aa,prod_comm)),
                          VDFM(trad_comm,prod_comm,kk)) ;

* Household domestic demand vectors (2:6)

 SAMG(dcc,"hhous",kk)   = SUM(trad_comm
                          $MAPDOM(dcc,trad_comm),
                          VDPM(trad_comm,kk)) ;

* Export taxes

 SAMG(teetax,dcc,kk)    = SUM((trad_comm,kkp)
                          $(MAPDOM(dcc,trad_comm)
                          $MAPTETAX(teetax,kkp)),
                          VXWD(trad_comm,kk,kkp))
                              - SUM((trad_comm,kkp)
                                $(MAPDOM(dcc,trad_comm)
                                $MAPTETAX(teetax,kkp)),
                                VXMD(trad_comm,kk,kkp)) ;

* Government domestic demand vectors (2:13)

 SAMG(dcc,"ggovt",kk)   = SUM(trad_comm
                          $MAPDOM(dcc,trad_comm),
                          VDGM(trad_comm,kk)) ;

* Investment domestic demand vectors (2:14)

 SAMG(dcc,ii,kk)           = SUM((trad_comm,prod_comm)
                             $(MAPDOM(dcc,trad_comm)
                             $MAPINV(ii,prod_comm)),
                             VDFM(trad_comm,prod_comm,kk)) ;

* Export demand matrices (2:16)
* Export of transport services

 SAMG("ddotp","otppvst",kk)     = VST1("ddotp",kk) ;
 SAMG("ddwtp","wtppvst",kk)     = VST1("ddwtp",kk) ;
 SAMG("ddatp","atppvst",kk)     = VST1("ddatp",kk) ;

* Exports of Goods and Services

 SAMG(dcc,ww,kk)           = SUM((trad_comm,kkp)
                             $(MAPDOM(dcc,trad_comm)
                             $MAPTRAD(ww,kkp)),
                             VXWD(trad_comm,kk,kkp)) ;

*#### Activity Income

* Make Matrix (3:2)

 SAMG(aa,dcc,kk)    = (VDM(dcc,kk) + VST1(dcc,kk)
                              + SUM(ww,SUM((trad_comm,kkp)
                                $(MAPDOM(dcc,trad_comm)
                                $MAPTRAD(ww,kkp)),
                                VXMD(trad_comm,kk,kkp))))
                          * ID(aa,dcc) ;

*#### Factor Income

* Factor demands by activities (4:3)

 SAMG(ff,aa,kk)            = SUM((endw_comm,prod_comm)
                             $(MAPFACT(ff,endw_comm)
                             $MAPACT(aa,prod_comm)),
                             VFM(endw_comm,prod_comm,kk)) ;

*#### Indirect Tax Receipts for INDTAX(r) in GTAP model

* Import Duty Income (7:1)

 SAMG(tmmtax,mcc,kk)      = SUM((trad_comm,kkp)
                            $(MAPIMP(mcc,trad_comm)
                            $MAPTMTAX(tmmtax,kkp)),
                            VIMS(trad_comm,kkp,kk))
                                  - SUM((trad_comm,kkp)
                                    $(MAPIMP(mcc,trad_comm)
                                    $MAPTMTAX(tmmtax,kkp)),
                                    VIWS(trad_comm,kkp,kk)) ;

*# Import Sales Taxes

* Intermediate Inputs (8:3)

 SAMG(smmtax,aa,kk)      = SUM(mcc
                           $MAPSMTAX(smmtax,mcc),
                             SUM((trad_comm,prod_comm)
                             $(MAPIMP(mcc,trad_comm)
                             $MAPACT(aa,prod_comm)),
                             VIFA(trad_comm,prod_comm,kk)))
                                - SUM(mcc
                                  $MAPSMTAX(smmtax,mcc),
                                    SUM((trad_comm,prod_comm)
                                    $(MAPIMP(mcc,trad_comm)
                                    $MAPACT(aa,prod_comm)),
                                    VIFM(trad_comm,prod_comm,kk))) ;

* Household Demand (9:6)

 SAMG(smmtax,"hhous",kk) = SUM(mcc
                           $MAPSMTAX(smmtax,mcc),
                             SUM(trad_comm
                             $MAPIMP(mcc,trad_comm),
                             VIPA(trad_comm,kk)))
                               - SUM(mcc
                                 $MAPSMTAX(smmtax,mcc),
                                   SUM(trad_comm
                                   $MAPIMP(mcc,trad_comm),
                                   VIPM(trad_comm,kk))) ;

* Government Demand (9:13)

 SAMG(smmtax,"ggovt",kk) = SUM(mcc
                           $MAPSMTAX(smmtax,mcc),
                             SUM(trad_comm
                             $MAPIMP(mcc,trad_comm),
                             VIGA(trad_comm,kk)))
                               - SUM(mcc
                                 $MAPSMTAX(smmtax,mcc),
                                   SUM(trad_comm
                                   $MAPIMP(mcc,trad_comm),
                                   VIGM(trad_comm,kk))) ;

* Investment Demand (9:14)

 SAMG(smmtax,ii,kk)      = SUM(mcc
                           $MAPSMTAX(smmtax,mcc),
                             SUM((trad_comm,prod_comm)
                             $(MAPIMP(mcc,trad_comm)
                             $MAPINV(ii,prod_comm)),
                             VIFA(trad_comm,prod_comm,kk)))
                               - SUM(mcc
                                 $MAPSMTAX(smmtax,mcc),
                                   SUM((trad_comm,prod_comm)
                                   $(MAPIMP(mcc,trad_comm)
                                   $MAPINV(ii,prod_comm)),
                                   VIFM(trad_comm,prod_comm,kk))) ;

*# Domestic Sales Taxes

* Intermediate Inputs (8:3)

 SAMG(sddtax,aa,kk)      = SUM(dcc
                           $MAPSDTAX(sddtax,dcc),
                             SUM((trad_comm,prod_comm)
                             $(MAPDOM(dcc,trad_comm)
                             $MAPACT(aa,prod_comm)),
                             VDFA(trad_comm,prod_comm,kk)))
                                - SUM(dcc
                                  $MAPSDTAX(sddtax,dcc),
                                    SUM((trad_comm,prod_comm)
                                    $(MAPDOM(dcc,trad_comm)
                                    $MAPACT(aa,prod_comm)),
                                    VDFM(trad_comm,prod_comm,kk))) ;

* Household Demand (8:6)

 SAMG(sddtax,"hhous",kk) = SUM(dcc
                           $MAPSDTAX(sddtax,dcc),
                             SUM(trad_comm
                             $MAPDOM(dcc,trad_comm),
                             VDPA(trad_comm,kk)))
                                - SUM(dcc
                                  $MAPSDTAX(sddtax,dcc),
                                    SUM(trad_comm
                                    $MAPDOM(dcc,trad_comm),
                                    VDPM(trad_comm,kk))) ;

* Government Demand (8:13)

 SAMG(sddtax,"ggovt",kk) = SUM(dcc
                           $MAPSDTAX(sddtax,dcc),
                             SUM(trad_comm
                             $MAPDOM(dcc,trad_comm),
                             VDGA(trad_comm,kk)))
                                - SUM(dcc
                                  $MAPSDTAX(sddtax,dcc),
                                    SUM(trad_comm
                                    $MAPDOM(dcc,trad_comm),
                                    VDGM(trad_comm,kk))) ;

* Investment Demand (8:14)

 SAMG(sddtax,ii,kk)     = SUM(dcc
                          $MAPSDTAX(sddtax,dcc),
                            SUM((trad_comm,prod_comm)
                            $(MAPDOM(dcc,trad_comm)
                            $MAPINV(ii,prod_comm)),
                            VDFA(trad_comm,prod_comm,kk)))
                               - SUM(dcc
                                 $MAPSDTAX(sddtax,dcc),
                                   SUM((trad_comm,prod_comm)
                                   $(MAPDOM(dcc,trad_comm)
                                   $MAPINV(ii,prod_comm)),
                                   VDFM(trad_comm,prod_comm,kk))) ;

* Factor taxes paid by activities

* Factor taxes paid by activities

 SAMG(fftax,aa,kk)        = SUM((endw_comm,prod_comm)
                            $(MAPFTAX(fftax,endw_comm)
                            $MAPACT(aa,prod_comm)),
                            EVFA(endw_comm,prod_comm,kk))
                               - SUM((endw_comm,prod_comm)
                                 $(MAPFTAX(fftax,endw_comm)
                                 $MAPACT(aa,prod_comm)),
                                 VFM(endw_comm,prod_comm,kk)) ;

* Production taxes paid by activity

 SAMG("pprodtax",aa,kk)  = SUM(dcc,SAMG(aa,dcc,kk)) -
                           (SUM(mcc,SUM((trad_comm,prod_comm)
                                    $(MAPIMP(mcc,trad_comm)
                                    $MAPACT(aa,prod_comm)),
                                    VIFA(trad_comm,prod_comm,kk)))
                           + SUM(dcc,SUM((trad_comm,prod_comm)
                                     $(MAPDOM(dcc,trad_comm)
                                     $MAPACT(aa,prod_comm)),
                                     VDFA(trad_comm,prod_comm,kk)))
                           + SUM(ff,SUM((endw_comm,prod_comm)
                                     $(MAPFACT(ff,endw_comm)
                                     $MAPACT(aa,prod_comm)),
                                     EVFA(endw_comm,prod_comm,kk))) ) ;


* Factor Income Taxes (12:4)

 SAMG("ddirtax",ff,kk)   = SUM(aa,SUM((endw_comm,prod_comm)
                           $(MAPFACT(ff,endw_comm)
                           $MAPACT(aa,prod_comm)),
                           VFM(endw_comm,prod_comm,kk)))
                              - SUM(endw_comm
                                $MAPFACT(ff,endw_comm),
                                EVOA(endw_comm,kk)) ;

*#### Components of Regional Household Income

* Factor Incomes after depreciation (5:4)

 SAMG("rreghous",ff,kk)      = SUM(endw_comm
                               $MAPFACT(ff,endw_comm),
                               EVOA(endw_comm,kk))
                                   - DEPREC(ff,kk) ;

* Import duties and export taxes (5:7)

 SAMG("rreghous",tmmtax,kk)  = SUM(mcc,SAMG(tmmtax,mcc,kk)) ;

 SAMG("rreghous",teetax,kk)  = SUM(dcc,SAMG(teetax,dcc,kk)) ;

* Domestic Sales taxes (5:8)

 SAMG("rreghous",sddtax,kk)  = SUM(aa, SAMG(sddtax,aa,kk))
                              + SAMG(sddtax,"hhous",kk)
                              + SAMG(sddtax,"ggovt",kk)
                              + SAMG(sddtax,"kkap",kk) ;

* Import Sales taxes (5:9)

 SAMG("rreghous",smmtax,kk)  = SUM(aa,SAMG(smmtax,aa,kk))
                              + SAMG(smmtax,"hhous",kk)
                              + SAMG(smmtax,"ggovt",kk)
                              + SAMG(smmtax,"kkap",kk) ;

* Production Taxes (5:11)

 SAMG("rreghous","pprodtax",kk)
                         = SUM(aa,SAMG("pprodtax",aa,kk)) ;

* Factor Use Taxes

 SAMG("rreghous",fftax,kk)   =  SUM(aa,SAMG(fftax,aa,kk)) ;

* Direct Taxes (5:12)
 SAMG("rreghous","ddirtax",kk)  =  SUM(ff,SAMG("ddirtax",ff,kk)) ;

*#### Components of Regional Household Expenditure

* Income of Private Households (6:5)

 SAMG("hhous","RREGHOUS",kk) = SUM(mcc,SAMG(mcc,"hhous",kk))
                              + SUM(smmtax,SAMG(smmtax,"hhous",kk))
                              + SUM(dcc,SAMG(dcc,"hhous",kk))
                              + SUM(sddtax,SAMG(sddtax,"hhous",kk))  ;

* Income of Government (13:5)
 SAMG("ggovt","RREGHOUS",kk) = SUM(mcc,SAMG(mcc,"ggovt",kk))
                              + SUM(smmtax,SAMG(smmtax,"ggovt",kk))
                              + SUM(dcc,SAMG(dcc,"ggovt",kk))
                              + SUM(sddtax,SAMG(sddtax,"ggovt",kk))  ;

* Domestic Savings (14:5)

 SAMG("kkap","RREGHOUS",kk)  = SAVE(kk) ;

*#### Capital Account Income

* Depreciation charges (14:4)

 SAMG("kkap","ffcapital",kk) = VDEP(kk) ;

*#### Rest of World

* Import Margin Matrices (15:1)

 SAMG(OTPPMARG,mcc,kk)    = SUM((trad_comm,kkp)
                            $(MAPIMP(mcc,trad_comm)
                            $MAPOTPMARG(otppmarg,kkp)),
                            VTWR("otp",trad_comm,kkp,kk)) ;

 SAMG(wtppmarg,mcc,kk)    = SUM((trad_comm,kkp)
                            $(MAPIMP(mcc,trad_comm)
                            $MAPWTPMARG(wtppmarg,kkp)),
                            VTWR("wtp",trad_comm,kkp,kk)) ;

 SAMG(atppmarg,mcc,kk)    = SUM((trad_comm,kkp)
                            $(MAPIMP(mcc,trad_comm)
                            $MAPATPMARG(atppmarg,kkp)),
                            VTWR("atp",trad_comm,kkp,kk)) ;

*## Import Supply Matrices (16:1)

* Direct method
$ontext
 SAMG(ww,mcc,kk)          = SUM((trad_comm,kkp)
                             $(MAPIMP(mcc,trad_comm)
                             $MAPTRAD(ww,kkp)),
                             VIWS(trad_comm,kkp,kk))
                                - SUM(marg_comm,SUM((trad_comm,kkp)
                                  $(MAPIMP(mcc,trad_comm)
                                  $MAPTRAD(ww,kkp)),
                                  VTWR(marg_comm,trad_comm,kkp,kk)))  ;
$offtext

* Indirect Method using Exports fob

Parameter
 SAMExports1(mcc,ww,rr)    Exports of commod mcc to region ww by region rr
 SAMExports2(mcc,kk,rr)    Exports of commod mcc to region kk by region rr
 SAMExports3(mcc,kk,ww)    Exports of commod mcc to region kk by region ww

 ExportsCHK(dcc,ww,kk)     Check on Exports data
 ImportsCHK(ww,mcc,kk)     Check on Imports data

 ;

 SAMExports1(mcc,ww,rr) = SUM((dcc,kk)
                          $(MAPCOM(mcc,dcc)
                          $MAPREG(rr,kk)),
                          SAMG(dcc,ww,kk)) ;

 SAMExports2(mcc,kk,rr)  = SUM(ww
                           $MAPREG4(kk,ww),
                           SAMExports1(mcc,ww,rr)) ;

 SAMExports3(mcc,kk,ww)  = SUM(rr
                           $MAPREG5(ww,rr),
                           SAMExports2(mcc,kk,rr)) ;

 SAMG(ww,mcc,kk)         = SAMExports3(mcc,kk,ww) ;

 ExportsCHK(dcc,ww,kk)  = SAMG(dcc,ww,kk) ;

 ImportsCHK(ww,mcc,kk)  = SAMG(ww,mcc,kk) ;

Display ExportsCHK, ImportsCHK ;

Execute_unload 'trade_data_CHK.gdx', ExportsCHK, ImportsCHK ;

* Expenditures on transport services

 SAMG("otppvst",otppmarg,kk)  = SUM(mcc,SAMG(otppmarg,mcc,kk)) ;
 SAMG("wtppvst",wtppmarg,kk)  = SUM(mcc,SAMG(wtppmarg,mcc,kk)) ;
 SAMG("atppvst",atppmarg,kk)  = SUM(mcc,SAMG(atppmarg,mcc,kk)) ;

*### Capital Account Balances
* Capital Account balance for trade in transport services

 SAMG("kkap","otppvst",kk)  = SUM((mcc,otppmarg),SAMG(otppmarg,mcc,kk))
                               - SUM(dcc,SAMG(dcc,"otppvst",kk)) ;

 SAMG("kkap","wtppvst",kk)  = SUM((mcc,wtppmarg),SAMG(wtppmarg,mcc,kk))
                               - SUM(dcc,SAMG(dcc,"wtppvst",kk)) ;

 SAMG("kkap","atppvst",kk)  = SUM((mcc,atppmarg),SAMG(atppmarg,mcc,kk))
                               - SUM(dcc,SAMG(dcc,"atppvst",kk)) ;

* Capital Account balances by trade partner on commodity trade

 SAMG("kkap",ww,kk)       = SUM(mcc,SAMG(ww,mcc,kk))
                             - SUM(dcc,SUM((trad_comm,kkp)
                                       $(MAPDOM(dcc,trad_comm)
                                       $MAPTRAD(ww,kkp)),
                                       VXWD(trad_comm,kk,kkp))) ;

*#### Rounding the Global SAM to 6 Decimal Places
* The GTAP database only records data to 6 decimal places

 SAMG(ss,ssp,kk)      = ROUND(SAMG(ss,ssp,kk),6) ;

*DISPLAY SAMG ;

*############## 10. CHECKING THE GLOBAL SAM ###########################

* This checking of the Global SAM is important.
* The definition of 'errors' in the GTAP database is likely to differ
* according to the perspective of the user, e.g., small differences MAY not
* be an issue for some users/software.

* The approach here is to report absolute and proportionate differences
* across a range of cases.

*#### Checking that Exports fob equal Imports fob
* This check is critical since it impacts upon all subsequent routines
* All entries in TradeCHK must be ZERO

* TRADECAL

Parameter
 Exports(mcc,ww,rr)    Exports of commod mcc to region ww by region rr
 Imports1(rr,mcc,kk)   Imports from region rr of commod mcc by region kk
 Imports2(rr,mcc,ww)   Imports from region rr of commod mcc by region ww

 TradeCHK(mcc,ww,rr)   Difference between imports and exports

 TraderrorCNT          Count on errors between Imports and exports fob

 ;

 Exports(mcc,ww,rr)  = SUM((dcc,kk)
                       $(MAPCOM(mcc,dcc)
                       $MAPREG(rr,kk)),
                       SAMG(dcc,ww,kk)) ;

 Imports1(rr,mcc,kk) = SUM(ww
                       $MAPREG2(rr,ww),
                       SAMG(ww,mcc,kk)) ;

 Imports2(rr,mcc,ww) = SUM(kk
                       $MAPREG3(ww,kk),
                       Imports1(rr,mcc,kk)) ;

 TradeCHK(mcc,ww,rr) = Exports(mcc,ww,rr) - Imports2(rr,mcc,ww) ;

option decimals = 8 ;

DISPLAY  Exports, Imports1, Imports2 ;
DISPLAY  TradeCHK ;

 TraderrorCNT  = SUM((mcc,ww,rr)$(TradeCHK(mcc,ww,rr) > 0.0000000001), 1) ;

Display TraderrorCNT ;

 ABORT$(TraderrorCNT GT 0.0)
         "IMPORTS fob and EXPORTS fob ARE NOT IDENTICAL" ;

*#### Computing Account totals for Global SAM by Region

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;

 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

Set
 step    steps for counts of big total and percentage differences   /
 stgt5        > 5 total OR percentage difference according to case
 stgt1        > 1 total OR percentage difference according to case
 stgt05       > 0.5 total OR percentage difference according to case
 stgt01       > 0.1 total OR percentage difference according to case
 stgt001      > 0.01 total OR percentage difference according to case
 stgt0001     > 0.001 total OR percentage difference according to case
 stgt00001    > 0.0001 total OR percentage difference according to case
 stgt000001   > 0.00001 total OR percentage difference according to case
 stgt0000001  > 0.000001 total OR percentage difference according to case
  /

 case   number of cases in each step  /
 case1      Differences in Account totals
 case2      Differences in Account percentages
 case3      Differences in Account totals AND percentages
  /
  ;

Parameter

 COLTOT(*,kk)       Check on region column totals
 ROWTOT(kk,*)       Check on region row totals
 DIFFTOT(*,kk)      Check on difference in region column and row totals
 BIGDIFFTOT(*,kk)   BIG (>0.01) difference in region column and row totals
 SUMDIFFTOT(kk)     Sum of differences in region row and column totals
 DIFFPER(*,kk)      Percentage differences in region column and row totals
 BIGDIFFPER(*,kk)   BIG (>0.01) Percentage diffs in region column and row totals

 DIFTOTPERCNT(step,case)  Counts of big total and percentage differences

 ;

 COLTOT(ssnp,kk)    = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 ROWTOT(kk,ssn)     = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 DIFFTOT(ssnp,kk)   = COLTOT(ssnp,kk) - ROWTOT(kk,ssnp) ;

 DIFFTOT(ssnp,kk)   = ROUND(DIFFTOT(ssnp,kk),6 ) ;

 BIGDIFFTOT(ssnp,kk)$(ABS(DIFFTOT(ssnp,kk) GT 0.01)) = DIFFTOT(ssnp,kk) ;

 SUMDIFFTOT(kk)     = SUM(ssnp,DIFFTOT(ssnp,kk)) ;

 DIFFPER(ssnp,kk)$COLTOT(ssnp,kk)
       = (DIFFTOT(ssnp,kk)/(0.5 * (COLTOT(ssnp,kk) + ROWTOT(kk,ssnp)))) * 100 ;

 DIFFPER(ssnp,kk)   = ROUND(DIFFPER(ssnp,kk),6 ) ;

 BIGDIFFPER(ssnp,kk)$(ABS(DIFFPER(ssnp,kk) GT 0.01)) = DIFFPER(ssnp,kk) ;

* Counting big total and percentage differences

 DIFTOTPERCNT("stgt5","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 5), 1) ;
 DIFTOTPERCNT("stgt1","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 1), 1) ;
 DIFTOTPERCNT("stgt05","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.5), 1) ;
 DIFTOTPERCNT("stgt01","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.1), 1) ;
 DIFTOTPERCNT("stgt001","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.01), 1) ;
 DIFTOTPERCNT("stgt0001","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.001), 1) ;
 DIFTOTPERCNT("stgt00001","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.0001), 1) ;
 DIFTOTPERCNT("stgt000001","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.00001), 1) ;
 DIFTOTPERCNT("stgt0000001","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.000001), 1) ;

 DIFTOTPERCNT("stgt5","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 5), 1) ;
 DIFTOTPERCNT("stgt1","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 1), 1) ;
 DIFTOTPERCNT("stgt05","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.5), 1) ;
 DIFTOTPERCNT("stgt01","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.1), 1) ;
 DIFTOTPERCNT("stgt001","case2")
                      = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.01), 1) ;
 DIFTOTPERCNT("stgt0001","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.001), 1) ;
 DIFTOTPERCNT("stgt00001","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.0001), 1) ;
 DIFTOTPERCNT("stgt000001","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.00001), 1) ;
 DIFTOTPERCNT("stgt0000001","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.000001), 1) ;

 DIFTOTPERCNT("stgt5","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 5)
                              AND (DIFFPER(ssn,kk) > 5)), 1) ;
 DIFTOTPERCNT("stgt1","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 1)
                              AND (DIFFPER(ssn,kk) > 1)), 1) ;
 DIFTOTPERCNT("stgt05","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.5)
                              AND (DIFFPER(ssn,kk) > 0.5)), 1) ;
 DIFTOTPERCNT("stgt01","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.1)
                              AND (DIFFPER(ssn,kk) > 0.1)),  1) ;
 DIFTOTPERCNT("stgt001","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.01)
                              AND (DIFFPER(ssn,kk) > 0.01)),  1) ;
 DIFTOTPERCNT("stgt0001","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.001)
                              AND (DIFFPER(ssn,kk) > 0.001)),  1) ;
 DIFTOTPERCNT("stgt00001","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.0001)
                              AND (DIFFPER(ssn,kk) > 0.0001)),  1) ;
 DIFTOTPERCNT("stgt000001","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.00001)
                              AND (DIFFPER(ssn,kk) > 0.00001)),  1) ; ;
 DIFTOTPERCNT("stgt0000001","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.000001)
                              AND (DIFFPER(ssn,kk) > 0.000001)),  1) ;

option decimals = 6 ;

DISPLAY COLTOT, ROWTOT, DIFFTOT, BIGDIFFTOT,
        DIFFPER, BIGDIFFPER,
        DIFTOTPERCNT ;

*## Writing out the results to GDX
*$ontext

Execute_Unload  'gtptots.gdx',  SAMG
                                COLTOT
                                ROWTOT
                                DIFFTOT
                                DIFFPER
                                BIGDIFFTOT
                                BIGDIFFPER
                                DIFTOTPERCNT ;

*$offtext

* Identifying the MAX and MIN transactions for each Region

PARAMETER
 MAXTV(kk)        Max absolute value of transactions in SAM by region
 MINTV(kk)        Min absolute value of transactions in SAM by region ;

 MAXTV(kk)    = SMAX((SSN,SSNP),ABS (SAMG(SSN,SSNP,kk))) ;
 MINTV(kk)    = SMIN((SSN,SSNP)$SAMG(SSN,SSNP,kk),ABS (SAMG(SSN,SSNP,kk))) ;

 DISPLAY MAXTV, MINTV ;

*## Writing out the results to GDX
*$ontext

Execute_Unload  'gtpmxmin.gdx', MAXTV
                                MINTV ;

*$offtext

*############## 11. ADDITIONAL DATA FROM GTAP ########################

*#### SATELLITE TAX DATA

$ontext
* Parameters from HAR file
* Protection based
 FBEP(endw_comm,prod_comm,kk)     Protection Factor-Based Subsidies
 ISEP(trad_comm,prod_comm,kk,dir) Protection Intermediate Input Subsidies
 MFRV(trad_comm,kk,kk)            Protection MFA Export Subsidy Equivalent
 OSEP(trad_comm,kk)               Protection Ordinary Output Subsidies
 TFRV(trad_comm,kk,kk)            Protection Ordinary Import Duty
 XTRV(trad_comm,kk,kk)            Protection Ordinary Export Subsidy
 FTRV(endw_comm,prod_comm,kk)     Taxes - Factor Employment Tax Revenue

 PAYD(dec,pys,trad_comm,kk)       Domestic support payments of different types bases in millions of USD
 VTSS(tar,trad_comm,kk,kk)        Value of Imports in World Prices + Specific & AdValorem tariff revenue

* Parameters of no interest
 DPSM(kk)                         Sum Distn Parameters in Hhold Demand System

* Empty HAR files
 ADRV(trad_comm,kk,kk)            Protection Anti-Dumping Duty
 PURV(trad_comm,kk,kk)            Protn Price Undertaking Export Subsidy Equiv
 VRRV(trad_comm,kk,kk)            Protection VER Export Subsidy Equivalent
$offtext

Parameter

* Factor based
 FacSubs(ff,aa,kk)      Factor-Based Subsidies by activity and region
 FacEmpTax(ff,aa,kk)    Factor Employment Tax Revenue

* Activity based
 OutSubs(dcc,kk)         Ordinary Output Subsidies

* Intermediate Input based
 IntInSubsM(mcc,aa,kk)  Imported intermediate input subsidies
 IntInSubsD(dcc,aa,kk)  Domestic intermediate input subsidies

* Export based
 MFASubs(dcc,ww,kk)     MFA Export Subsidy Equivalents
 OrdXSub(dcc,ww,kk)     Ordinary Export subsidies

* Import based
 OrdMDuty(ww,mcc,kk)    Ordinary Import duties

   ;


$GDXIN basedata.gdx

$LOAD FBEP ISEP MFRV OSEP TFRV XTRV FTRV

$GDXIN

Display FBEP, ISEP, MFRV, OSEP, TFRV, XTRV, FTRV  ;

*##### Assigning satellite tax data

* Factor based

 FacSubs(ff,aa,kk)    = SUM((endw_comm,prod_comm)
                         $(MAPFACT(ff,endw_comm)
                         $MAPACT(aa,prod_comm)),
                         FBEP(endw_comm,prod_comm,kk)) ;

 FacEmpTax(ff,aa,kk)  = SUM((endw_comm,prod_comm)
                         $(MAPFACT(ff,endw_comm)
                         $MAPACT(aa,prod_comm)),
                         FTRV(endw_comm,prod_comm,kk)) ;

* Activity based

 OutSubs(dcc,kk)       = SUM(trad_comm
                         $MAPDOM(dcc,trad_comm),
                         OSEP(trad_comm,kk)) ;

* Intermediate Input based

 IntInSubsM(mcc,aa,kk) = SUM((trad_comm,prod_comm)
                         $(MAPIMP(mcc,trad_comm)
                         $MAPACT(aa,prod_comm)),
                         ISEP(trad_comm,prod_comm,kk,"imported")) ;

 IntInSubsD(dcc,aa,kk) = SUM((trad_comm,prod_comm)
                         $(MAPDOM(dcc,trad_comm)
                         $MAPACT(aa,prod_comm)),
                         ISEP(trad_comm,prod_comm,kk,"domestic")) ;

* Export based

 MFASubs(dcc,ww,kk)   = SUM((trad_comm,kkp)
                         $(MAPDOM(dcc,trad_comm)
                         $MAPTRAD(ww,kkp)),
                         MFRV(trad_comm,kk,kkp)) ;

 OrdXSub(dcc,ww,kk)   = SUM((trad_comm,kkp)
                         $(MAPDOM(dcc,trad_comm)
                         $MAPTRAD(ww,kkp)),
                         XTRV(trad_comm,kk,kkp)) ;

* Import based

 OrdMDuty(ww,mcc,kk)  = SUM((trad_comm,kkp)
                         $(MAPIMP(mcc,trad_comm)
                         $MAPTRAD(ww,kkp)),
                         TFRV(trad_comm,kk,kkp)) ;

Display  FacSubs, FacEmpTax,
         OutSubs,
         IntInSubsM, IntInSubsD,
         MFASubs, OrdXSub, OrdMDuty ;

*#### DOMESTIC SALES

Parameter
 TVOM(TRAD_COMM,KK)     sales of domestic product at market prices
 TVOM2(dcc,kk)            sales of domestic product at market prices

 ;

$GDXIN basedata.gdx

$LOAD TVOM

$GDXIN

Display  TVOM ;

* Assigning domestic sales data

 TVOM2(dcc,kk) = SUM(TRAD_COMM
                $MAPDOM(dcc,trad_comm),
                TVOM(TRAD_COMM,KK)) ;

Display TVOM2 ;

*#### POPULATION DATA

$ontext
* Parameters from HAR file
 POP(KK)                          Population
$offtext

Parameter
 POPn(kk)              Population

   ;


$GDXIN basedata.gdx

$LOAD POP

$GDXIN

Display  POP ;


* Assigning population tax data

 POPn(kk)     = POP(kk) ;

Display POPn ;

*#### CAPITAL STOCK DATA

$ontext
* Parameters from HAR file
 VKB(KK)                          Capital Stock Value at Beginning-of-Period
$offtext

Parameter

 Kstoc(kk)             Value of capital stock at beginning of period

   ;

$GDXIN basedata.gdx

$LOAD VKB

$GDXIN

Display  VKB ;

* Assigning capital stock data

 Kstoc(kk)     = VKB(kk) ;

Display Kstoc ;

*#### GTAP ELASTICITIES DATA

* HAR file parameters

Parameter

 ESBV(PROD_COMM)     CES between primary factors in production
 ESUBVA(aa)          CES between primary factors in production

 ESBD(TRAD_COMM)     Armington CES for domestic_imported allocation
 ESUBD(mcc)          Armington CES for domestic_imported allocation

 ESBM(TRAD_COMM)     Armington CES for regional allocation of imports
 ESUBM(mcc)          Armington CES for regional allocation of imports

 SUBP(TRAD_COMM,kk)  CDE substitution parameter
 SUBCDE(dcc,kk)  CDE substitution parameter

 INCP(TRAD_COMM,kk)  CDE expansion parameter
 INCCDE(dcc,kk)  CDE expansion parameter

 ESBT(PROD_COMM)     Elasticity of intermediate input substitution
 ESUBT(aa)           Elasticity of intermediate input substitution

 ETRE(ENDW_COMM)     CET between sectors for sluggish primary factors
 ETRAE(ff)           CET between sectors for sluggish primary factors

 RFLX(kk)            Expected rate of return flexibility parameter

   ;

Parameter
 elastexist     if gtap elasticity data exist equals 1 ;

$IF exist default.har   elastexist = 1

Display elastexist ;

$IF exist default.har $CALL har2gdx   default.har    elastdata.gdx

$IF exist elastdata.gdx   $GDXIN elastdata.gdx

$IF exist elastdata.gdx   $LOAD ESBV = ESUBVA
$IF exist elastdata.gdx   $LOAD ESBD = ESUBD
$IF exist elastdata.gdx   $LOAD ESBM = ESUBM

$IF exist elastdata.gdx   $LOAD SUBP = SUBPAR
$IF exist elastdata.gdx   $LOAD INCP = INCPAR
$IF exist elastdata.gdx   $LOAD ESBT = ESUBT
$IF exist elastdata.gdx   $LOAD ETRE = ETRAE
$IF exist elastdata.gdx   $LOAD RFLX = RORFLEX

$IF exist elastdata.gdx   $GDXIN

IF(elastexist = 1,

DISPLAY ESBV, ESBD, ESBM, SUBP, INCP, ESBT, ETRE, RFLX ;

* Assigning elasticities

 ESUBVA(aa)     = SUM(PROD_COMM
                      $MAPACT(aa,PROD_COMM),
                      ESBV(PROD_COMM)) ;

 ESUBD(mcc)     = SUM(TRAD_COMM
                      $MAPIMP(mcc,TRAD_COMM),
                      ESBD(TRAD_COMM)) ;

 ESUBM(mcc)     = SUM(TRAD_COMM
                      $MAPIMP(mcc,TRAD_COMM),
                      ESBM(TRAD_COMM)) ;

DISPLAY ESUBVA, ESUBD, ESUBM ;


 SUBCDE(dcc,kk) = SUM(TRAD_COMM
                      $MAPDOM(dcc,TRAD_COMM),
                      SUBP(TRAD_COMM,kk)) ;

 INCCDE(dcc,kk) = SUM(TRAD_COMM
                      $MAPDOM(dcc,TRAD_COMM),
                      INCP(TRAD_COMM,kk)) ;

 ESUBT(aa)      = SUM(PROD_COMM
                      $MAPACT(aa,PROD_COMM),
                      ESBT(PROD_COMM)) ;

 ETRAE(ff)      = SUM(ENDW_COMM
                      $MAPFACT(ff,ENDW_COMM),
                      ETRE(ENDW_COMM)) ;

* END of IF
  ) ;

*#### GTAP ENERGY DATA


Parameter
 gsdexist     if gtap energy data exist equals 1 ;

$IF exist gsdvole.har   gsdexist = 1

Display gsdexist ;

Parameter

 EDF(en,prod_comm,kk)       usage of domestic product by firms Mtoe
 EDG(en,kk)                 government consumption of domestic product Mtoe
 EDP(en,kk)                 private consumption of domestic product Mtoe

 EIF(en,prod_comm,kk)       usage of imports by firms Mtoe
 EIG(en,kk)                 government consumption of imports Mtoe
 EIP(en,kk)                 private consumption of imports Mtoe

 EXI(en,kk,kk)              volume of trade Mtoe

 EVolDA(en,a2,kk)        volume of input domestic purchases by activities (Mtoe)
 EVolDH(en,kk)           volume of domestic purchases by households (Mtoe)
 EVolDG(en,kk)           volume of domestic purchases by government (Mtoe)
 EVolDI(en,kk)           volume of domestic purchases by investment (Mtoe)

 EVolIA(en,a2,kk)        volume of input import purchases by activities (Mtoe)
 EVolIH(en,kk)           volume of import purchases by households (Mtoe)
 EVolIG(en,kk)           volume of import purchases by government (Mtoe)
 EVolII(en,kk)           volume of import purchases by investment (Mtoe)

 EVolT(en,kk,kk)        volume of bilateral trade (Mtoe)

   ;

$IF exist gsdvole.har $CALL har2gdx   gsdvole.har    gsdvole.gdx

$IF exist gsdvole.gdx   $GDXIN gsdvole.gdx

$IF exist gsdvole.gdx   $LOAD en = erg_comm

$IF exist gsdvole.gdx   $LOAD EDF = EDF
$IF exist gsdvole.gdx   $LOAD EDG = EDG
$IF exist gsdvole.gdx   $LOAD EDP = EDP

$IF exist gsdvole.gdx   $LOAD EIF = EIF
$IF exist gsdvole.gdx   $LOAD EIG = EIG
$IF exist gsdvole.gdx   $LOAD EIP = EIP

$IF exist gsdvole.gdx   $LOAD EXI = EXIDAG

$IF exist gsdvole.gdx   $GDXIN


IF(gsdexist = 1,

* Domestic purchases
 EVolDA(en,a2,kk)   = SUM(prod_comm
                         $MAPPROD(a2,prod_comm),
                         EDF(en,prod_comm,kk)) ;

 EVolDA(en,"aacgds",kk)   = 0.0 ;

 EVolDH(en,kk)      = EDP(en,kk) ;

 EVolDG(en,kk)      = EDG(en,kk) ;

 EVolDI(en,kk)      = EDF(en,"CGDS",kk) ;

*Import purchases
 EVolIA(en,a2,kk)   = SUM(prod_comm
                         $MAPPROD(a2,prod_comm),
                         EIF(en,prod_comm,kk)) ;

 EVolIA(en,"aacgds",kk)   = 0.0 ;

 EVolIH(en,kk)      = EIP(en,kk) ;

 EVolIG(en,kk)      = EIG(en,kk) ;

 EVolII(en,kk)      = EIF(en,"CGDS",kk) ;

* Trade Volumes
 EVolT(en,kk,kkp)   = EXI(en,kk,kkp) ;


DISPLAY en, EDF, EDG, EDP, EIF, EIG, EIP, EXI,
        EVolDA, EVolDH, EVolDG, EVolDI,
        EVolIA, EVolIH, EVolIG, EVolII,
        EVolT ;

* END of IF
  ) ;


*#### GTAP EMISSIONS DATA

Set
 fuel_comm(*)     energy commodities for emissions data ;

Parameter
 co2exist     if gtap emission data exist equals 1 ;

$IF exist co2.har   co2exist = 1

Display co2exist ;

Parameter

 MDF2(en,prod_comm,kk)    emissions from domestic product in current production Mt CO2
 MDA(en,a2,kk)    emissions from domestic product in current production Mt CO2
 MDG(en,kk)       emissions from govt consumption of domestic product Mt CO2
 MDH(en,kk)       emissions from private consumption of domestic product Mt CO2
 MDI(en,kk)       emissions from investment consumption of domestic product Mt CO2

 MIF2(en,prod_comm,kk)    emissions from imports in current production Mt CO2
 MIA(en,a2,kk)    emissions from imports in current production Mt CO2
 MIG(en,kk)       emissions from government consumption of imports Mt CO2
 MIH(en,kk)       emissions from private consumption of imports Mt CO2
 MII(en,kk)       emissions from investment consumption of imports Mt CO2

  ;


$IF exist co2.har $CALL har2gdx   co2.har    co2.gdx

$IF exist co2.gdx   $GDXIN co2.gdx

$IF exist co2.gdx   $LOAD  fuel_comm

$IF exist co2.gdx   $LOAD  MDF2 = MDF
$IF exist co2.gdx   $LOAD  MDG = MDG
$IF exist co2.gdx   $LOAD  MDH = MDP
$IF exist co2.gdx   $LOAD  MIF2 = MIF
$IF exist co2.gdx   $LOAD  MIG = MIG
$IF exist co2.gdx   $LOAD  MIH = MIP

$IF exist co2.gdx   $GDXIN

 MDA(en,a2,kk)   = SUM(prod_comm
                         $MAPPROD(a2,prod_comm),
                         MDF2(en,prod_comm,kk)) ;

 MDA(en,"aacgds",kk)   = 0.0 ;

 MDI(en,kk)      =  MDF2(en,"CGDS",kk) ;

 MIA(en,a2,kk)   = SUM(prod_comm
                         $MAPPROD(a2,prod_comm),
                         MIF2(en,prod_comm,kk)) ;

 MII(en,kk)      = MIF2(en,"CGDS",kk) ;

Display MDF2, MDA, MDG, MDH, MDI, MIF2, MIA, MIG, MIH, MII ;

*#### GTAP PROTECTION DATA

$ontext
Parameter
* Protection based
 FBEP(endw_comm,prod_comm,kk)     Protection Factor-Based Subsidies
 FTRV(endw_comm,prod_comm,kk)     Taxes - Factor Employment Tax Revenue

 ISEP(trad_comm,prod_comm,kk,dir) Protection Intermediate Input Subsidies
 OSEP(trad_comm,kk)               Protection Ordinary Output Subsidies

 XTRV(trad_comm,kk,kk)            Protection Ordinary Export Subsidy
 MFRV(trad_comm,kk,kk)            Protection MFA Export Subsidy Equivalent

 TFRV(trad_comm,kk,kk)            Protection Ordinary Import Duty
 VITSS(tar,trad_comm,kk,kk)       Value of Imports in World Prices + Specific & AdValorem tariff revenue

 ;
$offtext

Parameter
 VTSS2(tar,tmmtax,mcc,kk)     Value of Imports in World Prices + Specific & AdValorem tariff revenue

 TM_REVCHK(tmmtax,mcc,kk)     CHECK on trade tax revenues

 CNT_TM_REVHK1                COUNT on TM_REVCHK diff > 0.000001
 CNT_TM_REVHK2                COUNT on TM_REVCHK diff > 0.00001
 CNT_TM_REVHK3                COUNT on TM_REVCHK diff > 0.0001
 CNT_TM_REVHK4                COUNT on TM_REVCHK diff > 0.001
 CNT_TM_REVHK5                COUNT on TM_REVCHK diff > 0.01

  ;


$GDXIN basedata.gdx
* Sets from GTAP database

$LOADdc VTSS = TFRVSA

$GDXIN

 VTSS2(tar,tmmtax,mcc,kk)   = SUM((trad_comm,kkp)
                              $(MAPIMP(mcc,trad_comm)
                              $MAPTMTAX(tmmtax,kkp)),
                               VTSS(tar,trad_comm,kkp,kk)) ;

 TM_REVCHK(tmmtax,mcc,kk)   = SAMG(tmmtax,mcc,kk)
                               -SUM(tar,VTSS2(tar,tmmtax,mcc,kk)) ;

 CNT_TM_REVHK1 = SUM((tmmtax,mcc,kk)$(TM_REVCHK(tmmtax,mcc,kk) > 0.000001), 1 ) ;
 CNT_TM_REVHK2 = SUM((tmmtax,mcc,kk)$(TM_REVCHK(tmmtax,mcc,kk) > 0.00001), 1 ) ;
 CNT_TM_REVHK3 = SUM((tmmtax,mcc,kk)$(TM_REVCHK(tmmtax,mcc,kk) > 0.0001), 1 ) ;
 CNT_TM_REVHK4 = SUM((tmmtax,mcc,kk)$(TM_REVCHK(tmmtax,mcc,kk) > 0.001), 1 ) ;
 CNT_TM_REVHK5 = SUM((tmmtax,mcc,kk)$(TM_REVCHK(tmmtax,mcc,kk) > 0.01), 1 ) ;


Display TM_REVCHK, CNT_TM_REVHK1, CNT_TM_REVHK2, CNT_TM_REVHK3,
                   CNT_TM_REVHK4, CNT_TM_REVHK5 ;

Execute_Unload  'TM_REVCHK.gdx', TM_REVCHK ;

*#### GTAP DOMESTIC AGRICULTURAL SUPPORT DATA
$ontext
Parameter
 PAYD(dec,pys,trad_comm,kk)       Domestic support payments of different types bases in millions of USD

 ;

$GDXIN basedata.gdx
* Sets from GTAP database
$LOAD  PAYD = PAYMENTS

$GDXIN

Display PAYD ;

$offtext

*#### GTAP TIME SERIES TRADE DATA
$ontext

Parameter
 tstexist     if gtap energy data exist equals 1 ;

$IF exist tstrade.har   tstexist = 1

Display tstexist ;

* HAR file parameters
Parameter

 VTTS(TRAD_COMM,kk,kk,tt)    Trade flows between regions
 TSTRAD(dcc,kk,ww,tt)        Trade flows between regions   ;

$IF exist tstrade.har $CALL har2gdx   tstrade.har    tstrade.gdx

$IF exist tstrade.gdx   $GDXIN tstrade.gdx

$IF exist tstrade.gdx   $LOAD VTTS = NTSTRD

$IF exist tstrade.gdx   $GDXIN

IF(tstexist = 1,

 TSTRAD(dcc,kk,ww,tt)  = SUM((TRAD_COMM,kkp)
                             $(MAPDOM(DCC,TRAD_COMM)
                             $MAPTRAD(ww,kkp)),
                             VTTS(TRAD_COMM,kk,kkp,tt)) ;

DISPLAY tt ;
*DISPLAY VTTS ;
*DISPLAY TSTRAD ;

* END of IF
  ) ;
$offtext


*############## 12. VARIANTS OF THE GTAP SAM #########################

Parameter

 SAMG_v1(ss,ss,kk)     Basic GTAP model SAM for regions k

 SAMG_v2(ss,ss,kk)     GTAP SAM with Additional trade tax data for regions k

 ;

*#### 12.1 Basic GTAP SAM

 SAMG_v1(ss,ssp,kk)  = SAMG(ss,ssp,kk) ;

*#### 12.2 Trade tax augmented GTAP SAM

 SAMG_v2(ss,ssp,kk)  = SAMG(ss,ssp,kk) ;

* ## CHECK import duties in transactions SAM v1 are correct

Parameter
 VTSS2_CHK(tmmtax,mcc,kk)    CHECK on Tariffs ;

 VTSS2_CHK(tmmtax,mcc,kk) = SUM(tar,VTSS2(tar,tmmtax,mcc,kk))
                             - SAMG(tmmtax,mcc,kk) ;

Display VTSS2_CHK ;

* ## Assign SPECIFIC import duties

Parameter
 TMMTAX_SPE(tmmtax,mcc,kk)  Specific tariff revenue as residual ;

* Residual calculation

 TMMTAX_SPE(tmmtax,mcc,kk)
                     = SAMG(tmmtax,mcc,kk) - VTSS2("adv",tmmtax,mcc,kk) ;

 SAMG_v2(tmsstax,mcc,kk)
                     = SUM(tmmtax$map_tmss_tmm(tmsstax,tmmtax),
                           TMMTAX_SPE(tmmtax,mcc,kk)) ;
$ontext
* Direct calculation
 SAMG_v2(tmmsptax,mcc,kk)
                     = SUM(tmmtax$map_tmss_tmm(tmsstax,tmmtax),
                          VTSS2("spe",tmmtax,mcc,kk)) ;
$offtext

* ## Derive ad valorem equivalent import duties

 SAMG_v2(tmmtax,mcc,kk)  = 0.0 ;

 SAMG_v2(tmmtax,mcc,kk) = VTSS2("adv",tmmtax,mcc,kk) ;

 SAMG_v2("rreghous",tmmtax,kk)   = SUM(mcc,SAMG_v2(tmmtax,mcc,kk)) ;
 SAMG_v2("rreghous",tmsstax,kk)  = SUM(mcc,SAMG_v2(tmsstax,mcc,kk)) ;

* SAMG_v2("rreghous",tmmtax,kk)    = 0.0 ;

Parameter
 TMM_CHK(mcc,kk)    CHECK on TMTAX ;

 TMM_CHK(mcc,kk)  = SUM(tmmtax,SAMG(tmmtax,mcc,kk))
                      - SUM(tmmtax,SAMG_v2(tmmtax,mcc,kk))
                      - SUM(tmsstax,SAMG_v2(tmsstax,mcc,kk)) ;

Display TMM_CHK ;

*##### CHECK on SAMG_v2 #####

 COLTOT(ssnp,kk)    = SUM(ssn,SAMG_v2(ssn,ssnp,kk)) ;
 ROWTOT(kk,ssn)     = SUM(ssnp,SAMG_v2(ssn,ssnp,kk)) ;

 DIFFTOT(ssnp,kk)   = COLTOT(ssnp,kk) - ROWTOT(kk,ssnp) ;

 DIFFTOT(ssnp,kk)   = ROUND(DIFFTOT(ssnp,kk),6 ) ;

 BIGDIFFTOT(ssnp,kk)$(ABS(DIFFTOT(ssnp,kk) GT 0.01)) = DIFFTOT(ssnp,kk) ;

 SUMDIFFTOT(kk)     = SUM(ssnp,DIFFTOT(ssnp,kk)) ;

 DIFFPER(ssnp,kk)$COLTOT(ssnp,kk)
       = (DIFFTOT(ssnp,kk)/(0.5 * (COLTOT(ssnp,kk) + ROWTOT(kk,ssnp)))) * 100 ;

 DIFFPER(ssnp,kk)   = ROUND(DIFFPER(ssnp,kk),6 ) ;

 BIGDIFFPER(ssnp,kk)$(ABS(DIFFPER(ssnp,kk) GT 0.01)) = DIFFPER(ssnp,kk) ;

* Counting big total and percentage differences

 DIFTOTPERCNT("stgt5","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 5), 1) ;
 DIFTOTPERCNT("stgt1","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 1), 1) ;
 DIFTOTPERCNT("stgt05","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.5), 1) ;
 DIFTOTPERCNT("stgt01","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.1), 1) ;
 DIFTOTPERCNT("stgt001","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.01), 1) ;
 DIFTOTPERCNT("stgt0001","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.001), 1) ;
 DIFTOTPERCNT("stgt00001","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.0001), 1) ;
 DIFTOTPERCNT("stgt000001","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.00001), 1) ;
 DIFTOTPERCNT("stgt0000001","case1")
                        = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 0.000001), 1) ;

 DIFTOTPERCNT("stgt5","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 5), 1) ;
 DIFTOTPERCNT("stgt1","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 1), 1) ;
 DIFTOTPERCNT("stgt05","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.5), 1) ;
 DIFTOTPERCNT("stgt01","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.1), 1) ;
 DIFTOTPERCNT("stgt001","case2")
                      = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.01), 1) ;
 DIFTOTPERCNT("stgt0001","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.001), 1) ;
 DIFTOTPERCNT("stgt00001","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.0001), 1) ;
 DIFTOTPERCNT("stgt000001","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.00001), 1) ;
 DIFTOTPERCNT("stgt0000001","case2")
                        = SUM((ssn,kk)$(DIFFPER(ssn,kk) > 0.000001), 1) ;

 DIFTOTPERCNT("stgt5","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 5)
                              AND (DIFFPER(ssn,kk) > 5)), 1) ;
 DIFTOTPERCNT("stgt1","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 1)
                              AND (DIFFPER(ssn,kk) > 1)), 1) ;
 DIFTOTPERCNT("stgt05","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.5)
                              AND (DIFFPER(ssn,kk) > 0.5)), 1) ;
 DIFTOTPERCNT("stgt01","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.1)
                              AND (DIFFPER(ssn,kk) > 0.1)),  1) ;
 DIFTOTPERCNT("stgt001","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.01)
                              AND (DIFFPER(ssn,kk) > 0.01)),  1) ;
 DIFTOTPERCNT("stgt0001","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.001)
                              AND (DIFFPER(ssn,kk) > 0.001)),  1) ;
 DIFTOTPERCNT("stgt00001","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.0001)
                              AND (DIFFPER(ssn,kk) > 0.0001)),  1) ;
 DIFTOTPERCNT("stgt000001","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.00001)
                              AND (DIFFPER(ssn,kk) > 0.00001)),  1) ; ;
 DIFTOTPERCNT("stgt0000001","case3")
                        = SUM((ssn,kk)$((DIFFTOT(ssn,kk) > 0.000001)
                              AND (DIFFPER(ssn,kk) > 0.000001)),  1) ;

option decimals = 6 ;

DISPLAY COLTOT, ROWTOT, DIFFTOT, BIGDIFFTOT,
        DIFFPER, BIGDIFFPER,
        DIFTOTPERCNT ;

*############## 13. WRITING GTAP DATABASE TO GDX #####################

*#### 13.1 Writing out ALL the GTAP data to GDX

*GTAP SAM database version 9pr1.11

Execute_Unload  'gtpdatav9pr1_11.gdx',
* SAM and associated sets
                                    SAMG_v1
                                    SAMG_v2
                                    ss
                                    mcc
                                    dcc
                                    aa
                                    ff
                                    tmmtax
                                    tmsstax
                                    teetax
                                    smmtax
                                    sddtax
                                    fftax
                                    otppmarg
                                    wtppmarg
                                    atppmarg
                                    vsttmarg
                                    ww
                                    kk
* SATELLITE TAX DATA
                                    FacSubs
                                    FacEmpTax
                                    OutSubs
                                    IntInSubsM
                                    IntInSubsD
                                    MFASubs
                                    OrdXSub
                                    OrdMDuty
* DOMESTIC SALES
                                    TVOM2
* POPULATION DATA
                                    POPn
* CAPITAL STOCK DATA
                                    Kstoc
* Elasticities
                                    ESUBVA
                                    ESUBD
                                    ESUBM
                                    SUBCDE
                                    INCCDE
                                    ESUBT
                                    ETRAE
                                    RFLX
* Energy and emission data and associated set
                                    EVolDA
                                    EVolDH
                                    EVolDG
                                    EVolDI
                                    EVolIA
                                    EVolIH
                                    EVolIG
                                    EVolII
                                    EVolT
                                    MDA
                                    MDG
                                    MDH
                                    MDI

                                    MIA
                                    MIG
                                    MIH
                                    MII
                                    en
* GTAP protection data
                                    VTSS2
* GTAP domestic agricultural support data
*                                    PAYD
* Time series trade data and associated set
*                                    TSTRAD
*                                    tt
 ;

Parameter
 SAM_1(ss,ss)             Sample SAM for checking
 SAM_2(ss,ss)             Sample SAM for checking ;


 SAM_1(ss,ssp)        = SAMG_v1(ss,ssp,"deu") ;
 SAM_2(ss,ssp)        = SAMG_v2(ss,ssp,"deu") ;

Execute_Unload  'gtpdata_samplesam',
             SAM_1
             SAM_2

  ;

*########################### THE END ########################
