*#################### BALANCING SAMG #################################
$ontext
*##### Balancing the GLOBE Region Accounts

* Assigning exports to GLOBE of margins as equal to imports by GLOBE

 SAMG("ddotp","wwglo",kkn)       = SUM(wwn$map_kk_ww(kkn,wwn),SAMG("mmotp",wwn,"glo")) ;
 SAMG("ddwtp","wwglo",kkn)       = SUM(wwn$map_kk_ww(kkn,wwn),SAMG("mmwtp",wwn,"glo")) ;
 SAMG("ddatp","wwglo",kkn)       = SUM(wwn$map_kk_ww(kkn,wwn),SAMG("mmatp",wwn,"glo")) ;

* This section is hard coded and relies on identifying a regions to aborb
* the imbalances in margin trade

 SAMG("ddotp","mmotp","glo") = -1.0 * SUM(ww,SAMG("ddotp",ww,"glo")) ;
 SAMG("ddwtp","mmwtp","glo") = -1.0 * SUM(ww,SAMG("ddwtp",ww,"glo")) ;
 SAMG("ddatp","mmatp","glo") = -1.0 * SUM(ww,SAMG("ddatp",ww,"glo")) ;

 SAMG("ttotal",ssnp,kk) = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 SAMG(ssn,"ttotal",kk)  = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 DIFFTOT(ssnp,kk)   = SAMG("ttotal",ssnp,kk) - SAMG(ssnp,"ttotal",kk) ;

Parameter
 DIFFTOT3(ss,kk) ;
 DIFFTOT3(ss,kk) = DIFFTOT(ss,kk) ;

Display DIFFTOT3 ;


 SAMG("wwkor","mmotp","glo")  = SAMG("wwkor","mmotp","glo") - DIFFTOT("mmotp","glo") ;
 SAMG("wwkor","mmwtp","glo")  = SAMG("wwkor","mmwtp","glo") - DIFFTOT("mmwtp","glo") ;
 SAMG("wwkor","mmatp","glo")  = SAMG("wwkor","mmatp","glo") - DIFFTOT("mmatp","glo") ;

* Adjusting exports of margin G&S

 SAMG("ddotp","wwglo","kor")  = SAMG("wwkor","mmotp","glo") ;
 SAMG("ddwtp","wwglo","kor")  = SAMG("wwkor","mmwtp","glo") ;
 SAMG("ddatp","wwglo","kor")  = SAMG("wwkor","mmatp","glo") ;

 SAMG("ttotal",ssnp,kk) = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 SAMG(ssn,"ttotal",kk)  = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 DIFFTOT(ssnp,kk)   = SAMG("ttotal",ssnp,kk) - SAMG(ssnp,"ttotal",kk) ;

$ontext
Parameter
 DIFFTOT2(ss,kk) ;
 DIFFTOT2(ss,kk) = DIFFTOT(ss,kk) ;

Display DIFFTOT2 ;

*$offtext

* Recomputing GLOBE trade balances

 SAMG("ii_s",ww,"glo")   = {SAMG(ww,"mmotp","glo") + SAMG(ww,"mmwtp","glo")
                             + SAMG(ww,"mmatp","glo")}
                            - {SAMG("ddotp",ww,"glo") + SAMG("ddwtp",ww,"glo")
                               + SAMG("ddatp",ww,"glo")} ;

 SAMG("ttotal",ssnp,kk) = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 SAMG(ssn,"ttotal",kk)  = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 DIFFTOT(ssnp,kk)   = SAMG("ttotal",ssnp,kk) - SAMG(ssnp,"ttotal",kk) ;

Parameter
 DIFFTOT2(ss,kk) ;
 DIFFTOT2(ss,kk) = DIFFTOT(ss,kk) ;

Display DIFFTOT2 ;

 SAMG("ii_s","wwglo",kkn)  = -1.0 * SUM(wwn$map_kk_ww(kkn,wwn),SAMG("ii_s",wwn,"glo")) ;

Display DIFFTOT ;

$offtext

*##### Balancing Commodity Accounts
* This is achieved by assigning the difference between row and col total to 'ddstoc'

 SAMG(mmc,"ddstoc",kkn)   = DIFFTOT(mmc,kkn) ;

 SAMG(ddc,"ddstoc",kkn)   = DIFFTOT(ddc,kkn) ;

 SAMG("ttotal",ssnp,kkn) = SUM(ssn,SAMG(ssn,ssnp,kkn)) ;
 SAMG(ssn,"ttotal",kkn)  = SUM(ssnp,SAMG(ssn,ssnp,kkn)) ;

 DIFFTOT(ssnp,kkn)   = SAMG("ttotal",ssnp,kkn) - SAMG(ssnp,"ttotal",kkn) ;

option decimals = 4 ;

Display DIFFTOT ;

*##### Balancing Activity Accounts
* This is achieved by assigning the difference between row and col total to 'ff_kap'

Parameter
 CHK_act_bal(aa,kk)      Check that payment to Capital GT DIFFTOT
 CHK_act_bal_cnt         COUNT on Check that payment to Capital GT DIFFTOT
 ;

 CHK_act_bal(aa,kkn)$[DIFFTOT(aa,kkn) GT SAMG("ffkap",aa,kkn)] = 1 ;



 CHK_act_bal_cnt   = SUM{(aa,kkn)$[CHK_act_bal(aa,kkn) ne 0.0 ], 1 } ;

 ABORT$(CHK_act_bal_cnt GT 0.0) "ERROR ADJUST VIA ff_kap DOES NOT WORK" ;

Display CHK_act_bal, CHK_act_bal_cnt ;

 SAMG("ffkap",aa,kkn)   =  SAMG("ffkap",aa,kkn) - DIFFTOT(aa,kkn) ;

 SAMG("ttotal",ssnp,kkn) = SUM(ssn,SAMG(ssn,ssnp,kkn)) ;
 SAMG(ssn,"ttotal",kkn)  = SUM(ssnp,SAMG(ssn,ssnp,kkn)) ;

 DIFFTOT(ssnp,kkn)   = SAMG("ttotal",ssnp,kkn) - SAMG(ssnp,"ttotal",kkn) ;

Display DIFFTOT ;

*##### Balancing Factor Accounts
* This is achieved by assigning the difference between row and col total
* to 'dirtax', which adds a factor income tax.
* It is worth keeping a factor income tax in the model just in case GTAP
* decides to assign household income tax payment to the private household.

 SAMG("ddirtax",ff,kkn)   = SAMG("ddirtax",ff,kkn) - DIFFTOT(ff,kkn) ;

 SAMG("ggovt","ddirtax",kkn)   =  SAMG("ggovt","ddirtax",kkn)
                                 + SUM(ff,SAMG("ddirtax",ff,kkn)) ;

 SAMG("ttotal",ssnp,kkn) = SUM(ssn,SAMG(ssn,ssnp,kkn)) ;
 SAMG(ssn,"ttotal",kkn)  = SUM(ssnp,SAMG(ssn,ssnp,kkn)) ;

 DIFFTOT(ssnp,kkn)   = SAMG("ttotal",ssnp,kkn) - SAMG(ssnp,"ttotal",kkn) ;

 DIFFTOT(ssn,kkn)   = ROUND(DIFFTOT(ssn,kkn),6 ) ;

Display DIFFTOT ;

*##### Balancing Sales tax accounts

 SAMG("ggovt",ttsm,kkn)  = SAMG("ggovt",ttsm,kkn) - DIFFTOT(ttsm,kkn) ;

 SAMG("ggovt",ttsd,kkn)  = SAMG("ggovt",ttsd,kkn) - DIFFTOT(ttsd,kkn) ;

*##### Balancing the factor use tax accounts

 SAMG("ggovt",ttff,kkn)   = SUM(aa,SAMG(ttff,aa,kkn)) ;

 SAMG("ttotal",ssnp,kkn) = SUM(ssn,SAMG(ssn,ssnp,kkn)) ;
 SAMG(ssn,"ttotal",kkn)  = SUM(ssnp,SAMG(ssn,ssnp,kkn)) ;

 DIFFTOT(ssnp,kkn)   = SAMG("ttotal",ssnp,kkn) - SAMG(ssnp,"ttotal",kkn) ;

 DIFFTOT(ssn,kkn)   = ROUND(DIFFTOT(ssn,kkn),6 ) ;

Display DIFFTOT ;

*##### Balancing the margin accounts
$ontext

 SAMG("ootppvst",ootpm,kkn)  = SAMG("ootppvst",ootpm,kkn) - DIFFTOT(ootpm,kkn) ;
 SAMG("wwtppvst",wwtpm,kkn)  = SAMG("wwtppvst",wwtpm,kkn) - DIFFTOT(wwtpm,kkn) ;
 SAMG("aatppvst",aatpm,kkn)  = SAMG("aatppvst",aatpm,kkn) - DIFFTOT(aatpm,kkn) ;

 SAMG("ttotal",ssnp,kkn) = SUM(ssn,SAMG(ssn,ssnp,kkn)) ;
 SAMG(ssn,"ttotal",kkn)  = SUM(ssnp,SAMG(ssn,ssnp,kkn)) ;

 DIFFTOT(ssnp,kkn)   = SAMG("ttotal",ssnp,kkn) - SAMG(ssnp,"ttotal",kkn) ;

$offtext
*##### Balancing the trade accounts

* SAMG("ii_s",vvst,kkn)  = SAMG("ii_s",vvst,kkn) - DIFFTOT(vvst,kkn) ;

 SAMG("ii_s",ww,kkn)  = SAMG("ii_s",ww,kkn) - DIFFTOT(ww,kkn) ;

 SAMG("ttotal",ssnp,kkn) = SUM(ssn,SAMG(ssn,ssnp,kkn)) ;
 SAMG(ssn,"ttotal",kkn)  = SUM(ssnp,SAMG(ssn,ssnp,kkn)) ;

 DIFFTOT(ssnp,kkn)   = SAMG("ttotal",ssnp,kkn) - SAMG(ssnp,"ttotal",kkn) ;

 DIFFTOT(ssn,kkn)   = ROUND(DIFFTOT(ssn,kkn),6 ) ;

Display DIFFTOT ;


*##### Balancing the production tax accounts

* Delete payment of production taxes on investment

 SAMG("pprodtax","ii_s",kkn)  = 0.0 ;

 SAMG("ggovt","pprodtax",kkn) = SUM(aa,SAMG("pprodtax",aa,kkn)) ;

 SAMG("ttotal",ssnp,kkn) = SUM(ssn,SAMG(ssn,ssnp,kkn)) ;
 SAMG(ssn,"ttotal",kkn)  = SUM(ssnp,SAMG(ssn,ssnp,kkn)) ;

 DIFFTOT(ssnp,kkn)   = SAMG("ttotal",ssnp,kkn) - SAMG(ssnp,"ttotal",kkn) ;

 DIFFTOT(ssn,kkn)   = ROUND(DIFFTOT(ssn,kkn),6 ) ;

Display DIFFTOT ;

*##### Balancing the Household accounts
* Balancing through the savings account

 SAMG("ii_s","hhous",kkn)  = SAMG("ii_s","hhous",kkn) - DIFFTOT("hhous",kkn) ;

 SAMG("ttotal",ssnp,kkn) = SUM(ssn,SAMG(ssn,ssnp,kkn)) ;
 SAMG(ssn,"ttotal",kkn)  = SUM(ssnp,SAMG(ssn,ssnp,kkn)) ;

 DIFFTOT(ssnp,kkn)   = SAMG("ttotal",ssnp,kkn) - SAMG(ssnp,"ttotal",kkn) ;

 DIFFTOT(ssn,kkn)   = ROUND(DIFFTOT(ssn,kkn),6 ) ;

Display DIFFTOT ;

*##### Funding Stock Changes (ddstoc)

 SAMG("ddstoc","ii_s",kkn)  = SUM(mmc,SAMG(mmc,"ddstoc",kkn))
                                + SUM(ddc,SAMG(ddc,"ddstoc",kkn)) ;

 SAMG("ttotal",ssnp,kkn) = SUM(ssn,SAMG(ssn,ssnp,kkn)) ;
 SAMG(ssn,"ttotal",kkn)  = SUM(ssnp,SAMG(ssn,ssnp,kkn)) ;

 DIFFTOT(ssnp,kkn)   = SAMG("ttotal",ssnp,kkn) - SAMG(ssnp,"ttotal",kkn) ;

 DIFFTOT(ssn,kkn)   = ROUND(DIFFTOT(ssn,kkn),6 ) ;

Display DIFFTOT ;

*##### Balancing the Government and Investment_Savings accounts

 SAMG("ii_s","ggovt",kkn)  = SAMG("ii_s","ggovt",kkn) - DIFFTOT("ggovt",kkn) ;

 SAMG("ttotal",ssnp,kkn) = SUM(ssn,SAMG(ssn,ssnp,kkn)) ;
 SAMG(ssn,"ttotal",kkn)  = SUM(ssnp,SAMG(ssn,ssnp,kkn)) ;

 DIFFTOT(ssnp,kkn)   = SAMG("ttotal",ssnp,kkn) - SAMG(ssnp,"ttotal",kkn) ;

 DIFFTOT(ssn,kkn)   = ROUND(DIFFTOT(ssn,kkn),6 ) ;

Display DIFFTOT ;


$INCLUDE include\chk_samg.inc

Display "END of glbsam_bal" ;