*############## 5. SAMG_1 for Standard GLOBE v1 ##########


*##### Initialise  SAMG_1
* This will be purged at the end of this include file

 SAMG_1(ss,ssp,kk) = SAMG_B(ss,ssp,kk) ;


*------- 5a. Creating SAMG from GTAP in a SAM
$ontext

This stage creates a SAM under the implicit assumption that a law of
one price held in the base GTAP data.

$offtext

*###### REVALUING COMMODITIES AT PURCHASER PRICES

*#### Import commodity income components

* Import Intermediate and Final Demand Use matrices (1:3; 1:6; 1:13; 1:14)

 SAMG_1(mmc,ss,kkn)       = SAMG_1(mmc,ss,kkn) +  SMTAX(mmc,ss,kkn) ;

*#### Domestic commodity income components

* Domestic Intermediate and Final Demand Use matrices (2:3; 2:6; 2:13; 2:14)

 SAMG_1(ddc,ss,kkn)       =  SAMG_1(ddc,ss,kkn) + SDTAX(ddc,ss,kkn) ;

*#### Deleting commodity specific sales taxes

*# Import Sales Taxes  (9:3; 9:6; 9:13; 9:14)

 SAMG_1(ttsm,ss,kkn)    = 0.0 ;

*# Domestic Sales Taxes

* Intermediate Inputs (8:3; 8:6; 8:13; 8:14)

 SAMG_1(ttsd,ss,kkn)    = 0.0 ;

*## Total Sales Taxes Revenues with common Sales Tax rates
* On imported commodities

 SAMG_1("ssaltax",mmc,kkn)  =  SUM(aa,SMTAX(mmc,aa,kkn))
                                + {SMTAX(mmc,"hhous",kkn)
                                  + SMTAX(mmc,"ggovt",kkn)
                                  + SMTAX(mmc,"ii_s",kkn)} ;

* On domestic commodities

 SAMG_1("ssaltax",ddc,kkn)  =  SUM(aa,SDTAX(ddc,aa,kkn))
                                + {SDTAX(ddc,"hhous",kkn)
                                  + SDTAX(ddc,"ggovt",kkn)
                                  + SDTAX(ddc,"ii_s",kkn)} ;


* Income of Government from TAXES (13:5)

 SAMG_1("ggovt","ssaltax",kkn)   = SUM(mmc,SAMG_1("ssaltax",mmc,kkn))
                                 + SUM(ddc,SAMG_1("ssaltax",ddc,kkn)) ;

 SAMG_1("ggovt",ttsm,kk)         = 0.0 ;
 SAMG_1("ggovt",ttsd,kk)         = 0.0 ;

*####### Aggregating the IMPORT and DOMESTIC commodity accounts

* Rows
 SAMG_1(cc,ss,kk)         = SUM{mmc$map_cc_mmc(cc,mmc),SAMG_1(mmc,ss,kk)}
                            + SUM{ddc$map_cc_ddc(cc,ddc),SAMG_1(ddc,ss,kk)} ;

* Column
 SAMG_1(ss,cc,kk)         = SUM{mmc$map_cc_mmc(cc,mmc),SAMG_1(ss,mmc,kk)}
                            + SUM{ddc$map_cc_ddc(cc,ddc),SAMG_1(ss,ddc,kk)} ;

* Deleting Import and Domestic commodity rows and columns

 SAMG_1(mmc,ss,kk) = 0.0 ;
 SAMG_1(ddc,ss,kk) = 0.0 ;
 SAMG_1(ss,mmc,kk) = 0.0 ;
 SAMG_1(ss,ddc,kk) = 0.0 ;


*##### Aggregating Ad Valorem and Specific Import duty rates

 SAMG_1(ttm,ss,kk)  = SAMG_1(ttm,ss,kk)
                      + SUM{ttms$map_ttm_ttms(ttm,ttms),SAMG_1(ttms,ss,kk)} ;

 SAMG_1(ss,ttm,kk)  = SAMG_1(ss,ttm,kk)
                      + SUM{ttms$map_ttm_ttms(ttm,ttms),SAMG_1(ss,ttms,kk)} ;

 SAMG_1("ggovt",ttm,kk)   = SUM(cc,SAMG_1(ttm,cc,kk)) ;

* Deleting Specific Import Duties

 SAMG_1(ttms,ss,kk)  = 0.0 ;
 SAMG_1(ss,ttms,kk)  = 0.0 ;

* Cleaning out intra agent TVs in GLOBE region account

 SAMG_1("ccotp","ccotp","glo") = 0.0 ;
 SAMG_1("ccwtp","ccwtp","glo") = 0.0 ;
 SAMG_1("ccatp","ccatp","glo") = 0.0 ;

* This check also recomputes the row and column totals


$INCLUDE include\chk_samg_1.inc

* Assigning SAMG

 SAMG(ss,ssp,kk)    = SAMG_1(ss,ssp,kk) ;

*############# SATELLITE ACCOUNT DATA




Execute_unload 'GLB_output\glb_samg_v1.gdx',
*### TRANSACTIONS
 SAMG
*#### POPULATION DATA
 POP
*#### CAPITAL STOCK DATA
 Kstoc
*#### GTAP ELASTICITIES DATA
* Satellite account data
 ESUBVA
 ESUBDC
 ESUBMC
* ImpactEcon LABOUR DATA
* SAM Satelitte Data
 Q_FD
 Q_FS

 ;

 SAMG_1(ss,ssp,kk) = 0.0 ;
 SAMG(ss,ssp,kk)   = 0.0 ;


Display "END of glbsam_glb1" ;








