*############## 5. SAMG_2 for Standard GLOBE V2 ##########

$ontext

This stage creates a SAM under the implicit assumption that a law of
one price held in the base GTAP data.

$offtext

*##### Initialise  SAMG_2
* This will be purged at the end of this include file

 SAMG_2(ss,ssp,kk) = SAMG_B(ss,ssp,kk) ;

*###### REVALUING COMMODITIES AT PURCHASER PRICES

*#### Import commodity income components

* Import Intermediate and Final Demand Use matrices (1:3; 1:6; 1:13; 1:14)

 SAMG_2(mmc,ss,kkn)       = SAMG_2(mmc,ss,kkn) +  SMTAX(mmc,ss,kkn) ;

*#### Domestic commodity income components

* Domestic Intermediate and Final Demand Use matrices (2:3; 2:6; 2:13; 2:14)

 SAMG_2(ddc,ss,kkn)       =  SAMG_2(ddc,ss,kkn) + SDTAX(ddc,ss,kkn) ;

* Deleting commodity specific sales taxes

*# Import Sales Taxes  (9:3; 9:6; 9:13; 9:14)

 SAMG_2(ttsm,ss,kkn)    = 0.0 ;

*# Domestic Sales Taxes

 SAMG_2(ttsd,ss,kkn)    = 0.0 ;

*###### Total Value Added Taxes Revenues on imports
* On imported commodities

 SAMG_2("vvattax",mmc,kkn)  = (tvm2(mmc,kkn) * SAMG_2(mmc,"hhous",kkn)) ;

* On domestic commodities

 SAMG_2("vvattax",ddc,kkn)  = (tvd2(ddc,kkn) * SAMG_2(ddc,"hhous",kkn)) ;

*##### Total Sales Taxes Revenues with common Sales Tax rates
* On imported commodities

 SAMG_2("ssaltax",mmc,kkn)  =  SUM(aa,SMTAX(mmc,aa,kkn))
                            + (SMTAX(mmc,"hhous",kkn)
                                 - (tvm2(mmc,kkn) * SAMG_2(mmc,"hhous",kkn)))
                            + SMTAX(mmc,"ggovt",kkn)
                            + SMTAX(mmc,"ii_s",kkn) ;

* On domestic commodities

 SAMG_2("ssaltax",ddc,kkn)  =  SUM(aa,SDTAX(ddc,aa,kkn))
                            + (SDTAX(ddc,"hhous",kkn)
                                 - (tvd2(ddc,kkn) * SAMG_2(ddc,"hhous",kkn)))
                            + SDTAX(ddc,"ggovt",kkn)
                            + SDTAX(ddc,"ii_s",kkn) ;


* Income of Government from TAXES (13:5)

 SAMG_2("ggovt","vvattax",kkn)   = SUM(mmc,SAMG_2("vvattax",mmc,kkn))
                                   + SUM(ddc,SAMG_2("vvattax",ddc,kkn)) ;

 SAMG_2("ggovt","ssaltax",kkn)   = SUM(mmc,SAMG_2("ssaltax",mmc,kkn))
                                   + SUM(ddc,SAMG_2("ssaltax",ddc,kkn)) ;

 SAMG_2("ggovt",ttsm,kk)         = 0.0 ;
 SAMG_2("ggovt",ttsd,kk)         = 0.0 ;

*####### Aggregating the IMPORT and DOMESTIC commodity accounts

* Rows
 SAMG_2(cc,ss,kk)         = SUM{mmc$map_cc_mmc(cc,mmc),SAMG_2(mmc,ss,kk)}
                            + SUM{ddc$map_cc_ddc(cc,ddc),SAMG_2(ddc,ss,kk)} ;

* Column
 SAMG_2(ss,cc,kk)         = SUM{mmc$map_cc_mmc(cc,mmc),SAMG_2(ss,mmc,kk)}
                            + SUM{ddc$map_cc_ddc(cc,ddc),SAMG_2(ss,ddc,kk)} ;

* Deleting Import and Domestic commodity rows and columns

 SAMG_2(mmc,ss,kk) = 0.0 ;
 SAMG_2(ddc,ss,kk) = 0.0 ;
 SAMG_2(ss,mmc,kk) = 0.0 ;
 SAMG_2(ss,ddc,kk) = 0.0 ;

* Cleaning out intra agent TVs in GLOBE region account

 SAMG_2("ccotp","ccotp","glo") = 0.0 ;
 SAMG_2("ccwtp","ccwtp","glo") = 0.0 ;
 SAMG_2("ccatp","ccatp","glo") = 0.0 ;

* This check also recomputes the row and column totals

$INCLUDE include\chk_samg_2.inc

* Assigning SAMG

 SAMG(ss,ssp,kk)    = SAMG_2(ss,ssp,kk) ;

*############# SATELLITE ACCOUNT DATA




Execute_unload 'GLB_output\glb_samg_v2.gdx',
*### TRANSACTIONS
 SAMG
*#### POPULATION DATA
 POP
*#### CAPITAL STOCK DATA
 Kstoc
*#### GTAP ELASTICITIES DATA
* Satellite account data
 ESUBVA
 ESUBDC
 ESUBMC
* ImpactEcon LABOUR DATA
* SAM Satelitte Data
 Q_FD
 Q_FS


 ;

 SAMG_2(ss,ssp,kk) = 0.0 ;
 SAMG(ss,ssp,kk)   = 0.0 ;


Display "END of glbsam_glb2" ;





