*############## 5. SAMG for Standard GLOBE ##########
$ontext

This stage creates a SAM under the implicit assumption that a law of
one price held in the base GTAP data.

$offtext

*##### Initialise  SAMG_2
* This will be purged at the end of this include file

 SAMG_2_en(ss,ssp,kk) = SAMG_B(ss,ssp,kk) ;


*###### REVALUING COMMODITIES AT PURCHASER PRICES

*#### Import commodity income components

* Import Intermediate and Final Demand Use matrices (1:3; 1:6; 1:13; 1:14)

 SAMG_2_en(mmc_en,ss,kkn)       = SAMG_2_en(mmc_en,ss,kkn) +  SMTAX(mmc_en,ss,kkn) ;

*#### Domestic commodity income components

* Domestic Intermediate and Final Demand Use matrices (2:3; 2:6; 2:13; 2:14)

 SAMG_2_en(ddc_en,ss,kkn)       =  SAMG_2_en(ddc_en,ss,kkn) + SDTAX(ddc_en,ss,kkn) ;

* Deleting NON Energy commodity specific sales taxes

*# Import Sales Taxes  (9:3; 9:6; 9:13; 9:14)

 SAMG_2_en(ttsm_en,ss,kkn)    = 0.0 ;

*# Domestic Sales Taxes

 SAMG_2_en(ttsd_en,ss,kkn)    = 0.0 ;

* Total Value Added Taxes Revenues on imports

 SAMG_2_en("vvattax",mmc_en,kkn)  = (tvm2(mmc_en,kkn) * SAMG_2_en(mmc_en,"hhous",kkn)) ;

* Total Value Added Taxes Revenues on domestic commodities

 SAMG_2_en("vvattax",ddc_en,kkn)  = (tvd2(ddc_en,kkn) * SAMG_2_en(ddc_en,"hhous",kkn)) ;

*## Total Sales Taxes Revenues with common Sales Tax rates
* On imported commodities

 SAMG_2_en("ssaltax",mmc_en,kkn)  =  SUM(aa,SMTAX(mmc_en,aa,kkn))
                            + (SMTAX(mmc_en,"hhous",kkn)
                                 - (tvm2(mmc_en,kkn) * SAMG_2_en(mmc_en,"hhous",kkn)))
                            + SMTAX(mmc_en,"ggovt",kkn)
                            + SMTAX(mmc_en,"ii_s",kkn) ;

* On domestic commodities

 SAMG_2_en("ssaltax",ddc_en,kkn)  =  SUM(aa,SDTAX(ddc_en,aa,kkn))
                            + (SDTAX(ddc_en,"hhous",kkn)
                                 - (tvd2(ddc_en,kkn) * SAMG_2_en(ddc_en,"hhous",kkn)))
                            + SDTAX(ddc_en,"ggovt",kkn)
                            + SDTAX(ddc_en,"ii_s",kkn) ;


* Income of Government from TAXES (13:5)

 SAMG_2_en("ggovt","vvattax",kkn)
                        = SUM(mmc_en,SAMG_2_en("vvattax",mmc_en,kkn))
                              + SUM(ddc_en,SAMG_2_en("vvattax",ddc_en,kkn)) ;

 SAMG_2_en("ggovt","ssaltax",kkn)
                        = SUM(mmc_en,SAMG_2_en("ssaltax",mmc_en,kkn))
                               + SUM(ddc_en,SAMG_2_en("ssaltax",ddc_en,kkn)) ;

 SAMG_2_en("ggovt",ttsm_en,kk)         = 0.0 ;
 SAMG_2_en("ggovt",ttsd_en,kk)         = 0.0 ;



*####### Aggregating the IMPORT and DOMESTIC commodity accounts

* Rows
 SAMG_2_en(cc,ss,kk)         = SUM{mmc$map_cc_mmc(cc,mmc),SAMG_2_en(mmc,ss,kk)}
                            + SUM{ddc$map_cc_ddc(cc,ddc),SAMG_2_en(ddc,ss,kk)} ;

* Column
 SAMG_2_en(ss,cc,kk)         = SUM{mmc$map_cc_mmc(cc,mmc),SAMG_2_en(ss,mmc,kk)}
                            + SUM{ddc$map_cc_ddc(cc,ddc),SAMG_2_en(ss,ddc,kk)} ;

* Deleting Import and Domestic commodity rows and columns

 SAMG_2_en(mmc,ss,kk) = 0.0 ;
 SAMG_2_en(ddc,ss,kk) = 0.0 ;
 SAMG_2_en(ss,mmc,kk) = 0.0 ;
 SAMG_2_en(ss,ddc,kk) = 0.0 ;

*####### Aggregating the IMPORT and DOMESTIC commodity SALES Tax accounts

* Rows
 SAMG_2_en(tts,ss,kk)  = SUM{ttsm$map_tts_ttsm(tts,ttsm),SAMG_2_en(ttsm,ss,kk)}
                         + SUM{ttsd$map_tts_ttsd(tts,ttsd),SAMG_2_en(ttsd,ss,kk)} ;

* Column

 SAMG_2_en(ss,tts,kk)  = SUM{ttsm$map_tts_ttsm(tts,ttsm),SAMG_2_en(ss,ttsm,kk)}
                         + SUM{ttsd$map_tts_ttsd(tts,ttsd),SAMG_2_en(ss,ttsd,kk)} ;

* Deleting Import and Domestic commodity SALES Tax rows and columns

 SAMG_2_en(ttsm,ss,kk) = 0.0 ;
 SAMG_2_en(ttsd,ss,kk) = 0.0 ;

 SAMG_2_en(ss,ttsm,kk) = 0.0 ;
 SAMG_2_en(ss,ttsd,kk) = 0.0 ;

* Cleaning out intra agent TVs in GLOBE region account

 SAMG_2_en("ccotp","ccotp","glo") = 0.0 ;
 SAMG_2_en("ccwtp","ccwtp","glo") = 0.0 ;
 SAMG_2_en("ccatp","ccatp","glo") = 0.0 ;

* This check also recomputes the row and column totals


$INCLUDE include\chk_samg_2_en.inc

* Assigning SAMG

 SAMG(ss,ssp,kk)    = SAMG_2_en(ss,ssp,kk) ;

*############# SATELLITE ACCOUNT DATA

* Energy and Emissions data

 EVol(cc,ss,kk)  =  SUM{ddc$map_cc_ddc(cc,ddc),EVolD(ddc,ss,kk)}
                    + SUM{mmc$map_cc_mmc(cc,mmc),EVolM(mmc,ss,kk)} ;

 Em_C02(cc,ss,kk) = SUM{ddc$map_cc_ddc(cc,ddc),Em_D_C02(ddc,ss,kk)}
                    + SUM{mmc$map_cc_mmc(cc,mmc),Em_M_C02(mmc,ss,kk)} ;


Execute_unload 'GLB_output\glb_samg_v2_en.gdx',
*### TRANSACTIONS
 SAMG
*#### POPULATION DATA
 POP
*#### CAPITAL STOCK DATA
 Kstoc
*#### GTAP ELASTICITIES DATA
* Satellite account data
 ESUBVA
 ESUBDC
 ESUBMC
* Energy and Emissions data
 EVol
 Em_C02
* ImpactEcon LABOUR DATA
* SAM Satelitte Data
 Q_FD
 Q_FS

 ;


 SAMG_2_en(ss,ssp,kk) = 0.0 ;
 SAMG(ss,ssp,kk)      = 0.0 ;


Display "END of glbsam_glb2_en" ;





