*############## 5. SAMG_3 for GLOBE V3 ##########

$ontext

This stage creates a SAM under the implicit assumption that a law of
one price held in the base GTAP data.

$offtext

*##### Initialise  SAMG_3
* This will be purged at the end of this include file

 SAMG_3(ss,ssp,kk) = SAMG(ss,ssp,kk) ;

*###### REVALUING COMMODITIES AT PURCHASER PRICES

*#### Import commodity income components

* Import Intermediate and Final Demand Use matrices (1:3; 1:6; 1:13; 1:14)

 SAMG_3(mmc,ss,kkn)       = SAMG_3(mmc,ss,kkn) +  SMTAX(mmc,ss,kkn) ;

*#### Domestic commodity income components

* Domestic Intermediate and Final Demand Use matrices (2:3; 2:6; 2:13; 2:14)

 SAMG_3(ddc,ss,kkn)       =  SAMG_3(ddc,ss,kkn) + SDTAX(ddc,ss,kkn) ;

* Deleting commodity specific sales taxes

*# Import Sales Taxes  (9:3; 9:6; 9:13; 9:14)

 SAMG_3(ttsm,ss,kkn)    = 0.0 ;

*# Domestic Sales Taxes

 SAMG_3(ttsd,ss,kkn)    = 0.0 ;

*###### Total Value Added Taxes Revenues on imports
* On imported commodities

 SAMG_3("vvattax",mmc,kkn)  = (tvm2(mmc,kkn) * SAMG_3(mmc,"hhous",kkn)) ;

* On domestic commodities

 SAMG_3("vvattax",ddc,kkn)  = (tvd2(ddc,kkn) * SAMG_3(ddc,"hhous",kkn)) ;

*##### Total Sales Taxes Revenues with common Sales Tax rates
* On imported commodities

 SAMG_3("ssaltax",mmc,kkn)  =  SUM(aa,SMTAX(mmc,aa,kkn))
                            + (SMTAX(mmc,"hhous",kkn)
                                 - (tvm2(mmc,kkn) * SAMG_3(mmc,"hhous",kkn)))
                            + SMTAX(mmc,"ggovt",kkn)
                            + SMTAX(mmc,"ii_s",kkn) ;

* On domestic commodities

 SAMG_3("ssaltax",ddc,kkn)  =  SUM(aa,SDTAX(ddc,aa,kkn))
                            + (SDTAX(ddc,"hhous",kkn)
                                 - (tvd2(ddc,kkn) * SAMG_3(ddc,"hhous",kkn)))
                            + SDTAX(ddc,"ggovt",kkn)
                            + SDTAX(ddc,"ii_s",kkn) ;


* Income of Government from TAXES (13:5)

 SAMG_3("ggovt","vvattax",kkn)   = SUM(mmc,SAMG_3("vvattax",mmc,kkn))
                                   + SUM(ddc,SAMG_3("vvattax",ddc,kkn)) ;

 SAMG_3("ggovt","ssaltax",kkn)   = SUM(mmc,SAMG_3("ssaltax",mmc,kkn))
                                   + SUM(ddc,SAMG_3("ssaltax",ddc,kkn)) ;

 SAMG_3("ggovt",ttsm,kk)         = 0.0 ;
 SAMG_3("ggovt",ttsd,kk)         = 0.0 ;

*####### Aggregating the IMPORT and DOMESTIC commodity accounts

* Rows
 SAMG_3(cc,ss,kk)         = SUM{mmc$map_cc_mmc(cc,mmc),SAMG_3(mmc,ss,kk)}
                            + SUM{ddc$map_cc_ddc(cc,ddc),SAMG_3(ddc,ss,kk)} ;

* Column
 SAMG_3(ss,cc,kk)         = SUM{mmc$map_cc_mmc(cc,mmc),SAMG_3(ss,mmc,kk)}
                            + SUM{ddc$map_cc_ddc(cc,ddc),SAMG_3(ss,ddc,kk)} ;

* Deleting Import and Domestic commodity rows and columns

 SAMG_3(mmc,ss,kk) = 0.0 ;
 SAMG_3(ddc,ss,kk) = 0.0 ;
 SAMG_3(ss,mmc,kk) = 0.0 ;
 SAMG_3(ss,ddc,kk) = 0.0 ;

* Cleaning out intra agent TVs in GLOBE region account

 SAMG_2("ccotp","ccotp","glo") = 0.0 ;
 SAMG_2("ccwtp","ccwtp","glo") = 0.0 ;
 SAMG_2("ccatp","ccatp","glo") = 0.0 ;

* This check also recomputes the row and column totals

$INCLUDE include\chk_samg_3.inc

*############# SATELLITE ACCOUNT DATA




Execute_unload 'GLB_output\glb_samg_v3.gdx',
*### TRANSACTIONS
 SAMG_3
*#### POPULATION DATA
 POP
*#### CAPITAL STOCK DATA
 Kstoc
*#### GTAP ELASTICITIES DATA
* Satellite account data
 ESUBVA
 ESUBDC
 ESUBMC
* ImpactEcon LABOUR DATA
* SAM Satelitte Data
 Q_FD
 Q_FS


 ;

 SAMG_3(ss,ssp,kk) = 0.0 ;








