*--- Introducing the globe region for margins

* Exports of margins to globe
 SAMG(ddc,"wwglo",kkn)   = SUM(vvst,SAMG(ddc,vvst,kkn)) ;

 SAMG(ddc,vvst,kkn)       = 0.0 ;

* Calculating the import demand for each margin import

 SAMG("wwglo",ootpm,kkn)  = SUM(mmc,SAMG(ootpm,mmc,kkn)) ;
 SAMG("wwglo",wwtpm,kkn)  = SUM(mmc,SAMG(wwtpm,mmc,kkn)) ;
 SAMG("wwglo",aatpm,kkn)  = SUM(mmc,SAMG(aatpm,mmc,kkn)) ;

 SAMG(vvst,ootpm,kkn)      = 0.0 ;
 SAMG(vvst,wwtpm,kkn)      = 0.0 ;
 SAMG(vvst,aatpm,kkn)      = 0.0 ;

* Calculating trade balances for margins

 SAMG("ii_s","wwglo",kkn)   = {SUM(ootpm,SAMG("wwglo",ootpm,kkn))
                               + SUM(wwtpm,SAMG("wwglo",wwtpm,kkn))
                               + SUM(aatpm,SAMG("wwglo",aatpm,kkn))}
                                 - SUM(ddc,SAMG(ddc,"wwglo",kkn)) ;

 SAMG("ii_s",vvst,kkn)  = 0.0 ;

*#### Rounding the Global SAM to 6 Decimal Places
* The GTAP database only records data to 6 decimal places

 SAMG(ss,ssp,kk)      = ROUND(SAMG(ss,ssp,kk),6) ;


*---- Populating the SAM for globe

Parameter
 SAM_glo(ss,ss)                   SAM for globe

 marg_exp(ddc,ww,kk)              Margin exports

 marg_imp_otp(ootpm,mmc,kk)    OTP margin imports by kk
 marg_imp_wtp(wwtpm,mmc,kk)    WTP margin imports by kk
 marg_imp_atp(aatpm,mmc,kk)    ATP margin imports by kk

 margimps(mmc,kk)    Margin imports of type mmc by region kk

 ;

 marg_exp(ddc,ww,kkn)          = SAMG(ddc,"wwglo",kkn) ;

 marg_imp_otp(ootpm,mmc,kkn)   = SAMG(ootpm,mmc,kkn) ;
 marg_imp_wtp(wwtpm,mmc,kkn)   = SAMG(wwtpm,mmc,kkn) ;
 marg_imp_atp(aatpm,mmc,kkn)   = SAMG(aatpm,mmc,kkn) ;

*--- Clearing out any data in globe region

 SAMG(ss,ssp,"glo")     = 0.0 ;

 SAM_glo(ss,ssp)        = SAMG(ss,ssp,"glo") ;

Display SAM_glo, marg_imp_otp, marg_imp_wtp, marg_imp_atp ;



*--- Margin imports by globe (are exports ddc from other regions kkn to wwglo)

 SAMG(ww,mmc,"glo")     = SUM((ddc,kkn)
                            $(map_mmc_ddc(mmc,ddc)
                              $map_ww_kk(ww,kkn)),
                                SAMG(ddc,"wwglo",kkn)) ;

Parameter

 margchk1(ss)      Margins check for margin imports by GLOBE

 ;

 margchk1(mmc)   = SUM((ddc,kkn)$map_mmc_ddc(mmc,ddc),
                         marg_exp(ddc,"wwglo",kkn))
                                - SUM(ww,SAMG(ww,mmc,"glo")) ;

 SAM_glo(ww,mmc)  = SAMG(ww,mmc,"glo") ;

DISPLAY SAM_glo, margchk1 ;

*--- Margin exports by globe (are imports o/w/atp by other regions kkn to wwglo)

* Margin imports by Region

 margimps("mmotp",kk)  = SUM((ootpm,mmc),SAMG(ootpm,mmc,kk)) ;
 margimps("mmwtp",kk)  = SUM((wwtpm,mmc),SAMG(wwtpm,mmc,kk)) ;
 margimps("mmatp",kk)  = SUM((aatpm,mmc),SAMG(aatpm,mmc,kk)) ;

DISPLAY margimps ;

Execute_unload 'stats\marg_test.gdx', margimps,
                                SAM_glo,
                                marg_imp_otp,
                                marg_imp_wtp,
                                marg_imp_atp
   ;


 SAMG(ddc,ww,"glo")    = SUM((mmc,kkn)
                          $(map_ww_kk(ww,kkn)
                          $map_ddc_mmc(ddc,mmc)),margimps(mmc,kkn)) ;

 SAM_glo(ddc,ww)  = SAMG(ddc,ww,"glo") ;

 SAMG("ddotp","mmotp","glo") = -1 * SUM(ww,SAMG("ddotp",ww,"glo")) ;
 SAMG("ddwtp","mmwtp","glo") = -1 * SUM(ww,SAMG("ddwtp",ww,"glo")) ;
 SAMG("ddatp","mmatp","glo") = -1 * SUM(ww,SAMG("ddatp",ww,"glo")) ;

 SAMG(ddc,mmc,"glo") = 0.00 ;

* SAMG(d_marg,"m_otp","glo") = -1 * SUM(ww,SAMG(d_marg,ww,"glo")) ;

 SAMG("ii_s",ww,"glo") = SUM(mmc,SAMG(ww,mmc,"glo"))
                          - SUM(ddc,SAMG(ddc,ww,"glo")) ;

 SAM_glo("ii_s",ww)  = SAMG("ii_s",ww,"glo") ;

 SAM_glo("ttotal",ssnp)        = SUM(ssn,SAM_glo(ssn,ssnp)) ;
 SAM_glo(ssn,"ttotal")         = SUM(ssnp,SAM_glo(ssn,ssnp)) ;

Parameter
 diff_SAM_glo(ss)    differences in SAM_glo row and column totals
 ;

 diff_SAM_glo(ssn)  = SAM_glo("ttotal",ssn) - SAM_glo(ssn,"ttotal") ;

Display SAM_glo, diff_SAM_glo ;

Execute_unload 'stats\samg_glo1.gdx', SAM_glo ;

*---- Removing the 'Errors' in Margins

* Recomputing the account totals

 SAMG("TTOTAL",ssnp,kk)        = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 SAMG(ssn,"TTOTAL",kk)         = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

Parameter
 adjust_m(ss,kk)   Adjustment for trade margins

 ;

 SAMG("ttotal",ssnp,kk) = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
 SAMG(ssn,"ttotal",kk)  = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

 adjust_m(ssn,kk)   = SAMG("ttotal",ssn,kk) - SAMG(ssn,"ttotal",kk) ;

Display adjust_m ;

*##### CHECK on SAMG #####

* Checking SAM after GLOBE region

$INCLUDE include\chk_samg.inc

*###### UNLOADING SAMG

Execute_Unload 'stats\SAMG_glo.gdx',
                                    SAMG
                                    DIFFTOT
                                    BIGDIFFTOT
                                    LRGDIFFTOT
                                    SUMDIFFTOT
                                    DIFFPER
                                    BIGDIFFPER
                                    DIFTOTPERCNT
 ;


Display "END of glbsam_glo" ;
