*############## ASSIGNING THE GLOBE SAM #########################

* ## CHECK import duties in transactions SAM v1 are correct

$GDXIN data\basedata.gdx
* Sets and data from GTAP database

$LOAD tar = tartype

$LOADdc VTSS

$GDXIN

Display VTSS ;

Parameter
 VTSS2(tar,ttm,mmc,kk)     Value of Imports in World Prices + Specific & AdValorem tariff revenue

 TM_REVCHK(ttm,mmc,kk)     CHECK on trade tax revenues

 CNT_TM_REVHK1                COUNT on TM_REVCHK diff > 0.000001
 CNT_TM_REVHK2                COUNT on TM_REVCHK diff > 0.00001
 CNT_TM_REVHK3                COUNT on TM_REVCHK diff > 0.0001
 CNT_TM_REVHK4                COUNT on TM_REVCHK diff > 0.001
 CNT_TM_REVHK5                COUNT on TM_REVCHK diff > 0.01

 VTSS2_CHK(ttm,mmc,kk)    CHECK on Tariffs
 VTSS3_CHK(ttm,mmc,kk)    CHECK on Tariffs

  ;

 VTSS2(tar,ttm,mmc,kk)   = SUM((trad_comm,kkp)
                               $(map_mmc_trad(mmc,trad_comm)
                                $map_ttm_kk(ttm,kkp)),
                                 VTSS(tar,trad_comm,kkp,kk)) ;

 TM_REVCHK(ttm,mmc,kk)   = SAMG(ttm,mmc,kk)
                               - SUM(tar,VTSS2(tar,ttm,mmc,kk)) ;

 CNT_TM_REVHK1 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.000001), 1 ) ;
 CNT_TM_REVHK2 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.00001), 1 ) ;
 CNT_TM_REVHK3 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.0001), 1 ) ;
 CNT_TM_REVHK4 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.001), 1 ) ;
 CNT_TM_REVHK5 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.01), 1 ) ;



 VTSS2_CHK(ttm,mmc,kk) = SUM(tar,VTSS2(tar,ttm,mmc,kk))
                             - SAMG(ttm,mmc,kk) ;

Execute_Unload  'stats\TM_REVCHK.gdx', TM_REVCHK ;

Display VTSS2_CHK ;

* ## Assign SPECIFIC import duties

Parameter

 TTM_BASE(ttm,mmc,kk) Tariff revenue in BASIC SAMG
 TTM_SPE(ttm,mmc,kk)  Specific tariff revenue as residual
 TTM_ADV(ttm,mmc,kk)  Ad valorem tariff revenue as residual ;

* Residual calculation

 TTM_BASE(ttm,mmc,kk) = SAMG(ttm,mmc,kk) ;

 TTM_ADV(ttm,mmc,kk)  = VTSS2("adv",ttm,mmc,kk) ;

 TTM_SPE(ttm,mmc,kk)
*                     = SAMG(ttm,mmc,kk) - VTSS2("adv",ttm,mmc,kk) ;
                     = SAMG(ttm,mmc,kk) - TTM_ADV(ttm,mmc,kk) ;

 VTSS3_CHK(ttm,mmc,kk) = SAMG(ttm,mmc,kk)
                              - TTM_ADV(ttm,mmc,kk)
                              - TTM_SPE(ttm,mmc,kk) ;

* ## Derive ad valorem equivalent import duties

 SAMG(ttm,mmc,kk)  = 0.0 ;

 SAMG(ttms,mmc,kk)
                     = SUM(ttm$map_ttms_ttm(ttms,ttm),
                           TTM_SPE(ttm,mmc,kk)) ;

$ontext
* Direct calculation
 SAMG(tmmsptax,mmc,kk)
                     = SUM(tmmtax$map_ttms_tmm(ttmstax,tmmtax),
                          VTSS2("spe",tmm,mmc,kk)) ;
$offtext

 SAMG(ttm,mmc,kk) = TTM_ADV(ttm,mmc,kk) ;

 SAMG("rreghous",ttm,kk)   = SUM(mmc,SAMG(ttm,mmc,kk)) ;
 SAMG("rreghous",ttms,kk)  = SUM(mmc,SAMG(ttms,mmc,kk)) ;

Parameter
 TTM_CHK(mmc,kk)    CHECK on TTM
 TTM_CHK_cnt        Count of non zero CHECK on TTM

 ;

 TTM_CHK(mmc,kk)  = SUM(ttm,TTM_BASE(ttm,mmc,kk))
                      - SUM(ttm,SAMG(ttm,mmc,kk))
                      - SUM(ttms,SAMG(ttms,mmc,kk)) ;

 TTM_CHK_cnt            = SUM{(mmc,kk)$ABS(TTM_CHK(mmc,kk) gt 0.0000001), 1 } ;
 ABORT$(TTM_CHK_cnt GT 0.0) "ERROR WHEN SPLITTING TRADE TAXES" ;

*##### CHECK on SAMG #####

* Checking SAM before removing Regional Household

$INCLUDE include\chk_samg.inc


*##### Removing the Regional Household Account

$ontext

ASSUMPTIONS
  1. all factor income taxes are household income taxes - this ignores
     any social security contributions
  2. government transfers to households are ZERO
  3. internal balances are derives from estimates from WDI database

$offtext

*## Income of Private Households (6:5)

* Moving factor incomes and income taxes to HOUS from REG HOUSE and DDIRTAX

 SAMG("hhous",ff,kkn)      = SAMG("rreghous",ff,kkn) + SAMG("ddirtax",ff,kkn) ;

 SAMG("rreghous",ff,kkn)    = 0.0 ;

 SAMG("hhous","rreghous",kkn)  = 0.0 ;

* Income Tax paid by private household

 SAMG("ddirtax","hhous",kkn) = SUM(ff,SAMG("ddirtax",ff,kkn)) ;

 SAMG("ddirtax",ff,kkn)      = 0.0 ;

* Income of Government (13:5)
* Moving components of indirect taxes from REG HOUSE to GOVT

 SAMG("ggovt",ttm,kkn)         = SAMG("rreghous",ttm,kkn) ;

 SAMG("ggovt",ttms,kkn)        = SAMG("rreghous",ttms,kkn) ;

 SAMG("ggovt",tte,kkn)         = SAMG("rreghous",tte,kkn) ;

 SAMG("ggovt",ttsm,kkn)        = SAMG("rreghous",ttsm,kkn) ;
 SAMG("ggovt",ttsd,kkn)        = SAMG("rreghous",ttsd,kkn) ;

 SAMG("ggovt",ttff,kkn)        = SAMG("rreghous",ttff,kkn) ;

 SAMG("ggovt","pprodtax",kkn)  = SUM(aa,SAMG("pprodtax",aa,kkn)) ;

* Government income for direct taxes

 SAMG("ggovt","ddirtax",kkn)   = SUM(ff,SAMG("ddirtax",ff,kkn))
                                  + SAMG("ddirtax","hhous",kkn) ;

Parameter
 YG(kk)     Government income ;

 YG(kkn)  = SUM(ttm,SAMG("ggovt",ttm,kkn))
            + SUM(ttms,SAMG("ggovt",ttms,kkn))
            + SUM(tte,SAMG("ggovt",tte,kkn))
            + SUM(ttsm,SAMG("ggovt",ttsm,kkn))
            + SUM(ttsd,SAMG("ggovt",ttsd,kkn))
            + SUM(ttff,SAMG("ggovt",ttff,kkn))
            + SAMG("ggovt","pprodtax",kkn)
            + SAMG("ggovt","ddirtax",kkn) ;

* Removing reghous tax accounts

 SAMG("rreghous",ttm,kkn)         = 0.0 ;
 SAMG("rreghous",ttms,kkn)        = 0.0 ;
 SAMG("rreghous",tte,kkn)         = 0.0 ;
 SAMG("rreghous",ttsm,kkn)        = 0.0 ;
 SAMG("rreghous",ttsd,kkn)        = 0.0 ;
 SAMG("rreghous",ttff,kkn)        = 0.0 ;
 SAMG("rreghous","pprodtax",kkn)  = 0.0 ;
 SAMG("rreghous","ddirtax",kkn)   = 0.0 ;

* Removing REGHOUS expenditures

 SAMG("ggovt","rreghous",kkn)     = 0.0 ;
 SAMG("ii_s","rreghous",kkn)      = 0.0 ;


* GDP from expenditure
Parameter
 GDP(kk)           GDP calculated from expenditures
 int_bal_sh(kk)    WDI estimates of internal balance shares
 Govt_sav(kk)      Government Savings
 ;

*### Domestic Savings by household (14:5) and government ??:??)
$ontext

Government
    Defining Savings by Govt as shares of GDP with the share estimates
       taken from WDI data read in from Excel 'Int_Bal_GTP92_11.xlsx'

Household
   Defining Savings by HOUS as total household income LESS Consumption
       expenditure, inclusive of sales taxes and direct taxes



$offtext

 GDP(kkn)  =
* Household consumption
          [SUM(mmc,SAMG(mmc,"hhous",kkn)) + SUM(ddc,SAMG(ddc,"hhous",kkn))]
* plus Government consumption
          + [SUM(mmc,SAMG(mmc,"ggovt",kkn)) + SUM(ddc,SAMG(ddc,"ggovt",kkn))]
* plus Investment consumption
          + [SUM(mmc,SAMG(mmc,"ii_s",kkn)) + SUM(ddc,SAMG(ddc,"ii_s",kkn))]
* plus exports
          + SUM((ddc,ww),SAMG(ddc,ww,kkn))
* minus imports
          - [SUM((ww,mmc),SAMG(ww,mmc,kkn))
          - SUM((ootpm,mmc),SAMG(ootpm,mmc,kkn))
          - SUM((wwtpm,mmc),SAMG(wwtpm,mmc,kkn))
          - SUM((aatpm,mmc),SAMG(aatpm,mmc,kkn))]
 ;


$GDXIN data_in.gdx

$LOADdc int_bal_sh = int_bal

$GDXIN

* Government Savings (?:?)

 SAMG("ii_s","ggovt",kkn)     = GDP(kkn) * int_bal_sh(kkn) ;

* Household saving (computed as a residual - )

 SAMG("ii_s","hhous",kkn)  =
* Investment expenditure on imported commodities incl sales taxes
                         { SUM[(mmc,ii),SAMG(mmc,ii,kkn)]
                            + SUM[(ttsm,ii),SAMG(ttsm,ii,kkn)]

* Investment expenditure on imported commodities incl sales taxes
                          + SUM[(ddc,ii),SAMG(ddc,ii,kkn)]
                            + SUM[(ttsd,ii),SAMG(ttsd,ii,kkn)] }
* LESS government savings
                       - { SUM[ii,SAMG(ii,"ggovt",kkn)]
* LESS deprectaion
                          + SUM[(ii,ff),SAMG(ii,ff,kkn)]

* LESS Trade balance
                          + SUM[(ii,ww), SAMG(ii,ww,kkn)]
* LESS Margins balance
                          + SUM[(ii,vvst),SAMG(ii,vvst,kkn)] }

  ;


$ontext
 SUM(ff,SAMG("hhous",ff,kkn))
                                 - {SUM(mmc,SAMG(mmc,"hhous",kkn))
                                      + SUM(ttsm,SAMG(ttsm,"hhous",kkn))
                                   + SUM(ddc,SAMG(ddc,"hhous",kkn))
                                      + SUM(ttsd,SAMG(ttsd,"hhous",kkn))
                                   + SAMG("ddirtax","hhous",kkn) } ;

$offtext

* Government account cleared by transfers to Households

 SAMG("hhous","ggovt",kkn)  = YG(kkn)
* minus Govt consumption expenditure
                              - [{SUM(mmc,SAMG(mmc,"ggovt",kkn))
                                      + SUM(ttsm,SAMG(ttsm,"ggovt",kkn))
                                   + SUM(ddc,SAMG(ddc,"ggovt",kkn))
                                      + SUM(ttsd,SAMG(ttsd,"ggovt",kkn)) }
* minus GOVT savings
                                   + SAMG("ii_s","ggovt",kkn) ] ;


 govt_sav(kk)  = SAMG("ii_s","ggovt",kk) ;

*##### CHECK on SAMG #####

* Checking SAM after MAKING

$INCLUDE include\chk_samg.inc

*####### Generating Macro SAMs ######

Set
 ac      Macro SAM accounts /
 mcom      imported commodities
 dcom      domestic commodities
 ccom      composite commodities
 acts      activities
 fact      factors
 mstax     sales taxes on imports commodities
 dstax     sales taxes on domestic commodities
 cstax     sales taxes on composite commodities
 mmtax     Ad valorem Import duties
 mmstax    Specific Import duties
 extax     Export taxes
 fatax     Factor use taxes
 ptax      Production tax
 dtax      Direct taxes
 pvth      Private household
 gvt       Government
 invt      Investment
 marg      margins on imports
 row       rest of the world
 tott      Account totals
  /


 ;

Set
 acn(ac)     Macro SAM accounts less totals
 ;

 acn(ac)     = YES ;
 acn("tott") = NO ;

Alias (ac,acp), (acn,acnp) ;

$ontext
hhous        Household
ssaltax        Sales taxes
vvattax        Value Added taxes
pprodtax        Production Taxes
ddirtax        Direct Taxes
ggovt        Government
ii_s        Investment saving
ddstoc        Stock changes
rreghous        Regional Household
ttotal        Account totals

$offtext

Parameter
 ASAM_base(ac,ac,kk)   Macro SAM from SAMG_base
 ASAM_base_chk(ac,kk)  Macro SAM from SAMG_base row and column check
 ;


 ASAM_base("mcom","acts",kk)   = SUM[(mmc,aa),SAMG(mmc,aa,kk)] ;
 ASAM_base("mcom","pvth",kk)   = SUM[mmc,SAMG(mmc,"hhous",kk)] ;
 ASAM_base("mcom","gvt ",kk)   = SUM[mmc,SAMG(mmc,"ggovt",kk)] ;
 ASAM_base("mcom","invt",kk)   = SUM[(mmc,ii),SAMG(mmc,ii,kk)] ;

 ASAM_base("dcom","acts",kk)   = SUM[(ddc,aa),SAMG(ddc,aa,kk)] ;
 ASAM_base("dcom","pvth",kk)   = SUM[ddc,SAMG(ddc,"hhous",kk)] ;
 ASAM_base("dcom","gvt ",kk)   = SUM[ddc,SAMG(ddc,"ggovt",kk)] ;
 ASAM_base("dcom","invt",kk)   = SUM[(ddc,ii),SAMG(ddc,ii,kk)] ;

 ASAM_base("dcom","marg",kk)   = SUM[(ddc,vvst),SAMG(ddc,vvst,kk)] ;
 ASAM_base("dcom","row",kk)    = SUM[(ddc,ww),SAMG(ddc,ww,kk)] ;

 ASAM_base("acts","dcom",kk)   = SUM[(aa,ddc),SAMG(aa,ddc,kk)] ;

 ASAM_base("fact","acts",kk)   = SUM[(ff,aa),SAMG(ff,aa,kk)] ;

 ASAM_base("mstax","acts",kk)  = SUM[(ttsm,aa),SAMG(ttsm,aa,kk)] ;
 ASAM_base("dstax","acts",kk)  = SUM[(ttsd,aa),SAMG(ttsd,aa,kk)] ;

 ASAM_base("mstax","pvth",kk)  = SUM[ttsm,SAMG(ttsm,"hhous",kk)] ;
 ASAM_base("dstax","pvth",kk)  = SUM[ttsd,SAMG(ttsd,"hhous",kk)] ;

 ASAM_base("mstax","gvt",kk)   = SUM[ttsm,SAMG(ttsm,"ggovt",kk)] ;
 ASAM_base("dstax","gvt",kk)   = SUM[ttsd,SAMG(ttsd,"ggovt",kk)] ;

 ASAM_base("mstax","invt",kk)  = SUM[(ttsm,ii),SAMG(ttsm,ii,kk)] ;
 ASAM_base("dstax","invt",kk)  = SUM[(ttsd,ii),SAMG(ttsd,ii,kk)] ;


 ASAM_base("mmtax","mcom",kk)  = SUM[(ttm,mmc),SAMG(ttm,mmc,kk)] ;
 ASAM_base("mmstax","mcom",kk) = SUM[(ttms,mmc),SAMG(ttms,mmc,kk)] ;
 ASAM_base("extax","dcom",kk)  = SUM[(tte,ddc),SAMG(tte,ddc,kk)] ;

 ASAM_base("fatax","acts",kk)  = SUM[(ttff,aa),SAMG(ttff,aa,kk)] ;

 ASAM_base("ptax","acts",kk)   = SUM[aa,SAMG("pprodtax",aa,kk)] ;
 ASAM_base("ptax","invt",kk)   = SUM[ii,SAMG("pprodtax",ii,kk)] ;

 ASAM_base("pvth","fact",kk)   = SUM[ff,SAMG("hhous",ff,kk)] ;

 ASAM_base("pvth","gvt",kk)    = SAMG("hhous","ggovt",kk) ;

 ASAM_base("dtax","pvth",kk)   = SAMG("ddirtax","hhous",kk) ;

 ASAM_base("gvt","mmtax",kk)   = SUM[ttm,SAMG("ggovt",ttm,kk)] ;
 ASAM_base("gvt","mmstax",kk)  = SUM[ttms,SAMG("ggovt",ttms,kk)] ;
 ASAM_base("gvt","extax",kk)   = SUM[tte,SAMG("ggovt",tte,kk)] ;

 ASAM_base("gvt","mstax",kk)   = SUM[ttsm,SAMG("ggovt",ttsm,kk)] ;
 ASAM_base("gvt","dstax",kk)   = SUM[ttsd,SAMG("ggovt",ttsd,kk)] ;

 ASAM_base("gvt","fatax",kk)   = SUM[ttff,SAMG("ggovt",ttff,kk)] ;

 ASAM_base("gvt","ptax",kk)    = SAMG("ggovt","pprodtax",kk) ;
 ASAM_base("gvt","dtax",kk)    = SAMG("ggovt","ddirtax",kk) ;


 ASAM_base("invt","fact",kk)   = SUM[(ii,ff),SAMG(ii,ff,kk)] ;

 ASAM_base("invt","pvth",kk)   = SUM[ii,SAMG(ii,"hhous",kk)] ;
 ASAM_base("invt","gvt",kk)    = SUM[ii,SAMG(ii,"ggovt",kk)] ;

 ASAM_base("invt","row",kk)    = SUM[(ii,ww),SAMG(ii,ww,kk)] ;

 ASAM_base("invt","marg",kk)   = SUM[(ii,vvst),SAMG(ii,vvst,kk)] ;

 ASAM_base("marg","mcom",kk)   = SUM[(ootpm,mmc),SAMG(ootpm,mmc,kk)]
                                 + SUM[(wwtpm,mmc),SAMG(wwtpm,mmc,kk)]
                                 + SUM[(aatpm,mmc),SAMG(aatpm,mmc,kk)] ;


 ASAM_base("row","mcom",kk)    = SUM[(ww,mmc),SAMG(ww,mmc,kk)] ;

 ASAM_base("tott",acnp,kk)     = SUM(acn,ASAM_base(acn,acnp,kk)) ;
 ASAM_base(acn,"tott",kk)      = SUM(acnp,ASAM_base(acn,acnp,kk)) ;

 ASAM_base_chk(acn,kk)         =  ASAM_base("tott",acn,kk)
                                 -  ASAM_base(acn,"tott",kk)   ;


*####### Count of Non Zero Cells in SAMG #######

Parameter
 SAMG_nonZ(ss,ss,kk)     Non Zero elements in SAMG
 SAMG_cnt(kk)            Count of NON Zero elements by region

 ;

 SAMG_nonZ(ss,ssp,kkn)${ABS[SAMG(ss,ssp,kkn) GT 0.0000001]}  = 1.0 ;

 SAMG_cnt(kkn)      = SUM[(ss,ssp),SAMG_nonZ(ss,ssp,kkn)] ;


* DIFTOTPERCNT("st_gt5","diff_tot")
*1416                          = SUM((ssn,kk)$(DIFFTOT(ssn,kk) > 5), 1) ;

* BIGDIFFTOT(ssnp,kk)${ABS(DIFFTOT(ssnp,kk) GT 1.00)} = 1.0 ;

*###### UNLOADING SAMG basic

Execute_Unload 'stats\SAMG_basic.gdx',
                                    SAMG
                                    DIFFTOT
                                    BIGDIFFTOT
                                    LRGDIFFTOT
                                    SUMDIFFTOT
                                    DIFFPER
                                    BIGDIFFPER
                                    DIFTOTPERCNT
                                    GDP
                                    govt_sav
                                    ASAM_base
                                    ASAM_base_chk
 ;


Display "END of glbsam_make" ;
