*############## ASSIGNING THE GLOBE SAM #########################

* ## CHECK import duties in transactions SAMG are correct

$GDXIN data\basedata.gdx
* Sets and data from GTAP database

$LOAD tar = tartype

$LOADdc VTSS = TFRVSA

$GDXIN

Display VTSS ;

Parameter
 VTSS2(tar,ttm,mmc,kk)     Value of Imports in World Prices + Specific & AdValorem tariff revenue

 TM_REVCHK(ttm,mmc,kk)     CHECK on trade tax revenues

 CNT_TM_REVHK1                COUNT on TM_REVCHK diff > 0.000001
 CNT_TM_REVHK2                COUNT on TM_REVCHK diff > 0.00001
 CNT_TM_REVHK3                COUNT on TM_REVCHK diff > 0.0001
 CNT_TM_REVHK4                COUNT on TM_REVCHK diff > 0.001
 CNT_TM_REVHK5                COUNT on TM_REVCHK diff > 0.01

 VTSS2_CHK(ttm,mmc,kk)    CHECK on Tariffs
 VTSS3_CHK(ttm,mmc,kk)    CHECK on Tariffs

  ;

 VTSS2(tar,ttm,mmc,kk)   = SUM((trad_comm,kkp)
                               $(map_mmc_trad(mmc,trad_comm)
                                $map_ttm_kk(ttm,kkp)),
                                 VTSS(tar,trad_comm,kkp,kk)) ;

 TM_REVCHK(ttm,mmc,kk)   = SAMG(ttm,mmc,kk)
                               - SUM(tar,VTSS2(tar,ttm,mmc,kk)) ;

 CNT_TM_REVHK1 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.000001), 1 ) ;
 CNT_TM_REVHK2 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.00001), 1 ) ;
 CNT_TM_REVHK3 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.0001), 1 ) ;
 CNT_TM_REVHK4 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.001), 1 ) ;
 CNT_TM_REVHK5 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.01), 1 ) ;



 VTSS2_CHK(ttm,mmc,kk) = SUM(tar,VTSS2(tar,ttm,mmc,kk))
                             - SAMG(ttm,mmc,kk) ;

Execute_Unload  'stats\TM_REVCHK.gdx', TM_REVCHK ;

Display VTSS2_CHK ;

* ## Assign SPECIFIC import duties

Parameter

 TTM_BASE(ttm,mmc,kk) Tariff revenue in BASIC SAMG
 TTM_SPE(ttm,mmc,kk)  Specific tariff revenue as residual
 TTM_ADV(ttm,mmc,kk)  Ad valorem tariff revenue as residual ;

* Residual calculation

 TTM_BASE(ttm,mmc,kk) = SAMG(ttm,mmc,kk) ;

 TTM_ADV(ttm,mmc,kk)  = VTSS2("adv",ttm,mmc,kk) ;

 TTM_SPE(ttm,mmc,kk)
*                     = SAMG(ttm,mmc,kk) - VTSS2("adv",ttm,mmc,kk) ;
                     = SAMG(ttm,mmc,kk) - TTM_ADV(ttm,mmc,kk) ;

 VTSS3_CHK(ttm,mmc,kk) = SAMG(ttm,mmc,kk)
                              - TTM_ADV(ttm,mmc,kk)
                              - TTM_SPE(ttm,mmc,kk) ;

* ## Derive ad valorem equivalent import duties

 SAMG(ttm,mmc,kk)  = 0.0 ;

 SAMG(ttms,mmc,kk)
                     = SUM(ttm$map_ttms_ttm(ttms,ttm),
                           TTM_SPE(ttm,mmc,kk)) ;

$ontext
* Direct calculation
 SAMG(tmmsptax,mmc,kk)
                     = SUM(tmmtax$map_ttms_tmm(ttmstax,tmmtax),
                          VTSS2("spe",tmm,mmc,kk)) ;
$offtext

 SAMG(ttm,mmc,kk) = TTM_ADV(ttm,mmc,kk) ;

 SAMG("rreghous",ttm,kk)   = SUM(mmc,SAMG(ttm,mmc,kk)) ;
 SAMG("rreghous",ttms,kk)  = SUM(mmc,SAMG(ttms,mmc,kk)) ;

Parameter
 TTM_CHK(mmc,kk)    CHECK on TTM
 TTM_CHK_cnt        Count of non zero CHECK on TTM

 ;

 TTM_CHK(mmc,kk)  = SUM(ttm,TTM_BASE(ttm,mmc,kk))
                      - SUM(ttm,SAMG(ttm,mmc,kk))
                      - SUM(ttms,SAMG(ttms,mmc,kk)) ;

 TTM_CHK_cnt            = SUM{(mmc,kk)$ABS(TTM_CHK(mmc,kk) gt 0.0000001), 1 } ;
 ABORT$(TTM_CHK_cnt GT 0.0) "ERROR WHEN SPLITTING TRADE TAXES" ;

*##### CHECK on SAMG #####

* Checking SAM before removing Regional Household

$INCLUDE include\chk_samg.inc


*##### Removing the Regional Household Account

$ontext
  The GTAP database uses the REGIONAL HOUSEHOLD construct so as to avoid
  accounting for tranascations between domestic institutions. This creates
  some anomalies
    a.  there is no accounting for the internal balance (government 'savings')
    b.  the 'private' household pays no taxes and does not save
    c.  income taxes are paid by the factors using a 'bizarre' allocation
    d.  there is no account for incorporated business enterprises
    e.  factor incomes are not assigned to domestic institutions

  Removing the regional housheold account requires STRONG assumptions; these
  can be made less strong if there is exogenous data. The assumptions made
  in the code below include
    a.  the household account (hhous) includes incorporated business
        enterprises
    b.  ALL factor incomes accrue to the household account
    c.  all factor income taxes are household income taxes, this ignores
        any social security contributions
    d.  ALL tax revenues accrue to the government account
    e.  the trade balance (in goods and services) is the same as the current
        account balance
    f.  government 'savings' are defined as a residual

$offtext

* Income of Private Households (6:5)

 SAMG("hhous",ff,kkn)      = SAMG("rreghous",ff,kkn) + SAMG("ddirtax",ff,kkn) ;

 SAMG("rreghous",ff,kkn)    = 0.0 ;

 SAMG("hhous","rreghous",kkn)  = 0.0 ;

* Income Tax paid by private household

 SAMG("ddirtax","hhous",kkn) = SUM(ff,SAMG("ddirtax",ff,kkn)) ;

 SAMG("ddirtax",ff,kkn)      = 0.0 ;

* Income of Government (13:5)
* Moving components of indirect taxes from REG HOUSE to GOVT

 SAMG("ggovt",ttm,kkn)         = SAMG("rreghous",ttm,kkn) ;

 SAMG("ggovt",ttms,kkn)        = SAMG("rreghous",ttms,kkn) ;

 SAMG("ggovt",tte,kkn)         = SAMG("rreghous",tte,kkn) ;

 SAMG("ggovt",ttsm,kkn)        = SAMG("rreghous",ttsm,kkn) ;
 SAMG("ggovt",ttsd,kkn)        = SAMG("rreghous",ttsd,kkn) ;

 SAMG("ggovt",ttff,kkn)        = SAMG("rreghous",ttff,kkn) ;

 SAMG("ggovt","pprodtax",kkn)  = SUM(aa,SAMG("pprodtax",aa,kkn)) ;

* Government income for direct taxes

 SAMG("ggovt","ddirtax",kkn)   = SUM(ff,SAMG("ddirtax",ff,kkn))
                                  + SAMG("ddirtax","hhous",kkn) ;

* Removing reghous tax accounts

 SAMG("rreghous",ttm,kkn)         = 0.0 ;
 SAMG("rreghous",ttms,kkn)        = 0.0 ;
 SAMG("rreghous",tte,kkn)         = 0.0 ;
 SAMG("rreghous",ttsm,kkn)        = 0.0 ;
 SAMG("rreghous",ttsd,kkn)        = 0.0 ;
 SAMG("rreghous",ttff,kkn)        = 0.0 ;
 SAMG("rreghous","pprodtax",kkn)  = 0.0 ;
 SAMG("rreghous","ddirtax",kkn)   = 0.0 ;

* Removing REGHOUS expenditures

 SAMG("ggovt","rreghous",kkn)     = 0.0 ;
 SAMG("ii_s","rreghous",kkn)      = 0.0 ;



* Domestic Savings (14:5)
* Defining Savings by HOUS as total household income LESS
* Consumption expenditure, inclusive of sales taxes and direct taxes

 SAMG("ii_s","hhous",kkn)     = SUM(ff,SAMG("hhous",ff,kkn))
                                 - {SUM(mmc,SAMG(mmc,"hhous",kkn))
                                      + SUM(ttsm,SAMG(ttsm,"hhous",kkn))
                                   + SUM(ddc,SAMG(ddc,"hhous",kkn))
                                      + SUM(ttsd,SAMG(ttsd,"hhous",kkn))
                                   + SAMG("ddirtax","hhous",kkn) } ;


* Government Savings (?:?)
* Defining Savings by Govt as total investment expenditure LESS
* Depreciation, External balance on margins trade and commodity trade,
* and household savings

 SAMG("ii_s","ggovt",kkn)     =  {SUM(mmc,SAMG(mmc,"ii_s",kkn))
                                      + SUM(ttsm,SAMG(ttsm,"ii_s",kkn))
                                   + SUM(ddc,SAMG(ddc,"ii_s",kkn))
                                      + SUM(ttsd,SAMG(ttsd,"ii_s",kkn)) }

                                 - {SUM(ff,SAMG("ii_s",ff,kkn))
                                    + SUM(vvst,SAMG("ii_s",vvst,kkn))
                                    + SUM(ww,SAMG("ii_s",ww,kkn))
                                    + SAMG("ii_s","hhous",kkn)} ;

*##### CHECK on SAMG #####

* Checking SAM after MAKING

$INCLUDE include\chk_samg.inc

*###### UNLOADING SAMG basic

Execute_Unload 'stats\SAMG_basic.gdx', SAMG ;


Display "END of glbsam_make" ;
