*############## ASSIGNING THE GLOBE SAM #########################

* ## CHECK import duties in transactions SAM v1 are correct

$GDXIN data\basedata.gdx
* Sets and data from GTAP database

$LOAD tar = tartype

$LOADdc VTSS

$GDXIN

Display VTSS ;

Parameter
 VTSS2(tar,ttm,mmc,kk)     Value of Imports in World Prices + Specific & AdValorem tariff revenue

 TM_REVCHK(ttm,mmc,kk)     CHECK on trade tax revenues

 CNT_TM_REVHK1                COUNT on TM_REVCHK diff > 0.000001
 CNT_TM_REVHK2                COUNT on TM_REVCHK diff > 0.00001
 CNT_TM_REVHK3                COUNT on TM_REVCHK diff > 0.0001
 CNT_TM_REVHK4                COUNT on TM_REVCHK diff > 0.001
 CNT_TM_REVHK5                COUNT on TM_REVCHK diff > 0.01

 VTSS2_CHK(ttm,mmc,kk)    CHECK on Tariffs
 VTSS3_CHK(ttm,mmc,kk)    CHECK on Tariffs

  ;

 VTSS2(tar,ttm,mmc,kk)   = SUM((trad_comm,kkp)
                               $(map_mmc_trad(mmc,trad_comm)
                                $map_ttm_kk(ttm,kkp)),
                                 VTSS(tar,trad_comm,kkp,kk)) ;

 TM_REVCHK(ttm,mmc,kk)   = SAMG(ttm,mmc,kk)
                               - SUM(tar,VTSS2(tar,ttm,mmc,kk)) ;

 CNT_TM_REVHK1 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.000001), 1 ) ;
 CNT_TM_REVHK2 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.00001), 1 ) ;
 CNT_TM_REVHK3 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.0001), 1 ) ;
 CNT_TM_REVHK4 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.001), 1 ) ;
 CNT_TM_REVHK5 = SUM((ttm,mmc,kk)$(TM_REVCHK(ttm,mmc,kk) > 0.01), 1 ) ;



 VTSS2_CHK(ttm,mmc,kk) = SUM(tar,VTSS2(tar,ttm,mmc,kk))
                             - SAMG(ttm,mmc,kk) ;

Execute_Unload  'stats\TM_REVCHK.gdx', TM_REVCHK ;

Display VTSS2_CHK ;

* ## Assign SPECIFIC import duties

Parameter

 TTM_BASE(ttm,mmc,kk) Tariff revenue in BASIC SAMG
 TTM_SPE(ttm,mmc,kk)  Specific tariff revenue as residual
 TTM_ADV(ttm,mmc,kk)  Ad valorem tariff revenue as residual ;

* Residual calculation

 TTM_BASE(ttm,mmc,kk) = SAMG(ttm,mmc,kk) ;

 TTM_ADV(ttm,mmc,kk)  = VTSS2("adv",ttm,mmc,kk) ;

 TTM_SPE(ttm,mmc,kk)
*                     = SAMG(ttm,mmc,kk) - VTSS2("adv",ttm,mmc,kk) ;
                     = SAMG(ttm,mmc,kk) - TTM_ADV(ttm,mmc,kk) ;

 VTSS3_CHK(ttm,mmc,kk) = SAMG(ttm,mmc,kk)
                              - TTM_ADV(ttm,mmc,kk)
                              - TTM_SPE(ttm,mmc,kk) ;

* ## Derive ad valorem equivalent import duties

 SAMG(ttm,mmc,kk)  = 0.0 ;

 SAMG(ttms,mmc,kk)
                     = SUM(ttm$map_ttms_ttm(ttms,ttm),
                           TTM_SPE(ttm,mmc,kk)) ;

$ontext
* Direct calculation
 SAMG(tmmsptax,mmc,kk)
                     = SUM(tmmtax$map_ttms_tmm(ttmstax,tmmtax),
                          VTSS2("spe",tmm,mmc,kk)) ;
$offtext

 SAMG(ttm,mmc,kk) = TTM_ADV(ttm,mmc,kk) ;

 SAMG("rreghous",ttm,kk)   = SUM(mmc,SAMG(ttm,mmc,kk)) ;
 SAMG("rreghous",ttms,kk)  = SUM(mmc,SAMG(ttms,mmc,kk)) ;

Parameter
 TTM_CHK(mmc,kk)    CHECK on TTM
 TTM_CHK_cnt        Count of non zero CHECK on TTM

 ;

 TTM_CHK(mmc,kk)  = SUM(ttm,TTM_BASE(ttm,mmc,kk))
                      - SUM(ttm,SAMG(ttm,mmc,kk))
                      - SUM(ttms,SAMG(ttms,mmc,kk)) ;

 TTM_CHK_cnt            = SUM{(mmc,kk)$ABS(TTM_CHK(mmc,kk) gt 0.0000001), 1 } ;
 ABORT$(TTM_CHK_cnt GT 0.0) "ERROR WHEN SPLITTING TRADE TAXES" ;

*##### CHECK on SAMG #####

* Checking SAM before removing Regional Household

$INCLUDE include\chk_samg.inc


*##### Removing the Regional Household Account

$ontext

ASSUMPTIONS
  1. all factor income taxes are household income taxes - this ignores
     any social security contributions
  2. government transfers to households are ZERO
  3. internal balances are derives from estimates from WDI database

$offtext

*## Income of Private Households (6:5)

* Moving factor incomes and income taxes to HOUS from REG HOUSE and DDIRTAX

 SAMG("hhous",ff,kkn)      = SAMG("rreghous",ff,kkn) + SAMG("ddirtax",ff,kkn) ;

 SAMG("rreghous",ff,kkn)    = 0.0 ;

 SAMG("hhous","rreghous",kkn)  = 0.0 ;

* Income Tax paid by private household

 SAMG("ddirtax","hhous",kkn) = SUM(ff,SAMG("ddirtax",ff,kkn)) ;

 SAMG("ddirtax",ff,kkn)      = 0.0 ;

* Income of Government (13:5)
* Moving components of indirect taxes from REG HOUSE to GOVT

 SAMG("ggovt",ttm,kkn)         = SAMG("rreghous",ttm,kkn) ;

 SAMG("ggovt",ttms,kkn)        = SAMG("rreghous",ttms,kkn) ;

 SAMG("ggovt",tte,kkn)         = SAMG("rreghous",tte,kkn) ;

 SAMG("ggovt",ttsm,kkn)        = SAMG("rreghous",ttsm,kkn) ;
 SAMG("ggovt",ttsd,kkn)        = SAMG("rreghous",ttsd,kkn) ;

 SAMG("ggovt",ttff,kkn)        = SAMG("rreghous",ttff,kkn) ;

 SAMG("ggovt","pprodtax",kkn)  = SUM(aa,SAMG("pprodtax",aa,kkn)) ;

* Government income for direct taxes

 SAMG("ggovt","ddirtax",kkn)   = SUM(ff,SAMG("ddirtax",ff,kkn))
                                  + SAMG("ddirtax","hhous",kkn) ;

Parameter
 YG(kk)     Government income ;

 YG(kkn)  = SUM(ttm,SAMG("ggovt",ttm,kkn))
            + SUM(ttms,SAMG("ggovt",ttms,kkn))
            + SUM(tte,SAMG("ggovt",tte,kkn))
            + SUM(ttsm,SAMG("ggovt",ttsm,kkn))
            + SUM(ttsd,SAMG("ggovt",ttsd,kkn))
            + SUM(ttff,SAMG("ggovt",ttff,kkn))
            + SAMG("ggovt","pprodtax",kkn)
            + SAMG("ggovt","ddirtax",kkn) ;

* Removing reghous tax accounts

 SAMG("rreghous",ttm,kkn)         = 0.0 ;
 SAMG("rreghous",ttms,kkn)        = 0.0 ;
 SAMG("rreghous",tte,kkn)         = 0.0 ;
 SAMG("rreghous",ttsm,kkn)        = 0.0 ;
 SAMG("rreghous",ttsd,kkn)        = 0.0 ;
 SAMG("rreghous",ttff,kkn)        = 0.0 ;
 SAMG("rreghous","pprodtax",kkn)  = 0.0 ;
 SAMG("rreghous","ddirtax",kkn)   = 0.0 ;

* Removing REGHOUS expenditures

 SAMG("ggovt","rreghous",kkn)     = 0.0 ;
 SAMG("ii_s","rreghous",kkn)      = 0.0 ;


*IF(glb_int_bal = 1 ,
*### Domestic Savings by household (14:5) and government ??:??)
$ontext
Household
   Defining Savings by HOUS as total household income LESS Consumption
       expenditure, inclusive of sales taxes and direct taxes

Government
    Defining Savings by Govt as total investment expenditure LESS
       Depreciation, External balance on margins trade and commodity trade,
        and household savings

$offtext

$ontext

* Household saving
 SAMG("ii_s","hhous",kkn)     = SUM(ff,SAMG("hhous",ff,kkn))
                                 - {SUM(mmc,SAMG(mmc,"hhous",kkn))
                                      + SUM(ttsm,SAMG(ttsm,"hhous",kkn))
                                   + SUM(ddc,SAMG(ddc,"hhous",kkn))
                                      + SUM(ttsd,SAMG(ttsd,"hhous",kkn))
                                   + SAMG("ddirtax","hhous",kkn) } ;

* Government Savings (?:?)

 SAMG("ii_s","ggovt",kkn)     =  {SUM(mmc,SAMG(mmc,"ii_s",kkn))
                                      + SUM(ttsm,SAMG(ttsm,"ii_s",kkn))
                                   + SUM(ddc,SAMG(ddc,"ii_s",kkn))
                                      + SUM(ttsd,SAMG(ttsd,"ii_s",kkn)) }

                                 - {SUM(ff,SAMG("ii_s",ff,kkn))
                                    + SUM(vvst,SAMG("ii_s",vvst,kkn))
                                    + SUM(ww,SAMG("ii_s",ww,kkn))
                                    + SAMG("ii_s","hhous",kkn)} ;
  ) ;
* End of IF
$offtext

* GDP from expenditure
Parameter
 GDP(kk)           GDP calculated from expenditures
 int_bal_sh(kk)    WDI estimates of internal balance shares
 Govt_sav(kk)      Government Savings
 ;

*IF(glb_int_bal = 2 ,
*### Domestic Savings by household (14:5) and government ??:??)
$ontext

Government
    Defining Savings by Govt as shares of GDP with the share estimates
       taken from WDI data read in from Excel 'Int_Bal_GTP92_11.xlsx'

Household
   Defining Savings by HOUS as total household income LESS Consumption
       expenditure, inclusive of sales taxes and direct taxes



$offtext

 GDP(kkn)  =
* Household consumption
          [SUM(mmc,SAMG(mmc,"hhous",kkn)) + SUM(ddc,SAMG(ddc,"hhous",kkn))]
* plus Government consumption
          + [SUM(mmc,SAMG(mmc,"ggovt",kkn)) + SUM(ddc,SAMG(ddc,"ggovt",kkn))]
* plus Investment consumption
          + [SUM(mmc,SAMG(mmc,"ii_s",kkn)) + SUM(ddc,SAMG(ddc,"ii_s",kkn))]
* plus exports (fob)
          + SUM((ddc,ww),SAMG(ddc,ww,kkn))
* minus imports (cif)
          - [SUM((ww,mmc),SAMG(ww,mmc,kkn))
          - SUM((ootpm,mmc),SAMG(ootpm,mmc,kkn))
          - SUM((wwtpm,mmc),SAMG(wwtpm,mmc,kkn))
          - SUM((aatpm,mmc),SAMG(aatpm,mmc,kkn))]
 ;


* Converting Excel GDP data to GDX
*$CALL "GDXXRW i=data\Int_Bal_GTP_10_14.xlsx o=data\gdp_data_in.gdx INDEX=LAYOUT!A4 trace=3"
*$if errorLevel 1 $abort problems with GDXXRW

*$GDXIN data\gdp_data_in.gdx
$GDXIN data_in.gdx

$LOADdc int_bal_sh = int_bal

$GDXIN

* Government Savings (?:?)

 SAMG("ii_s","ggovt",kkn)     = GDP(kkn) * int_bal_sh(kkn) ;

* Household saving
 SAMG("ii_s","hhous",kkn)     = SUM(ff,SAMG("hhous",ff,kkn))
                                 - {SUM(mmc,SAMG(mmc,"hhous",kkn))
                                      + SUM(ttsm,SAMG(ttsm,"hhous",kkn))
                                   + SUM(ddc,SAMG(ddc,"hhous",kkn))
                                      + SUM(ttsd,SAMG(ttsd,"hhous",kkn))
                                   + SAMG("ddirtax","hhous",kkn) } ;

* Government transfers to Households

 SAMG("hhous","ggovt",kkn)  = YG(kkn)
* minus Govt consumption expenditure
                              - [{SUM(mmc,SAMG(mmc,"ii_s",kkn))
                                      + SUM(ttsm,SAMG(ttsm,"ii_s",kkn))
                                   + SUM(ddc,SAMG(ddc,"ii_s",kkn))
                                      + SUM(ttsd,SAMG(ttsd,"ii_s",kkn)) }
* minus GOVT savings
                              - SAMG("ii_s","ggovt",kkn) ] ;

*  ) ;
* End of IF

 govt_sav(kk)  = SAMG("ii_s","ggovt",kk) ;


*##### CHECK on SAMG #####

* Checking SAM after MAKING

$INCLUDE include\chk_samg.inc

*###### UNLOADING SAMG basic

Execute_Unload 'stats\SAMG_basic.gdx',
                                    SAMG
                                    DIFFTOT
                                    BIGDIFFTOT
                                    LRGDIFFTOT
                                    SUMDIFFTOT
                                    DIFFPER
                                    BIGDIFFPER
                                    DIFTOTPERCNT
 ;


Display "END of glbsam_make" ;
