*############## 4. SALES TAX CALCULATION #################################

Parameters
* Sales Tax rate parameters

 tsm(mmc,ss,kk)     Sales Taxes rates on imported commod by agents
 tsmnonh(mmc,kk)    Sales Taxes rates on imported commod by non hhold demand
 tvm(mmc,kk)        Implied VAT rates on imported commod by households

 tsd(ddc,ss,kk)     Sales Taxes rates on domestic commod by agents
 tsdnonh(ddc,kk)    Sales Taxes rates on domestic commod by non hhold demand
 tvd(ddc,kk)        Implied VAT rates on domestic commod by households

* Sales Tax revenue parameters

 SMTAX(mmc,ss,kk)   Sales Taxes revenues on imported commod by agents
 SDTAX(ddc,ss,kk)   Sales Taxes revenues on domestic commod by agents

* STAX(cc,ss,kk)     Sales Taxes revenues on composite commod by agents

* Sales Tax Report parameters

 tsmrates(kk,mmc,tsmset)  Summary info on sales taxes on imported commod
 tsdrates(kk,ddc,tsdset)  Summary info on sales taxes on domestic commod

* Value Added Tax Report parameters

 tvmrates(kk,mmc,tsmset)  Summary info on VAT taxes on imported commod
 tvdrates(kk,ddc,tsdset)  Summary info on VAT taxes on domestic commod

 tvmratesNEG(kk,mmc,tsmset)  Negative VAT taxes on imported commod
 tvdratesNEG(kk,ddc,tsdset)  Negative VAT taxes on domestic commod

* Count on members of sets

 mmc_CNT            Count on members of mmc
 ddc_CNT            Count on members of ddc
 cc_CNT             Count on members of cc

   ;

 mmc_CNT        = 57 ;
 ddc_CNT        = 57 ;
 cc_CNT         = 57 ;

*### Assigning Sales Tax revenue parameters

* Imports by Activities
 SMTAX(mmc,aa,kkn)      = SUM(ttsm
                          $map_mmc_ttsm(mmc,ttsm),
                          SAMG(ttsm,aa,kkn)) ;

* Imports by Institutions
 SMTAX(mmc,inst,kkn) = SUM(ttsm
                          $map_mmc_ttsm(mmc,ttsm),
                          SAMG(ttsm,inst,kkn)) ;

* Domestic by Activities
 SDTAX(ddc,aa,kkn)      = SUM(ttsd
                          $map_ddc_ttsd(ddc,ttsd),
                          SAMG(ttsd,aa,kkn)) ;

* Domestic by Institutions
 SDTAX(ddc,inst,kkn) = SUM(ttsd
                          $map_ddc_ttsd(ddc,ttsd),
                          SAMG(ttsd,inst,kkn)) ;

* Total Sales taxes by Institutions
* STAX(cc,ss,kkn)     = SUM(mmc$map_cc_mmc(cc,mmc),SMTAX(mmc,ss,kkn))
*                         + SUM(ddc$map_cc_ddc(cc,ddc),SDTAX(ddc,ss,kkn)) ;

*### CALCULATING IMPLIED TAX RATES

* Parameters used in tax rate calculations only

Parameters

 tvmratesNEGCNT    COUNT on negative VAT rates on Imports
 tvdratesNEGCNT    COUNT on negative VAT rates on Domestic

 tvm2(mmc,kk)      Applied VAT rates on imported commod by households
 tvd2(ddc,kk)      Applied VAT rates on domestic commod by households

 tvm2NEGCNT        COUNT on negative tvm2 VAT rates on Imports
 tvd2NEGCNT        COUNT on negative tvd2 VAT rates on Domestic
 ;

*---- GTAP's Implied Sales Tax Rates

* Sales tax rates on imports

 tsm(mmc,aa,kkn)$SAMG(mmc,aa,kkn) = SMTAX(mmc,aa,kkn)/SAMG(mmc,aa,kkn) ;

 tsm(mmc,inst,kkn)$SAMG(mmc,inst,kkn) = SMTAX(mmc,inst,kkn)/SAMG(mmc,inst,kkn) ;

 tsmnonh(mmc,kkn)$(SUM(nonhh,SAMG(mmc,nonhh,kkn)))
                        = SUM(nonhh,SMTAX(mmc,nonhh,kkn))
                            /SUM(nonhh,SAMG(mmc,nonhh,kkn)) ;

 tvm(mmc,kkn)            = tsm(mmc,"hhous",kkn) - tsmnonh(mmc,kkn) ;

* Sales tax rates on domestic commodities

 tsd(ddc,aa,kkn)$SAMG(ddc,aa,kkn) = SDTAX(ddc,aa,kkn)/SAMG(ddc,aa,kkn) ;

 tsd(ddc,inst,kkn)$SAMG(ddc,inst,kkn) = SDTAX(ddc,inst,kkn)/SAMG(ddc,inst,kkn) ;

 tsdnonh(ddc,kkn)$(SUM(nonhh,SAMG(ddc,nonhh,kkn)))
                        = SUM(nonhh,SDTAX(ddc,nonhh,kkn))
                            /SUM(nonhh,SAMG(ddc,nonhh,kkn)) ;

 tvd(ddc,kkn)            = tsd(ddc,"hhous",kkn) - tsdnonh(ddc,kkn) ;

*DISPLAY tsma ;

 tsmrates(kkn,mmc,"mintsma")   = SMIN(aa$tsm(mmc,aa,kkn),tsm(mmc,aa,kkn)) ;
 tsmrates(kkn,mmc,"avtsma")    = SUM(aa,tsm(mmc,aa,kkn))/mmc_CNT ;
 tsmrates(kkn,mmc,"maxtsma")   = SMAX(aa,tsm(mmc,aa,kkn)) ;
 tsmrates(kkn,mmc,"tsmhous")   = tsm(mmc,"hhous",kkn) ;
 tsmrates(kkn,mmc,"tsmgovt")   = tsm(mmc,"ggovt",kkn) ;
 tsmrates(kkn,mmc,"tsmkap")    = tsm(mmc,"ii_s",kkn) ;
 tsmrates(kkn,mmc,"tsmnonhh")  = tsmnonh(mmc,kkn) ;
 tsmrates(kkn,mmc,"tvmhh")     = tvm(mmc,kkn) ;

 tsdrates(kkn,ddc,"mintsda")   = SMIN(aa$tsd(ddc,aa,kkn),tsd(ddc,aa,kkn)) ;
 tsdrates(kkn,ddc,"avtsda")    = SUM(aa,tsd(ddc,aa,kkn))/ddc_CNT ;
 tsdrates(kkn,ddc,"maxtsda")   = SMAX(aa,tsd(ddc,aa,kkn)) ;
 tsdrates(kkn,ddc,"tsdhous")   = tsd(ddc,"hhous",kkn) ;
 tsdrates(kkn,ddc,"tsdgovt")   = tsd(ddc,"ggovt",kkn) ;
 tsdrates(kkn,ddc,"tsdkap")    = tsd(ddc,"ii_s",kkn) ;
 tsdrates(kkn,ddc,"tsdnonhh")  = tsdnonh(ddc,kkn) ;
 tsdrates(kkn,ddc,"tvdhh")     = tvd(ddc,kkn) ;

*---- Adjusting Implied VAT rates

* Implied VAT rates

 tvmrates(kkn,mmc,"tvmhh")     = tvm(mmc,kkn) ;
 tvdrates(kkn,ddc,"tvdhh")     = tvd(ddc,kkn) ;

* Identifiying negative VAT rates

 tvmratesNEG(kkn,mmc,"tvmhh")$(tvm(mmc,kkn) LT 0.0)   = tvm(mmc,kkn) ;
 tvdratesNEG(kkn,ddc,"tvdhh")$(tvd(ddc,kkn) LT 0.0)   = tvd(ddc,kkn) ;


 tvmratesNEGCNT = SUM((kk,mmc)$tvmratesNEG(kk,mmc,"tvmhh"),1) ;
 tvdratesNEGCNT = SUM((kk,ddc)$tvdratesNEG(kk,ddc,"tvdhh"),1) ;

Display
  tvmratesNEGCNT, tvdratesNEGCNT
 ;

* Defining APPLIED VAT rates as positive IMPLIED VAT rates

 tvm2(mmc,kkn)     = tvm(mmc,kkn) - tvmratesNEG(kkn,mmc,"tvmhh") ;
 tvd2(ddc,kkn)     = tvd(ddc,kkn) - tvdratesNEG(kkn,ddc,"tvdhh") ;

 tvm2NEGCNT = SUM((kkn,mmc)$(tvm2(mmc,kkn) LT 0.0),1) ;
 tvd2NEGCNT = SUM((kkn,ddc)$(tvd2(ddc,kkn) LT 0.0),1) ;

Display
  tvm2NEGCNT, tvd2NEGCNT
 ;

Execute_unload 'stats\gtp_saltax_rates.gdx',
* Sales Tax rate parameters
 tsm, tsmnonh, tvm, tsd, tsdnonh, tvd,
* Sales Tax revenue parameters
 SMTAX, SDTAX,
* STAX
* Sales Tax Report parameters
 tsmrates, tsdrates,
* Value Added Tax Report parameters
 tvmrates, tvdrates, tvmratesNEG, tvdratesNEG

  ;


Display "END of glbsam_saltax" ;
