*################ TRUNCATING AND REBALANCING THE SAM ###################

Parameter

 trunc_fact             Truncation factor

 SAMG_base(ss,ss,kk)    SAMG after truncation
 DIFF_SAMG(ss,ss,kk)    Difference between SAMG after truncation and eliminations

 ;

*#### Truncating the FULL GLOBE SAMG

 trunc_fact = 10**dec_num ;

Display trunc_fact ;

 SAMG(ss,ssp,kk)  = trunc(SAMG(ss,ssp,kk)*trunc_fact) ;

 SAMG(ss,ssp,kk)  = SAMG(ss,ssp,kk)/trunc_fact ;

 SAMG_base(ss,ssp,kk)   = SAMG(ss,ssp,kk) ;

*##### CHECK on SAMG #####

* Checking SAM after TRUNCATING

$INCLUDE include\chk_samg.inc

 rowtot(ssn,kk)     = SUM[ssnp,SAMG(ssn,ssnp,kk)] ;
 coltot(ssnp,kk)     = SUM[ssn,SAMG(ssn,ssnp,kk)] ;

 DIFFTOT(ssn,kk)   = rowtot(ssn,kk) - coltot(ssn,kk) ;

 BIGDIFFTOT(ssnp,kk)${ABS(DIFFTOT(ssnp,kk) GT 1.00)} = DIFFTOT(ssnp,kk) ;

 LRGDIFFTOT(ssnp,kk)${ABS(DIFFTOT(ssnp,kk) GT 0.01)} = DIFFTOT(ssnp,kk) ;

Display DIFFTOT, BIGDIFFTOT, LRGDIFFTOT ;

*#### Eliminating activities with 'undesirable' characteristics

Set
 act_out(aa,kk)    Set of activities with undesirable characteristics

 ;

Parameters
 act_tot(aa,kk)       Report of gross output by activities
 sm_act_tot(aa,kk)    Report of small gross output by activities

 lab_act(aa,kk)       Total value of labour used by activities
 sm_lab_act(aa,kk)    Small Total value of labour used by activities

 cap_act(aa,kk)       Total value of capital used by activities
 sm_cap_act(aa,kk)    Small Total value of capital used by activities

 sm_fact              Small scaling factor

 ;

 sm_fact = 0.50 ;

*## Activity GROSS OUTPUTS
 act_tot(aa,kk)  = SAMG("ttotal",aa,kk) ;
* sm_act_tot(aa,kk)$(act_tot(aa,kk) LT [(10**{-(dec_num - 1)})]) = act_tot(aa,kk) ;
 sm_act_tot(aa,kk)$(act_tot(aa,kk) LT [(10**{-(dec_num - sm_fact)})]) = 1 ;

* Activity use of LABOUR
 lab_act(aa,kk)   = SUM(ll,SAMG(ll,aa,kk)) ;
* sm_lab_act(aa,kk)$(lab_act(aa,kk) LT [(10**{-(dec_num - 1)})]) = lab_act(aa,kk) ;
 sm_lab_act(aa,kk)$(lab_act(aa,kk) LT [(10**{-(dec_num - sm_fact)})]) = 1 ;

* Activity use of CAPITAL
 cap_act(aa,kk)   = SAMG("ffkap",aa,kk) ;
* sm_cap_act(aa,kk)$(cap_act(aa,kk) LT [(10**{-(dec_num - 1)})]) = cap_act(aa,kk) ;
 sm_cap_act(aa,kk)$(cap_act(aa,kk) LT [(10**{-(dec_num - sm_fact)})]) = 1 ;

*## Assigning Set for elimination of activities

 act_out(aa,kkn)$[sm_act_tot(aa,kkn)
                    OR sm_lab_act(aa,kkn)
                    OR sm_cap_act(aa,kkn)] = YES ;

* act_out(aa,kkn)$[sm_act_tot(aa,kkn)
*                    OR (lab_act(aa,kkn) EQ 0.0)
*                    OR (cap_act(aa,kkn) EQ 0.0)] = YES ;

*## Deleting activities with undesirable characteristics

 SAMG(ss,aa,kkn)$act_out(aa,kkn)  = 0.0 ;
 SAMG(aa,ss,kkn)$act_out(aa,kkn)  = 0.0 ;

 rowtot(ssn,kk)     = SUM[ssnp,SAMG(ssn,ssnp,kk)] ;
 coltot(ssnp,kk)     = SUM[ssn,SAMG(ssn,ssnp,kk)] ;

 DIFFTOT(ssn,kk)   = rowtot(ssn,kk) - coltot(ssn,kk) ;

 BIGDIFFTOT(ssnp,kk)${ABS(DIFFTOT(ssnp,kk) GT 1.00)} = DIFFTOT(ssnp,kk) ;

 LRGDIFFTOT(ssnp,kk)${ABS(DIFFTOT(ssnp,kk) GT 0.01)} = DIFFTOT(ssnp,kk) ;

Display DIFFTOT, BIGDIFFTOT, LRGDIFFTOT ;

*#### Eliminating taxes where there are no counterpart transactions

PARAMETERS

* Sales Tax rate parameters

 tsm2(mmc,ss,kk)     Sales Taxes rates on imported commod by agents
 SMTAX(mmc,ss,kk)    Sales Taxes revenues on imported commod by agents
 tsm_cnt             Check that number of transactions equals number of rates

 tsd2(ddc,ss,kk)     Sales Taxes rates on domestic commod by agents
 SDTAX(ddc,ss,kk)    Sales Taxes revenues on domestic commod by agents
 tsd_cnt             Check that number of transactions equals number of rates

* Import duty rate parameters

 ttm_adv2(ww,ss,kk)  Ad valorem import duty rates
 MTAX_adv(ww,ss,kk)  Ad valorem import duty revenues
 ttm_adv_cnt         Check that number of transactions equals number of rates

 ttm_spe2(ww,ss,kk)  Specific import duty rates
 MTAX_spe(ww,ss,kk)  Specific import duty revenues
 ttm_spe_cnt         Check that number of transactions equals number of rates

*##### Margins on imports

*~~~ Other Transport Margins

 mm_otpm2(ww,ss,kk)   Ad valorem import other transport margins
 MARG_otpm(ww,ss,kk)  Ad valorem import other transport margins expendituress
 mm_otpm2_cnt         Check that number of transactions equals number of rates

*~~~ Air Transport Margins

 mm_atpm2(ww,ss,kk)   Ad valorem import air transport margins
 MARG_atpm(ww,ss,kk)  Ad valorem import air transport margins expendituress
 mm_atpm2_cnt         Check that number of transactions equals number of rates

*~~~ Water Transport Margins

 mm_wtpm2(ww,ss,kk)   Ad valorem import water transport margins
 MARG_wtpm(ww,ss,kk)  Ad valorem import water transport margins expendituress
 mm_wtpm2_cnt         Check that number of transactions equals number of rates

* Export tax rate parameters

 tte2(ww,ss,kk)      Emport tax rates
 ETAX(ww,ss,kk)      Emport tax revenues
 tte_cnt             Check that number of transactions equals number of rates

* Factor use taxes

 tff2(ff,ss,kk)      Factor use tax rates
 FTAX(ff,ss,kk)      Factor use tax revenues
 tff_cnt             Check that number of transactions equals number of rates

* Production taxes
 tx2(ss,kk)         Production tax rates
 XTAX(ss,kk)        Production tx revenues
 tx_cnt             Check that number of transactions equals number of rates

* Direct taxes
 ty2(kk)            Direct tax rates
 YTAX(kk)           Direct ty revenues
 ty_cnt             Check that number of transactions equals number of rates

 ;


*##### Sales taxes on Imports (mmc)

 SAMG(ttsm,ss,kk)${[SAMG(ttsm,ss,kk)] ne 0.0
                        and SUM[mmc$map_ttsm_mmc(ttsm,mmc),
                            SAMG(mmc,ss,kk)] eq 0.0}
                       = 0.0 ;

 tsm2(mmc,ss,kk)$[SAMG(mmc,ss,kk)]
              = SUM{ttsm$map_mmc_ttsm(mmc,ttsm),SAMG(ttsm,ss,kk)}
                          /SAMG(mmc,ss,kk) ;

 SMTAX(mmc,ss,kk) = SUM(ttsm$map_mmc_ttsm(mmc,ttsm),SAMG(ttsm,ss,kk)) ;

 tsm_cnt            = SUM{(mmc,ss,kk)$[SMTAX(mmc,ss,kk) ne 0.0
                                     and tsm2(mmc,ss,kk) eq 0.0], 1 } ;

 ABORT$(tsm_cnt GT 0.0) "ERROR IMPORTS SALES TAX CALCULATION or ELIMINATION" ;

* Recompute sales tax expenditures

 SAMG("ggovt",ttsm,kk) = SUM(mmc,SAMG(ttsm,mmc,kk)) ;

*##### Sales taxes on Domestic (ddc)

 SAMG(ttsd,ss,kk)${[SAMG(ttsd,ss,kk)] ne 0.0
                        and SUM[ddc$map_ttsd_ddc(ttsd,ddc),
                            SAMG(ddc,ss,kk)] eq 0.0}
                       = 0.0 ;


 tsd2(ddc,ss,kk)$[SAMG(ddc,ss,kk)]
              = SUM{ttsd$map_ddc_ttsd(ddc,ttsd),SAMG(ttsd,ss,kk)}
                          /SAMG(ddc,ss,kk) ;

 SDTAX(ddc,ss,kk) = SUM(ttsd$map_ddc_ttsd(ddc,ttsd),SAMG(ttsd,ss,kk)) ;

 tsd_cnt            = SUM{(ddc,ss,kk)$[SDTAX(ddc,ss,kk) ne 0.0
                                     and tsd2(ddc,ss,kk) eq 0.0], 1 } ;

 ABORT$(tsd_cnt GT 0.0) "ERROR DOMESTIC SALES TAX CALCULATION or ELIMINATION" ;

* Recompute sales tax expenditures

 SAMG("ggovt",ttsd,kk) = SUM(ddc,SAMG(ttsd,ddc,kk)) ;

*##### Import duties

 SAMG(ttm,ss,kk)${[SAMG(ttm,ss,kk)] ne 0.0
                        and SUM[ww$map_ttm_ww(ttm,ww),
                            SAMG(ww,ss,kk)] eq 0.0}
                       = 0.0 ;

 ttm_adv2(ww,ss,kk)$[SAMG(ww,ss,kk)]
              = SUM{ttm$map_ww_ttm(ww,ttm),SAMG(ttm,ss,kk)}
                          /SAMG(ww,ss,kk) ;

 MTAX_adv(ww,ss,kk) = SUM{ttm$map_ww_ttm(ww,ttm),SAMG(ttm,ss,kk)} ;

 ttm_adv_cnt        = SUM{(ww,ss,kk)$[MTAX_adv(ww,ss,kk) ne 0.0
                                     and ttm_adv2(ww,ss,kk) eq 0.0], 1 } ;

 ABORT$(ttm_adv_cnt GT 0.0) "ERROR ADV DUTIES TAX CALCULATION or ELIMINATION" ;



 SAMG(ttms,ss,kk)${[SAMG(ttms,ss,kk)] ne 0.0
                        and SUM[ww$map_ttms_ww(ttms,ww),
                            SAMG(ww,ss,kk)] eq 0.0}
                       = 0.0 ;

 ttm_spe2(ww,ss,kk)$[SAMG(ww,ss,kk)]
              = SUM{ttms$map_ww_ttms(ww,ttms),SAMG(ttms,ss,kk)}
                          /SAMG(ww,ss,kk) ;

 MTAX_spe(ww,ss,kk) = SUM{ttms$map_ww_ttms(ww,ttms),SAMG(ttms,ss,kk)} ;

 ttm_spe_cnt        = SUM{(ww,ss,kk)$[MTAX_spe(ww,ss,kk) ne 0.0
                                     and ttm_spe2(ww,ss,kk) eq 0.0], 1 } ;

 ABORT$(ttm_spe_cnt GT 0.0) "ERROR SPE DUTIES TAX CALCULATION or ELIMINATION" ;


* Recompute ADV import duty expenditures

 SAMG("ggovt",ttm,kk) = SUM(mmc,SAMG(ttm,mmc,kk)) ;

* Recompute ADV import duty expenditures

 SAMG("ggovt",ttms,kk) = SUM(mmc,SAMG(ttms,mmc,kk)) ;

 rowtot(ssn,kk)     = SUM[ssnp,SAMG(ssn,ssnp,kk)] ;
 coltot(ssnp,kk)     = SUM[ssn,SAMG(ssn,ssnp,kk)] ;

 DIFFTOT(ssn,kk)   = rowtot(ssn,kk) - coltot(ssn,kk) ;

* SAMG("ttotal",ssnp,kk) = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
* SAMG(ssn,"ttotal",kk)  = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

* DIFFTOT(ssnp,kk)   = SAMG("ttotal",ssnp,kk) - SAMG(ssnp,"ttotal",kk) ;

Display DIFFTOT ;


*##### Margins on imports

*~~~ Other Transport Margins

 SAMG(ootpm,ss,kk)${[SAMG(ootpm,ss,kk)] ne 0.0
                        and SUM[ww$map_ootpm_ww(ootpm,ww),
                            SAMG(ww,ss,kk)] eq 0.0}
                       = 0.0 ;

 mm_otpm2(ww,ss,kk)$[SAMG(ww,ss,kk)]
              = SUM{ootpm$map_ww_ootpm(ww,ootpm),SAMG(ootpm,ss,kk)}
                          /SAMG(ww,ss,kk) ;

 MARG_otpm(ww,ss,kk) = SUM{ootpm$map_ww_ootpm(ww,ootpm),SAMG(ootpm,ss,kk)} ;

 mm_otpm2_cnt       = SUM{(ww,ss,kk)$[MARG_otpm(ww,ss,kk) ne 0.0
                                     and mm_otpm2(ww,ss,kk) eq 0.0], 1 } ;

 ABORT$(mm_otpm2_cnt GT 0.0) "ERROR OTPM MARGINS CALCULATION or ELIMINATION" ;

 rowtot(ssn,kk)     = SUM[ssnp,SAMG(ssn,ssnp,kk)] ;
 coltot(ssnp,kk)     = SUM[ssn,SAMG(ssn,ssnp,kk)] ;

 DIFFTOT(ssn,kk)   = rowtot(ssn,kk) - coltot(ssn,kk) ;

* SAMG("ttotal",ssnp,kk) = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
* SAMG(ssn,"ttotal",kk)  = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

* DIFFTOT(ssnp,kk)   = SAMG("ttotal",ssnp,kk) - SAMG(ssnp,"ttotal",kk) ;

Display DIFFTOT ;

*~~~ Air Transport Margins

 SAMG(aatpm,ss,kk)${[SAMG(aatpm,ss,kk)] ne 0.0
                        and SUM[ww$map_aatpm_ww(aatpm,ww),
                            SAMG(ww,ss,kk)] eq 0.0}
                       = 0.0 ;

 mm_atpm2(ww,ss,kk)$[SAMG(ww,ss,kk)]
              = SUM{aatpm$map_ww_aatpm(ww,aatpm),SAMG(aatpm,ss,kk)}
                          /SAMG(ww,ss,kk) ;

 MARG_atpm(ww,ss,kk) = SUM{aatpm$map_ww_aatpm(ww,aatpm),SAMG(aatpm,ss,kk)} ;

 mm_atpm2_cnt       = SUM{(ww,ss,kk)$[MARG_atpm(ww,ss,kk) ne 0.0
                                     and mm_atpm2(ww,ss,kk) eq 0.0], 1 } ;

 ABORT$(mm_atpm2_cnt GT 0.0) "ERROR ATPM MARGINS CALCULATION or ELIMINATION" ;

*~~~ Water Transport Margins

 SAMG(wwtpm,ss,kk)${[SAMG(wwtpm,ss,kk)] ne 0.0
                        and SUM[ww$map_wwtpm_ww(wwtpm,ww),
                            SAMG(ww,ss,kk)] eq 0.0}
                       = 0.0 ;

 mm_wtpm2(ww,ss,kk)$[SAMG(ww,ss,kk)]
              = SUM{wwtpm$map_ww_wwtpm(ww,wwtpm),SAMG(wwtpm,ss,kk)}
                          /SAMG(ww,ss,kk) ;

 MARG_wtpm(ww,ss,kk) = SUM{wwtpm$map_ww_wwtpm(ww,wwtpm),SAMG(wwtpm,ss,kk)} ;

 mm_wtpm2_cnt       = SUM{(ww,ss,kk)$[MARG_wtpm(ww,ss,kk) ne 0.0
                                     and mm_wtpm2(ww,ss,kk) eq 0.0], 1 } ;

 ABORT$(mm_wtpm2_cnt GT 0.0) "ERROR WTPM MARGINS CALCULATION or ELIMINATION" ;

*##### Export tax rate parameters

 SAMG(tte,ss,kk)${[SAMG(tte,ss,kk)] ne 0.0
                        and SUM[ww$map_tte_ww(tte,ww),
                            SAMG(ss,ww,kk)] eq 0.0}
                       = 0.0 ;

 tte2(ww,ss,kk)$[SAMG(ss,ww,kk)]
              = SUM{tte$map_ww_tte(ww,tte),SAMG(tte,ss,kk)}
                          /SAMG(ss,ww,kk) ;

 ETAX(ww,ss,kk) = SUM{tte$map_ww_tte(ww,tte),SAMG(tte,ss,kk)} ;

 tte_cnt        = SUM{(ww,ss,kk)$[ETAX(ww,ss,kk) ne 0.0
                                     and tte2(ww,ss,kk) eq 0.0], 1 } ;

 ABORT$(tte_cnt GT 0.0) "ERROR EXPORT TAX CALCULATION or ELIMINATION" ;

* Recompute sales tax expenditures

 SAMG("ggovt",tte,kk) = SUM(ddc,SAMG(tte,ddc,kk)) ;

*##### Factor use taxes

 SAMG(ttff,aa,kk)${[SAMG(ttff,aa,kk)] ne 0.0
                        and SUM[ff$map_ttf_ff(ttff,ff),
                            SAMG(ff,aa,kk)] eq 0.0}
                       = 0.0 ;

 tff2(ff,aa,kk)$[SAMG(ff,aa,kk)]
              = SUM{ttff$map_ff_ttf(ff,ttff),SAMG(ttff,aa,kk)}
                          /SAMG(ff,aa,kk) ;

 FTAX(ff,aa,kk) = SUM{ttff$map_ff_ttf(ff,ttff),SAMG(ttff,aa,kk)} ;

 tff_cnt       = SUM{(ff,aa,kk)$[FTAX(ff,aa,kk) ne 0.0
                                     and tff2(ff,aa,kk) eq 0.0], 1 } ;

 ABORT$(tff_cnt GT 0.0) "ERROR FACTOR USE TAX CALCULATION or ELIMINATION" ;

* Recompute factor use tax expenditures

 SAMG("ggovt",ttff,kk) = SUM(aa,SAMG(ttff,aa,kk)) ;

 rowtot(ssn,kk)     = SUM[ssnp,SAMG(ssn,ssnp,kk)] ;
 coltot(ssnp,kk)     = SUM[ssn,SAMG(ssn,ssnp,kk)] ;

 DIFFTOT(ssn,kk)   = rowtot(ssn,kk) - coltot(ssn,kk) ;

* SAMG("ttotal",ssnp,kk) = SUM(ssn,SAMG(ssn,ssnp,kk)) ;
* SAMG(ssn,"ttotal",kk)  = SUM(ssnp,SAMG(ssn,ssnp,kk)) ;

* DIFFTOT(ssnp,kk)   = SAMG("ttotal",ssnp,kk) - SAMG(ssnp,"ttotal",kk) ;

Display DIFFTOT ;

*##### Production taxes

 SAMG("pprodtax",aa,kk)${[SAMG("pprodtax",aa,kk) ne 0.0
                             and SAMG("ttotal",aa,kk)] eq 0.0}
                             = 0.0 ;

 SAMG("pprodtax","ii_s",kk)${[SAMG("pprodtax","ii_s",kk) ne 0.0
                             and SAMG("ttotal","ii_s",kk)] eq 0.0}
                             = 0.0 ;

 tx2(aa,kk)$SAMG("ttotal",aa,kk)
                = SAMG("pprodtax",aa,kk)/SAMG("ttotal",aa,kk) ;

 tx2("ii_s",kk)$SAMG("ttotal","ii_s",kk)
                = SAMG("pprodtax","ii_s",kk)/SAMG("ttotal","ii_s",kk) ;

 XTAX(aa,kk)    = SAMG("pprodtax",aa,kk) ;

 XTAX("ii_s",kk)    = SAMG("pprodtax","ii_s",kk) ;

 tx_cnt         = SUM{(ss,kk)$[XTAX(ss,kk) ne 0.0
                                     and tx2(ss,kk) eq 0.0], 1 } ;

 ABORT$(tx_cnt GT 0.0) "ERROR PRODUCTION TAX CALCULATION or ELIMINATION " ;

* Recompute production tax expenditures

 SAMG("ggovt","pprodtax",kk) = SUM(aa,SAMG("pprodtax",aa,kk))
                                     + SAMG("pprodtax","ii_s",kk) ;

*##### Direct taxes

 SAMG("ddirtax","hhous",kk)${[SAMG("ddirtax","hhous",kk) ne 0.0
                             and SAMG("ddirtax","hhous",kk)] eq 0.0}
                             = 0.0 ;

 ty2(kk)$SAMG("ttotal","hhous",kk)
                = SAMG("ddirtax","hhous",kk)/SAMG("ttotal","hhous",kk) ;

 YTAX(kk)    = SAMG("ddirtax","hhous",kk) ;

 ty_cnt         = SUM{(kk)$[YTAX(kk) ne 0.0
                                     and ty2(kk) eq 0.0], 1 } ;

 ABORT$(ty_cnt GT 0.0) "ERROR DIRECT TAX CALCULATION or ELIMINATION " ;


*##### CHECK on SAMG #####

* Checking SAM after Truncation and eliminating taxes with no counterpart transactions


$INCLUDE include\chk_samg.inc

 DIFF_SAMG(ss,ssp,kk) =  SAMG_base(ss,ssp,kk) - SAMG(ss,ssp,kk) ;

*####### Generating Macro SAMs ######

Parameter
 ASAM_trunc(ac,ac,kk)   Macro SAM from SAMG_base
 ASAM_trunc_chk(ac,kk)  Macro SAM from SAMG_base row and column check
 ;


 ASAM_trunc("mcom","acts",kk)   = SUM[(mmc,aa),SAMG(mmc,aa,kk)] ;
 ASAM_trunc("mcom","pvth",kk)   = SUM[mmc,SAMG(mmc,"hhous",kk)] ;
 ASAM_trunc("mcom","gvt ",kk)   = SUM[mmc,SAMG(mmc,"ggovt",kk)] ;
 ASAM_trunc("mcom","invt",kk)   = SUM[(mmc,ii),SAMG(mmc,ii,kk)] ;

 ASAM_trunc("dcom","acts",kk)   = SUM[(ddc,aa),SAMG(ddc,aa,kk)] ;
 ASAM_trunc("dcom","pvth",kk)   = SUM[ddc,SAMG(ddc,"hhous",kk)] ;
 ASAM_trunc("dcom","gvt ",kk)   = SUM[ddc,SAMG(ddc,"ggovt",kk)] ;
 ASAM_trunc("dcom","invt",kk)   = SUM[(ddc,ii),SAMG(ddc,ii,kk)] ;

 ASAM_trunc("dcom","marg",kk)   = SUM[(ddc,vvst),SAMG(ddc,vvst,kk)] ;
 ASAM_trunc("dcom","row",kk)    = SUM[(ddc,ww),SAMG(ddc,ww,kk)] ;

 ASAM_trunc("acts","dcom",kk)   = SUM[(aa,ddc),SAMG(aa,ddc,kk)] ;

 ASAM_trunc("fact","acts",kk)   = SUM[(ff,aa),SAMG(ff,aa,kk)] ;

 ASAM_trunc("mstax","acts",kk)  = SUM[(ttsm,aa),SAMG(ttsm,aa,kk)] ;
 ASAM_trunc("dstax","acts",kk)  = SUM[(ttsd,aa),SAMG(ttsd,aa,kk)] ;

 ASAM_trunc("mstax","pvth",kk)  = SUM[ttsm,SAMG(ttsm,"hhous",kk)] ;
 ASAM_trunc("dstax","pvth",kk)  = SUM[ttsd,SAMG(ttsd,"hhous",kk)] ;

 ASAM_trunc("mstax","gvt",kk)   = SUM[ttsm,SAMG(ttsm,"ggovt",kk)] ;
 ASAM_trunc("dstax","gvt",kk)   = SUM[ttsd,SAMG(ttsd,"ggovt",kk)] ;

 ASAM_trunc("mstax","invt",kk)  = SUM[(ttsm,ii),SAMG(ttsm,ii,kk)] ;
 ASAM_trunc("dstax","invt",kk)  = SUM[(ttsd,ii),SAMG(ttsd,ii,kk)] ;


 ASAM_trunc("mmtax","mcom",kk)  = SUM[(ttm,mmc),SAMG(ttm,mmc,kk)] ;
 ASAM_trunc("mmstax","mcom",kk) = SUM[(ttms,mmc),SAMG(ttms,mmc,kk)] ;
 ASAM_trunc("extax","dcom",kk)  = SUM[(tte,ddc),SAMG(tte,ddc,kk)] ;

 ASAM_trunc("fatax","acts",kk)  = SUM[(ttff,aa),SAMG(ttff,aa,kk)] ;

 ASAM_trunc("ptax","acts",kk)   = SUM[aa,SAMG("pprodtax",aa,kk)] ;
 ASAM_trunc("ptax","invt",kk)   = SUM[ii,SAMG("pprodtax",ii,kk)] ;

 ASAM_trunc("pvth","fact",kk)   = SUM[ff,SAMG("hhous",ff,kk)] ;

 ASAM_trunc("pvth","gvt",kk)    = SAMG("hhous","ggovt",kk) ;

 ASAM_trunc("dtax","pvth",kk)   = SAMG("ddirtax","hhous",kk) ;

 ASAM_trunc("gvt","mmtax",kk)   = SUM[ttm,SAMG("ggovt",ttm,kk)] ;
 ASAM_trunc("gvt","mmstax",kk)  = SUM[ttms,SAMG("ggovt",ttms,kk)] ;
 ASAM_trunc("gvt","extax",kk)   = SUM[tte,SAMG("ggovt",tte,kk)] ;

 ASAM_trunc("gvt","mstax",kk)   = SUM[ttsm,SAMG("ggovt",ttsm,kk)] ;
 ASAM_trunc("gvt","dstax",kk)   = SUM[ttsd,SAMG("ggovt",ttsd,kk)] ;

 ASAM_trunc("gvt","fatax",kk)   = SUM[ttff,SAMG("ggovt",ttff,kk)] ;

 ASAM_trunc("gvt","ptax",kk)    = SAMG("ggovt","pprodtax",kk) ;
 ASAM_trunc("gvt","dtax",kk)    = SAMG("ggovt","ddirtax",kk) ;


 ASAM_trunc("invt","fact",kk)   = SUM[(ii,ff),SAMG(ii,ff,kk)] ;

 ASAM_trunc("invt","pvth",kk)   = SUM[ii,SAMG(ii,"hhous",kk)] ;
 ASAM_trunc("invt","gvt",kk)    = SUM[ii,SAMG(ii,"ggovt",kk)] ;

 ASAM_trunc("invt","row",kk)    = SUM[(ii,ww),SAMG(ii,ww,kk)] ;

 ASAM_trunc("invt","marg",kk)   = SUM[(ii,vvst),SAMG(ii,vvst,kk)] ;

 ASAM_trunc("marg","mcom",kk)   = SUM[(ootpm,mmc),SAMG(ootpm,mmc,kk)]
                                 + SUM[(wwtpm,mmc),SAMG(wwtpm,mmc,kk)]
                                 + SUM[(aatpm,mmc),SAMG(aatpm,mmc,kk)] ;


 ASAM_trunc("row","mcom",kk)    = SUM[(ww,mmc),SAMG(ww,mmc,kk)] ;

 ASAM_trunc("tott",acnp,kk)     = SUM(acn,ASAM_trunc(acn,acnp,kk)) ;
 ASAM_trunc(acn,"tott",kk)      = SUM(acnp,ASAM_trunc(acn,acnp,kk)) ;

 ASAM_trunc_chk(acn,kk)         =  ASAM_trunc("tott",acn,kk)
                                 -  ASAM_trunc(acn,"tott",kk)   ;

* Count of Non Zero Elements

 SAMG_nonZ(ss,ssp,kkn)${ABS[SAMG(ss,ssp,kkn) GT (1.0*(10** (- dec_num)))]}  = 1.0 ;

 SAMG_cnt(kkn)      = SUM[(ss,ssp),SAMG_nonZ(ss,ssp,kkn)] ;

*###### UNLOADING SAMG basic

Execute_Unload 'stats\SAMG_trunc.gdx',
                                    SAMG
                                    DIFFTOT
                                    BIGDIFFTOT
                                    LRGDIFFTOT
                                    SUMDIFFTOT
                                    DIFFPER
                                    BIGDIFFPER
                                    DIFTOTPERCNT

                                    DIFF_SAMG

                                    ASAM_trunc
                                    ASAM_trunc_chk
                                    SAMG_nonZ
                                    SAMG_cnt


 ;


Display "END of glbsam_trunc" ;
