*###### ADDITIONAL DATA FROM GTAP


*############## 6. LOADING SETS ##########################################

$GDXIN data\basedata.gdx
* Sets from GTAP database

$LOAD dir

$GDXIN


*#### SATELLITE TAX DATA

$ontext
*##### FOR INFORMATION ONLY
* Parameters from HAR file
* Protection based
 FBEP(endw_comm,prod_comm,kk)     Protection Factor-Based Subsidies
 ISEP(trad_comm,prod_comm,kk,dir) Protection Intermediate Input Subsidies
 MFRV(trad_comm,kk,kk)            Protection MFA Export Subsidy Equivalent
 OSEP(trad_comm,kk)               Protection Ordinary Output Subsidies
 TFRV(trad_comm,kk,kk)            Protection Ordinary Import Duty
 XTRV(trad_comm,kk,kk)            Protection Ordinary Export Subsidy
 FTRV(endw_comm,prod_comm,kk)     Taxes - Factor Employment Tax Revenue

 PAYD(dec,pys,trad_comm,kk)       Domestic support payments of different types bases in millions of USD
 VTSS(tar,trad_comm,kk,kk)        Value of Imports in World Prices + Specific & AdValorem tariff revenue

* Parameters of no interest
 DPSM(kk)                         Sum Distn Parameters in Hhold Demand System

* Empty HAR files
 ADRV(trad_comm,kk,kk)            Protection Anti-Dumping Duty
 PURV(trad_comm,kk,kk)            Protn Price Undertaking Export Subsidy Equiv
 VRRV(trad_comm,kk,kk)            Protection VER Export Subsidy Equivalent
$offtext

Parameter

* Factor based
 FacSubs(ff,aa,kk)      Factor-Based Subsidies by activity and region
 FacEmpTax(ff,aa,kk)    Factor Employment Tax Revenue

* Activity based
 OutSubs(ddc,kk)         Ordinary Output Subsidies

* Intermediate Input based
 IntInSubsM(mmc,aa,kk)  Imported intermediate input subsidies
 IntInSubsD(ddc,aa,kk)  Domestic intermediate input subsidies

* Export based
 MFASubs(ddc,ww,kk)     MFA Export Subsidy Equivalents
 OrdXSub(ddc,ww,kk)     Ordinary Export subsidies

* Import based
 OrdMDuty(ww,mmc,kk)    Ordinary Import duties

   ;


$GDXIN data\basedata.gdx

$LOAD FBEP FTRV OSEP ISEP MFRV XTRV TFRV

$GDXIN


*##### Assigning satellite tax data

* Factor based

 FacSubs(ff,aa,kk)    = SUM(prod_comm$map_aa_prod(aa,prod_comm),
                         FBEP(ff,prod_comm,kk)) ;

* Adjusting FacSubs for GTAPAGG requirement that factor capital labelled "CAPITAL"
 FacSubs("ffkap",aa,kk)   = FacSubs("Capital",aa,kk) ;
 FacSubs("Capital",aa,kk) = 0.0 ;


 FacEmpTax(ff,aa,kk)  = SUM(prod_comm$map_aa_prod(aa,prod_comm),
                         FTRV(ff,prod_comm,kk)) ;

* Adjusting FacEmpTax for GTAPAGG requirement that factor capital labelled "CAPITAL"
 FacEmpTax("ffkap",aa,kk)   = FacEmpTax("Capital",aa,kk) ;
 FacEmpTax("Capital",aa,kk) = 0.0 ;

* Activity based

 OutSubs(ddc,kk)       = SUM(trad_comm
                         $map_ddc_trad(ddc,trad_comm),
                         OSEP(trad_comm,kk)) ;

* Intermediate Input based

 IntInSubsM(mmc,aa,kk) = SUM((trad_comm,prod_comm)
                         $(map_mmc_trad(mmc,trad_comm)
                         $map_aa_prod(aa,prod_comm)),
                         ISEP(trad_comm,prod_comm,kk,"imported")) ;

 IntInSubsD(ddc,aa,kk) = SUM((trad_comm,prod_comm)
                         $(map_ddc_trad(ddc,trad_comm)
                         $map_aa_prod(aa,prod_comm)),
                         ISEP(trad_comm,prod_comm,kk,"domestic")) ;

* Export based

 MFASubs(ddc,ww,kk)   = SUM((trad_comm,kkp)
                         $(map_ddc_trad(ddc,trad_comm)
                         $map_ww_kk(ww,kkp)),
                         MFRV(trad_comm,kk,kkp)) ;

 OrdXSub(ddc,ww,kk)   = SUM((trad_comm,kkp)
                         $(map_ddc_trad(ddc,trad_comm)
                         $map_ww_kk(ww,kkp)),
                         XTRV(trad_comm,kk,kkp)) ;

* Import based

 OrdMDuty(ww,mmc,kk)  = SUM((trad_comm,kkp)
                         $(map_mmc_trad(mmc,trad_comm)
                         $map_ww_kk(ww,kkp)),
                         TFRV(trad_comm,kk,kkp)) ;

*#### DOMESTIC SALES

Parameter
 TVOM(trad_comm,kk)       sales of domestic product at market prices
 TVOM2(ddc,kk)            sales of domestic product at market prices

 ;

$GDXIN data\basedata.gdx

$LOAD TVOM

$GDXIN

* Assigning domestic sales data

 TVOM2(ddc,kk) = SUM(TRAD_COMM
                  $map_ddc_trad(ddc,trad_comm),
                   TVOM(trad_comm,kk)) ;

*#### POPULATION DATA

$GDXIN data\basedata.gdx

$LOAD POP

$GDXIN


*#### CAPITAL STOCK DATA

Parameter

 Kstoc(kk)             Value of capital stock at beginning of period

   ;

$GDXIN data\basedata.gdx

$LOAD VKB

$GDXIN

* Assigning capital stock data

 Kstoc(kk)     = VKB(kk) ;


*#### GTAP ELASTICITIES DATA

* HAR file parameters

Parameter

* GTAP Data

 ESBV(prod_comm)     CES between primary factors in production
 ESBD(trad_comm)     Armington CES for domestic_imported allocation
 ESBM(trad_comm)     Armington CES for regional allocation of imports
 SUBP(trad_comm,kk)  CDE substitution parameter
 INCP(trad_comm,kk)  CDE expansion parameter
 ESBT(prod_comm)     Elasticity of intermediate input substitution
 ETRE(endw_comm)     CET between sectors for sluggish primary factors

* Satellite account data

 ESUBVA(ss)          CES between primary factors in production
 ESUBD(ss)           Armington CES for domestic_imported allocation
 ESUBM(ss)           Armington CES for regional allocation of imports
 SUBCDE(ddc,kk)      CDE substitution parameter
 INCCDE(ddc,kk)      CDE expansion parameter
 ESUBT(aa)           Elasticity of intermediate input substitution
 ETRAE(ff)           CET between sectors for sluggish primary factors

 RFLX(kk)            Expected rate of return flexibility parameter

   ;

Parameter
 elast_exist     if gtap elasticity data exist equals 1 ;

$IF exist data\default.har   elast_exist = 1

$IF NOT exist data\default.har elast_exist = 0

ABORT$(elast_exist = 0) "default.prm needs to be renamed as default.har" ;

Display elast_exist ;

$IF exist data\default.har $CALL har2gdx   data\default.har    data\elastdata.gdx

$IF exist data\elastdata.gdx   $GDXIN data\elastdata.gdx

$IF exist data\elastdata.gdx   $LOAD ESBV = ESUBVA
$IF exist data\elastdata.gdx   $LOAD ESBD = ESUBD
$IF exist data\elastdata.gdx   $LOAD ESBM = ESUBM

$IF exist data\elastdata.gdx   $LOAD SUBP = SUBPAR
$IF exist data\elastdata.gdx   $LOAD INCP = INCPAR
$IF exist data\elastdata.gdx   $LOAD ESBT = ESUBT
$IF exist data\elastdata.gdx   $LOAD ETRE = ETRAE
$IF exist data\elastdata.gdx   $LOAD RFLX = RORFLEX

$IF exist data\elastdata.gdx   $GDXIN

IF(elast_exist = 1,

* Assigning elasticities

 ESUBVA(aa)     = SUM(prod_comm
                      $map_aa_prod(aa,prod_comm),
                      ESBV(prod_comm)) ;

 ESUBD(mmc)     = SUM(trad_comm
                      $map_mmc_trad(mmc,trad_comm),
                      ESBD(trad_comm)) ;

 ESUBM(mmc)     = SUM(trad_comm
                      $map_mmc_trad(mmc,trad_comm),
                      ESBM(trad_comm)) ;

 SUBCDE(ddc,kk) = SUM(trad_comm
                      $map_ddc_trad(ddc,trad_comm),
                      SUBP(trad_comm,kk)) ;

 INCCDE(ddc,kk) = SUM(trad_comm
                      $map_ddc_trad(ddc,trad_comm),
                      INCP(trad_comm,kk)) ;

 ESUBT(aa)      = SUM(prod_comm
                      $map_aa_prod(aa,prod_comm),
                      ESBT(prod_comm)) ;

 ETRAE(ff)      = ETRE(ff) ;

* END of IF
  ) ;


*#### GTAP ENERGY DATA


Parameter
 gsd_exist     if gtap energy data exist equals 1 ;

$IF exist data\gsdvole.har   gsd_exist = 1

Display gsd_exist ;

$IF exist data\gsdvole.har $CALL har2gdx   data\gsdvole.har    data\gsdvole.gdx


Parameter

* GTAP Data
 EDF(trad_comm,prod_comm,kk)    usage of domestic product by firms Mtoe
 EDG(trad_comm,kk)              government consumption of domestic product Mtoe
 EDP(trad_comm,kk)              private consumption of domestic product Mtoe

 EIF(trad_comm,prod_comm,kk)    usage of imports by firms Mtoe
 EIG(trad_comm,kk)              government consumption of imports Mtoe
 EIP(trad_comm,kk)              private consumption of imports Mtoe

 EXI(trad_comm,kk,kk)           volume of trade Mtoe

* SAM Satelitte Data

 EVolD(ddc,ss,kk)          volume of input domestic purchases by agents (Mtoe)
 EVolM(mmc,ss,kk)          volume of input import purchases by agents (Mtoe)
 EVol(cc,ss,kk)            volume of input AGGREGATE purchases by agents (Mtoe)

 EVolT(mmc,kk,kk)          volume of bilateral trade (Mtoe)

   ;



$IF exist data\gsdvole.gdx   $GDXIN data\gsdvole.gdx

$IF exist data\gsdvole.gdx   $LOAD EDF = EDF
$IF exist data\gsdvole.gdx   $LOAD EDG = EDG
$IF exist data\gsdvole.gdx   $LOAD EDP = EDP

$IF exist data\gsdvole.gdx   $LOAD EIF = EIF
$IF exist data\gsdvole.gdx   $LOAD EIG = EIG
$IF exist data\gsdvole.gdx   $LOAD EIP = EIP

$IF exist data\gsdvole.gdx   $LOAD EXI = EXIDAG

$IF exist data\gsdvole.gdx   $GDXIN


Display EDF ;

IF(gsd_exist = 1,

* Domestic purchases

 EVolD(ddc,aa,kk)   = SUM((trad_comm,prod_comm)
                          $(map_ddc_trad(ddc,trad_comm)
                          $map_aa_prod(aa,prod_comm)),
                          EDF(trad_comm,prod_comm,kk)) ;

 EVolD(ddc,"hhous",kk)   = SUM(trad_comm$map_ddc_trad(ddc,trad_comm),
                                 EDP(trad_comm,kk)) ;
 EVolD(ddc,"ggovt",kk)   = SUM(trad_comm$map_ddc_trad(ddc,trad_comm),
                                 EDG(trad_comm,kk)) ;
 EVolD(ddc,"ii_s",kk)    = SUM(trad_comm$map_ddc_trad(ddc,trad_comm),
                                 EDF(trad_comm,"cgds",kk)) ;

*Import purchases

 EVolM(mmc,aa,kk)   = SUM((trad_comm,prod_comm)
                          $(map_mmc_trad(mmc,trad_comm)
                          $map_aa_prod(aa,prod_comm)),
                          EIF(trad_comm,prod_comm,kk)) ;

 EVolM(mmc,"hhous",kk)   = SUM(trad_comm$map_mmc_trad(mmc,trad_comm),
                                 EIP(trad_comm,kk)) ;
 EVolM(mmc,"ggovt",kk)   = SUM(trad_comm$map_mmc_trad(mmc,trad_comm),
                                 EIG(trad_comm,kk)) ;
 EVolM(mmc,"ii_s",kk)    = SUM(trad_comm$map_mmc_trad(mmc,trad_comm),
                                 EIF(trad_comm,"cgds",kk)) ;

* Trade Volumes
 EVolT(mmc,kk,kkp)   = SUM(trad_comm$map_mmc_trad(mmc,trad_comm),
                                EXI(trad_comm,kk,kkp)) ;


* END of IF
  ) ;


*#### GTAP EMISSIONS DATA

Set
 fuel_comm(*)     energy commodities for emissions data ;

Parameter
 co2_exist     if gtap emission data exist equals 1 ;

$IF exist data\co2.har   co2_exist = 1

Display co2_exist ;

Parameter

* GTAP Data

 MDF(trad_comm,prod_comm,kk)    emissions from domestic product in current production Mt CO2
 MDG(trad_comm,kk)       emissions from govt consumption of domestic product Mt CO2
 MDH(trad_comm,kk)       emissions from private consumption of domestic product Mt CO2

 MIF(trad_comm,prod_comm,kk)    emissions from imports in current production Mt CO2
 MIG(trad_comm,kk)       emissions from government consumption of imports Mt CO2
 MIH(trad_comm,kk)       emissions from private consumption of imports Mt CO2

* SAM Satelitte Data

 Em_D_C02(ddc,ss,kk)     CO2 emissions from domestic product in current production (MT CO2)
 Em_M_C02(mmc,ss,kk)     CO2 emissions from import productin current production (MT CO2)
 Em_C02(cc,ss,kk)        CO2 emissions from aggregate productin current production (MT CO2)

  ;


$IF exist data\co2.har $CALL har2gdx   data\co2.har    data\co2.gdx

$IF exist data\co2.gdx   $GDXIN data\co2.gdx

$IF exist data\co2.gdx   $LOAD  fuel_comm

$IF exist data\co2.gdx   $LOAD  MDF = MDF
$IF exist data\co2.gdx   $LOAD  MDG = MDG
$IF exist data\co2.gdx   $LOAD  MDH = MDP
$IF exist data\co2.gdx   $LOAD  MIF = MIF
$IF exist data\co2.gdx   $LOAD  MIG = MIG
$IF exist data\co2.gdx   $LOAD  MIH = MIP

$IF exist data\co2.gdx   $GDXIN

IF(co2_exist = 1,

* Domestic purchases

 Em_D_C02(ddc,aa,kk)   = SUM((trad_comm,prod_comm)
                          $(map_ddc_trad(ddc,trad_comm)
                          $map_aa_prod(aa,prod_comm)),
                          MDF(trad_comm,prod_comm,kk)) ;

 Em_D_C02(ddc,"hhous",kk)   = SUM(trad_comm$map_ddc_trad(ddc,trad_comm),
                                 MDH(trad_comm,kk)) ;
 Em_D_C02(ddc,"ggovt",kk)   = SUM(trad_comm$map_ddc_trad(ddc,trad_comm),
                                 MDG(trad_comm,kk)) ;
 Em_D_C02(ddc,"ii_s",kk)    = SUM(trad_comm$map_ddc_trad(ddc,trad_comm),
                                 MDF(trad_comm,"cgds",kk)) ;

*Import purchases

 Em_M_C02(mmc,aa,kk)   = SUM((trad_comm,prod_comm)
                          $(map_mmc_trad(mmc,trad_comm)
                          $map_aa_prod(aa,prod_comm)),
                          MIF(trad_comm,prod_comm,kk)) ;

 Em_M_C02(mmc,"hhous",kk)   = SUM(trad_comm$map_mmc_trad(mmc,trad_comm),
                                 MIH(trad_comm,kk)) ;
 Em_M_C02(mmc,"ggovt",kk)   = SUM(trad_comm$map_mmc_trad(mmc,trad_comm),
                                 MIG(trad_comm,kk)) ;
 Em_M_C02(mmc,"ii_s",kk)    = SUM(trad_comm$map_mmc_trad(mmc,trad_comm),
                                 MIF(trad_comm,"cgds",kk)) ;

* END of IF
  ) ;


*#### GTAP TIME SERIES TRADE DATA
$ontext

Parameter
 tstexist     if gtap energy data exist equals 1 ;

$IF exist data\tstrade.har   tstexist = 1

Display tstexist ;

* HAR file parameters
Parameter

 VTTS(TRAD_COMM,kk,kk,tt)    Trade flows between regions
 TSTRAD(ddc,kk,ww,tt)        Trade flows between regions   ;

$IF exist data\tstrade.har $CALL har2gdx   data\tstrade.har    data\tstrade.gdx

$IF exist data\tstrade.gdx   $GDXIN tstrade.gdx

$IF exist data\tstrade.gdx   $LOAD VTTS = NTSTRD

$IF exist data\tstrade.gdx   $GDXIN

IF(tstexist = 1,

 TSTRAD(ddc,kk,ww,tt)  = SUM((TRAD_COMM,kkp)
                             $(map_ddc_TRAD_COMM(ddc,TRAD_COMM)
                             $MAPTRAD(ww,kkp)),
                             VTTS(TRAD_COMM,kk,kkp,tt)) ;

DISPLAY tt ;
*DISPLAY VTTS ;
*DISPLAY TSTRAD ;

* END of IF
  ) ;
$offtext

$ontext

*#### FACTOR QUANTITY DATA


$ontext
 This section initialises the FACTOR QUANTITY data

 The default defines PHYSICAL QUANTITIES (Q_FD) equal to VALUE QUANTITIES

 IF LABOUR QUANTITY DATA FROM IMPACTECON EXIST
  THE VALUE QUANTITIES FOR LABOUR ARE UPDATED

$offtext

* HAR file sets

Set
 educ(*)      education categories  /
 basic
 sec
 tert
 /

 lab_comm(*)  labour categories   /
 tech_aspros
 clerks
 service_shop
 off_mgr_pros
 ag_othlowsk
 /

 map_ff_lab_comm(ff,lab_comm)  /
 ffltech.tech_aspros
 fflclerk.clerks
 fflserv.service_shop
 fflofic.off_mgr_pros
 fflagr.ag_othlowsk

 /

 ll(ff)  labour factors  /
 ffltech
 fflclerk
 fflserv
 fflofic
 fflagr
 /

 ;

* HAR file parameters

Parameter

* ImpactEcon LABOUR DATA

 QLAB1(lab_comm,prod_comm,kk)    Labour quantities
 QSUP1(educ,lab_comm,kk)         Labour quantities by education levels

* Satellite account data

 Q_FD(ff,aa,kk)       Quantities of factors demanded by activities and regions
 Q_FS(educ,ff,kk)     Quantities of factors supplied by education levels

   ;

* Default setting - VALUE QUANTITIES

 Q_FD(ff,aa,kk)  = SAMG(ff,aa,kk) ;

 Q_FS(educ,ff,kk) = 1.0 ;

* updating labour quantity data with IMPACTEcon labour data

Parameter
 lab_exist     if labour quantity data exist equals 1 ;

*$IF exist data\labor.har   lab_exist = 1.0


*Display lab_exist ;

$IF exist data\labor.har $CALL har2gdx   data\labor.har    data\labour.gdx

$IF exist data\labour.gdx   $GDXIN data\labour.gdx

$IF exist data\labour.gdx   $LOAD QLAB1
$IF exist data\labour.gdx   $LOAD QSUP1

$IF exist data\labour.gdx   $GDXIN

$IF exist data\labour.gdx   lab_exist = 1.0

Display lab_exist ;

IF(lab_exist = 1.0,

 Q_FD(ll,aa,kk)   = SUM((lab_comm,prod_comm)
                         ${map_ff_lab_comm(ll,lab_comm)
                         $map_aa_prod(aa,prod_comm)},
                            QLAB1(lab_comm,prod_comm,kk)) ;

 Q_FS(educ,ll,kk) = SUM{lab_comm$map_ff_lab_comm(ll,lab_comm),
                       QSUP1(educ,lab_comm,kk)} ;

* END of IF
  ) ;

Display "END of gtp_basedata" ;
