* DECLARING AND ASSIGNING SETS

SETS

* Use of global set (ss) and then subsets (mmc,ddc,aa,ff,ttm,tte, etc)

 ss                        SAM accounts

 cc(ss)                    Aggregate commodities
 mmc(ss)                   Imported Commodities
 ddc(ss)                   Domestic Commodities

 cc_e(cc)                  Aggregate energy commodities
 mmc_e(mmc)                Imported energy Commodities
 ddc_e(ddc)                Domestic energy Commodities

 aa(ss)                    Activities
 a2                        Production commodities Activities

 ff(ss)                    Factors

 ttm(ss)                   Import duties and Ad valorem equivalent Import duties
 ttms(ss)                  Specific Import duties
 tte(ss)                   Export taxes
 tts(ss)                   Sales Taxes on aggregate goods and services
 tts_e(tts)                Sales Taxes on aggregate ENERGY goods and services
 ttsd(ss)                  Sales Taxes on imported goods and services
 ttsd_e(ttsd)              Sales Taxes on imported ENERGY goods and services
 ttsm(ss)                  Sales Taxes on domestic goods and services
 ttsm_e(ttsm)              Sales Taxes on domestic ENERGY goods and services
 ttff(ss)                  Taxes on Factors

 ootpm(ss)                 Other trade and transport costs
 wwtpm(ss)                 Water trade and transport costs
 aatpm(ss)                 Air trade and transport costs
 vvst(ss)                  Exports of trade and transport services

 ii(ss)                    Investment

 ww(ss)                    Rest of the World

 kk                        Regions
 rr                        Regions



* These sets come from the basic GTAP database

 GlobalSet(*)              Set provided by GDX2HAR to order symbol table
 trad_comm(*)              traded commodities
 reg(*)                    regions in the model
* endw_comm(*)              endowment commodities
 prod_comm(*)              produced commodities
 dir(*)                    direction of trade flows
 marg_comm(*)              margin commodities
 cgds_comm                 capital goods
 decoupling(*)             PSE components
 tartype(*)                Tariff type
 allpayt(*)                Agricultural support payments

 samac(*)                  GTAP set for SAM labels


 trmm(samac)               Import of margins
 trxm(samac)               Export of margins


 reg(*)                    GTAP regions

* Other Sets

 tar           Tariff types
* pys           Agricultural support payment types
* dec           PSE components

 inst(ss)     Domestic final demand institutions - hhold govt kap
 nonhh(ss)    Activities government and investment saving demand

* Sets defined by reference to assigned sets

 ssn(ss)       SAM accounts excluding TOTAL

 kkn(kk)       Regions excluding GLOBE
 wwn(ww)       Regions excluding GLOBE

 cc_en(cc)               Aggregate NON energy commodities
 mmc_en(mmc)             Imported NON energy Commodities
 ddc_en(ddc)             Domestic NON energy Commodities

 tts_en(ss)              Sales Taxes on aggregate NON ENERGY goods and services
 ttsd_en(ttsd)           Sales Taxes on imported NON ENERGY goods and services
 ttsm_en(ttsm)           Sales Taxes on domestic NON ENERGY goods and services

 tt            Time periods  / Y1965*Y2015 /

* Sets for checking and reporting on SAMG

 step    steps for counts of big total and percentage differences   /
 st_gt5        > 5 total OR percentage difference according to case
 st_gt1        > 1 total OR percentage difference according to case
 st_gt05       > 0.5 total OR percentage difference according to case
 st_gt01       > 0.1 total OR percentage difference according to case
 st_gt001      > 0.01 total OR percentage difference according to case
 st_gt0001     > 0.001 total OR percentage difference according to case
 st_gt00001    > 0.0001 total OR percentage difference according to case
 st_gt000001   > 0.00001 total OR percentage difference according to case
 st_gt0000001  > 0.000001 total OR percentage difference according to case
  /

 case   number of cases in each step  /
 diff_tot       Differences in Account totals
 diff_per       Differences in Account percentages
 diff_tot_per   Differences in Account totals AND percentages
  /

 tsmset        Set for reporting sales taxes and VAT on imports /
 mintsma        min sales tax rate by activities
 avtsma         average sales tax rate by activities
 maxtsma        max sales tax rate by activities
 tsmhous        sales tax rate on private household
 tsmgovt        sales tax rate on government
 tsmkap         sales tax rate on capital
 tsmnonhh       sales tax rate on non household demand
 tvmhh          Implied VAT rates on imported commod by households
  /

 tsdset        Set for reporting sales taxes and VAT on domestic /
 mintsda        min sales tax rate by activities
 avtsda         average sales tax rate by activities
 maxtsda        max sales tax rate by activities
 tsdhous        sales tax rate on private household
 tsdgovt        sales tax rate on government
 tsdkap         sales tax rate on capital
 tsdnonhh       sales tax rate on non household demand
 tvdhh          Implied VAT rates on domestic commod by households
  /

  ;

*############## 6. LOADING SETS ##########################################

* These SETS are read in from an Excel file
$ontext
 1. ss
      The ORDERING of the set ss is important since it aids readability AND
      allows the definition of mapping sets using the '#**:#**' shorthand.
      This a GAMS issue that does not seem to arise with GEMPACK
 2.   mmc, ddc, tms, ii, ootpm etc
      These sets are not available from the GTAP sets.har of GTAPsam.har files
 3.   Future possible changes in GTAP set labels may allow greater use to be
      made of the sets in the GTAP database


$offtext

* The sets from Excel must be read in BEFORE those from the GTAP databases
* This ensures set are CORRECTLY ORDERED

$GDXIN data_in.gdx

$LOADdc kk

$LOADdc ss

$LOADdc cc mmc ddc cc_e mmc_e ddc_e
$LOADdc aa a2
$LOADdc ff
$LOADdc ttm ttms tte ttff tts tts_e ttsd ttsd_e ttsm ttsm_e
$LOADdc ootpm, wwtpm, aatpm, vvst,
$LOADdc rr ww
$LOADdc ii

$LOADdc trad_comm prod_comm

$GDXIN

$GDXIN data\GTAPsam.gdx

$LOADdc samac
$LOADdc marg_comm cgds_comm

$GDXIN


* Setting up ALIASES

 ALIAS(ss,ssp), (ssn,ssnp), (samac,samacp),
      (cc,ccp), (mmc,mmcp), (ddc,ddcp), (mmc_e,mmc_ep), (ddc_e,ddc_ep),
      (aa,aap), (a2,aa2),
      (ff,ffp,endw_comm),
      (ttm,ttmp), (ttms,ttmsp), (tte,ttep),
      (tts,ttsp),(tts_e,tts_ep),
      (ttsd,ttsdp), (ttsm,ttsmp), (ttsd_e,ttsd_ep), (ttsm_e,ttsm_ep),
      (ttff,ttffp),
      (nonhh,nonhhp), (inst, instp),
      (ootpm,ootpmp), (wwtpm,wwtpmp), (aatpm,aatpmp), (vvst,vvstp),
      (ww,wwp), (kk,kkp,regp), (rr,rrp,rrpp)
 ;


* Declaring and assigning mapping sets

* These mapping sets use data from Excel and therefore are 'CORRECTLY'
* ordered, hence they can be assigned in GAMS

Sets

 map_mmc_ddc(mmc,ddc)         Region mapping to mmc from ddc  /
 #mmc:#ddc
 /

 map_ddc_mmc(ddc,mmc)         Region mapping to mmc from ddc  /
 #ddc:#mmc
 /

 map_cc_ddc(cc,ddc)           Region mapping to cc from ddc  /
 #cc:#ddc
 /

 map_cc_mmc(cc,mmc)           Region mapping to cc from ddc  /
 #cc:#mmc
 /

 map_rr_ww(rr,ww)             Region mapping to rr from ww  /
 #rr:#ww
 /

 map_ww_rr(ww,rr)             Region mapping to ww from rr  /
 #ww:#rr
 /

 map_kk_ww(kk,ww)             Region mapping to kk from ww  /
 #kk:#ww
 /

 map_ww_kk(ww,kk)             Region mapping to ww from kk  /
 #ww:#kk
 /

 map_rr_kk(rr,kk)             Region mapping to rr from kk  /
 #rr:#kk
 /

 map_ttms_ttm(ttms,ttm)       Mapping to ttms to ttm  /
 #ttms:#ttm
 /

 map_ttm_ttms(ttm,ttms)       Mapping to ttm to ttms  /
 #ttm:#ttms
 /

* Sales tax mappings

 map_mmc_ttsm(mmc,ttsm)  Mapping from ttsm to mmc Import Sales tax mapping /
 #mmc:#ttsm
 /

 map_ttsm_mmc(ttsm,mmc)  Mapping from mmc to ttsm Import Sales tax mapping /
 #ttsm:#mmc
 /

 map_tts_ttsd(tts,ttsd)     Mapping from ttsd to tts Aggregate Sales tax /
 #tts:#ttsd
 /

 map_tts_ttsm(tts,ttsm)     Mapping from ttsm to tts Aggregate Sales tax /
 #tts:#ttsm
 /

 map_ddc_ttsd(ddc,ttsd)     Mapping from ttsd to ddc Domestic Sales tax /
 #ddc:#ttsd
 /

 map_ttsd_ddc(ttsd,ddc)     Mapping from ddc to ttsd Domestic Sales tax /
 #ttsd:#ddc
 /

* Import duty mappings

 map_ttm_ww(ttm,ww)       Mapping from ww to ttm ADV import duties /
 #ttm:#ww
 /

 map_ww_ttm(ww,ttm)       Mapping from ttm to ADV import duties /
 #ww:#ttm
 /

 map_ttms_ww(ttms,ww)     Mapping from ww to ttms SPE import duties /
 #ttms:#ww
 /

 map_ww_ttms(ww,ttms)     Mapping from ttms to ww SPE import duties /
 #ww:#ttms
 /

* Import Margin mappings

 map_ootpm_ww(ootpm,ww)   Mapping from ww to ootpm Other transport margins /
 #ootpm:#ww
 /

 map_ww_ootpm(ww,ootpm)   Mapping from ootpm to ww Other transport margins /
 #ww:#ootpm
 /

 map_aatpm_ww(aatpm,ww)   Mapping from ww to aatpm Air transport margins /
 #aatpm:#ww
 /

 map_ww_aatpm(ww,aatpm)   Mapping from aatpm to ww Air transport margins /
 #ww:#aatpm
 /

 map_wwtpm_ww(wwtpm,ww)   Mapping from ww to wwtpm Water transport margins /
 #wwtpm:#ww
 /

 map_ww_wwtpm(ww,wwtpm)   Mapping from wwtpm to ww Water transport margins /
 #ww:#wwtpm
 /

* Export tax mappings
 map_tte_ww(tte,ww)       Mapping from ww to tte ADV export taxes /
 #tte:#ww
 /

 map_ww_tte(ww,tte)       Mapping from tte to ADV export taxes /
 #ww:#tte
 /

* Factor use tax mappings
 map_ttf_ff(ttff,ff)      Mapping from ff to ttff factor use taxes /
 #ttff:#ff
 /

 map_ff_ttf(ff,ttff)      Mapping from ttff to ff factor use taxes /
 #ff:#ttff
 /

 ;

* These mapping sets need to read in from Excel because of ordering issues
* created by GTAP using the same labels for regions and sectors

Sets
* Mapping sets

 map_aa_trad(aa,trad_comm)     Mapping to aa from prod_comm
 map_aa_prod(aa,prod_comm)     Mapping to aa from prod_comm
 map_a2_prod(a2,prod_comm)     Mapping to a2 from prod_comm

 map_ddc_trad(ddc,trad_comm)   Mapping to ddc from trad_comm

 map_mmc_trad(mmc,trad_comm)   Mapping to mmc from trad_comm

 map_ttm_kk(ttm,kk)            Mapping to ttm from kk

 map_ss_samac(ss,samac)        Mapping to ss from samac

 ;

$GDXIN data_in.gdx

$LOAD map_aa_trad map_aa_prod map_a2_prod

$LOADdc map_ddc_trad map_mmc_trad

$LOADdc map_ttm_kk

$LOAD map_ss_samac

$GDXIN

 ;

* Other Sets

* SAM Accounts excluding totals
 ssn(ss)        = YES ;
 ssn("ttotal")  = NO ;

* Regions excluding glo
 kkn(kk)        = YES ;
 kkn("glo")     = NO ;

 wwn(ww)        = YES ;
 wwn("wwglo")   = NO ;

* NON energy commodities
 cc_en(cc)      = NOT cc_e(cc) ;

 mmc_en(mmc)    = NOT mmc_e(mmc) ;
 ddc_en(ddc)    = NOT ddc_e(ddc) ;

 tts_en(tts)    = NOT tts_e(tts) ;
 ttsd_en(ttsd)  = NOT ttsd_e(ttsd) ;
 ttsm_en(ttsm)  = NOT ttsm_e(ttsm) ;

* Other sets

 inst("hhous")  = YES ;
 inst("ggovt")  = YES ;
 inst("ii_s")   = YES ;

 nonhh("ggovt") = YES ;
 nonhh("ii_s")  = YES ;


Display "END of gtpsam_sets"

*##### END OF DECLARING AND ASSIGNING SETS FOR THIS PROGRAMME #######
